#!/bin/bash
#Next line helps to preserve blank spaces in file formatting
IFS=""
file='long_sweeps_list'
outfile='sweeps_file_sizes'
i=0
ifore=0
iaft=0
foretotalbytes=0
afttotalbytes=0
totalbytes=0
ttend=$(date -u +%s)
tend=$(($ttend))
#tend=$((tend-1920151))
tstart=$((tend-600))
while read line; do
    itest=$((i-4*(i/4)))
    if [ $itest == 0 ]; then
#	echo "using file"
	length=$(echo "$line" | cut -c 26-33)
	year2=$(echo "$line" | cut -c 74-75)
	year="20"$year2
	month=$(echo "$line" | cut -c 76-77)
	day=$(echo "$line" | cut -c 78-79)
	hour=$(echo "$line" | cut -c 80-81)
	min=$(echo "$line" | cut -c 82-83)
	sec=$(echo "$line" | cut -c 84-85)
	datecheck=$(echo $year"-"$month"-$day"  "$hour":"$min":"$sec")
#	echo $datecheck
	idate=$(date -d $datecheck +%s)
	iidate=$((idate))
	nbytes=$(($length))
	foreaft=$(echo "$line" | cut -c 71-73)
	sweepmin=$(echo "$line" | cut -c 80-83)
	totalbytes=$((totalbytes+nbytes))
	if [ $((iidate)) -ge $((tstart)) ] && [ $((iidate)) -le $((tend)) ];then
#	    echo "i got here" $iidate $sweepmin
	    iiforeaft=0
	    if [ $foreaft == "nrm" ]; then
		iiforeaft=1
	    elif [ $foreaft == "2TM" ]; then
		iiforeaft=1
	    elif [ $foreaft == "3TM" ]; then
		iiforeaft=1
	    fi
#    if [ $foreaft == "nrm" ] || [ $foreaft == "2TM" ] || [ $foreaft == "3TM" ] ] ;then
	    if [ $iiforeaft == 1 ]; then
		foretotalbytes=$((foretotalbytes+nbytes))
		ifore=$((ifore+1))
	    else
		afttotalbytes=$((afttotalbytes+nbytes))
		iaft=$((iaft+1))
	    fi
	fi
    fi
    i=$((i+1))
#    echo $totalbytes" "$i
#    averagebytes=$((totalbytes/i))
#    echo $averagebytes
#    echo "fore "$ifore" "$foretotalbytes
#    echo "aft "$iaft" "$afttotalbytes
done<$file
#    echo $ifore" "$foretotalbytes" "$iaft" "$afttotalbytes
    if [ $ifore == 0 ];then
	echo "THERE NO FORE FILES IN THE LAST 10 MINUTES"
	fore=$(echo "THERE NO FORE FILES IN THE LAST 10 MINUTES")
    else
	foreaveragebytes=$((foretotalbytes/ifore))
	fore=$(echo "AVERAGE FORE SWEEP BYTES FOR LAST 10 MINUTES = "$foreaveragebytes)
	echo "AVERAGE FORE SWEEP BYTES FOR LAST 10 MINUTES = "$foreaveragebytes
    fi
    if [ $iaft == 0 ];then
	echo "THERE NO AFT FILES IN THE LAST 10 MINUTES"
	aft=$(echo "THERE NO AFT FILES IN THE LAST 10 MINUTES")
    else
	aftaveragebytes=$((afttotalbytes/iaft))
	aft=$(echo "AVERAGE AFT SWEEP BYTES FOR LAST 10 MINUTES = "$aftaveragebytes)
	echo "AVERAGE AFT SWEEP BYTES FOR LAST 10 MINUTES = "$aftaveragebytes
    fi
/home/sysop/repos/HRDradar/scripts/hrd-sendto-chat-sweeps.sh $fore
/home/sysop/repos/HRDradar/scripts/hrd-sendto-chat-sweeps.sh $aft
exit

