      PROGRAM LEASTWIND
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM(40)*80,OFILNAM*80
      CHARACTER TESTFILE*80,KEYWORDOUT*4
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      REAL TSTARTARRAY(40),TENDARRAY(40)
      REAL SXB,SYB,SZB,XZB,YZB,ZZB,ROTB
      CHARACTER KEYWORDB*4,FLNAM*80
      CHARACTER COMYES*1,WINDFILE*80
      CHARACTER SUMFILENAME(2)*80,OSUMFILENAME(80)*80
      INTEGER KT(100000),ITOP(100000)
      INTEGER IMAXB,JMAXB,KMAXB
      INTEGER IVTSUB(80)
      DOUBLE PRECISION DOTMIN
      REAL XSHIFT(80),YSHIFT(80),DBZFACT(80)
      REAL RHMAX,RZMAX,EHMAX,EZMAX
      REAL XACC,YACC,ZACC
      CHARACTER*2 CHARINPUT
      CHARACTER CFACTORDIVDBZ*10
c
c The next three commented lines have parameters set for a 48 Meg 
c maximum program.  If you wish to increase this you must have the 
c memory available.  If you do decide to increase the available points
c from 24,000, my first suggestion is that you
c multiply each of the parameters (N1,N2,NARRAY,NWORK,NPOINTS)
C by the same factor.  N1 will tell you how many grid points you are
c allowed in your analysis domain.  You can fiddle
c a little if you want to see if you can decrease NARRAY or NWORK a
c a little relative to the others, but you won't be able to do it much.
c I wish you success....John Gamache
c
c      PARAMETER(N1=24000,N2=48000)
c      PARAMETER(NARRAY=2350000,NWORK=550000)
c      PARAMETER (NPOINTS=72100)
c thor      PARAMETER(N1=341000,N2=682000)
c thor      PARAMETER(NARRAY=45000000,NWORK=17000000)
c thor      PARAMETER (NPOINTS=1026000)
c workstation      PARAMETER(N1=80000,N2=160000)
c workstation      PARAMETER(NARRAY=11000000,NWORK=4000000)
c workstation      PARAMETER (NPOINTS=321000)
C*****2 Gig Memory
C      PARAMETER(N1=2500000,N2=5000000)
C      PARAMETER(NARRAY=400000000,NWORK=160000000)
C      PARAMETER (NPOINTS=8000000)
C*****1 Gig Memory
c      PARAMETER(N1=363000,N2=726000)
c      PARAMETER(NARRAY=44500000,NWORK=16000000)
c      PARAMETER (NPOINTS=1090000)
C*****256 MB Memory
c      PARAMETER(N1=80000,N2=160000)
c      PARAMETER(NARRAY=11000000,NWORK=4000000)
c      PARAMETER (NPOINTS=242000)
c      PARAMETER(N1=300000,N2=680000)
c      PARAMETER(NARRAY=20000000,NWORK=4000000)
c      PARAMETER (NPOINTS=910000)
      REAL,ALLOCATABLE::UFIT(:),VFIT(:),WFIT(:)
      REAL,ALLOCATABLE::SUM1(:),SUM2(:),SUM3(:)
      REAL,ALLOCATABLE::SUM4(:),SUM5(:),SUM6(:)
      REAL,ALLOCATABLE::SUM7(:),SUM8(:),SUM9(:)
      REAL,ALLOCATABLE::SUM10(:),SUM11(:),SUM12(:)
      REAL,ALLOCATABLE::SUM13(:),SUMWTSAVE(:)
      REAL,ALLOCATABLE::SUMDBZ(:),SUMDB(:)
      REAL,ALLOCATABLE::UGUESS(:),VGUESS(:),WGUESS(:)
      REAL,ALLOCATABLE::XWEIGHT(:),YWEIGHT(:),ZWEIGHT(:)
      DOUBLE PRECISION,ALLOCATABLE::RHS(:)
      REAL,ALLOCATABLE::U(:),V(:),W(:),BAND1(:)
      REAL,ALLOCATABLE::DIV(:),DIVDBZ(:)
      CHARACTER RAMSFILES(80)*80,DIVERFILE*80
      CHARACTER OFILEFIRST*16,OFILEREL*80
c      COMMON /ONE/X12,M,WORK,IWORK,IA,JA,VELS,INDEX44,INDEX5,
c     + INDX5,INDEX1,INDEX2,INDEX4,ICAST,DIV,U,V,W,BAND1,RHS,
c     + SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,
c     + SUM12,SUM13,SUMWTSAVE,SUMDBZ,SUMDB,UGUESS,VGUESS,WGUESS,
c     + XWEIGHT,YWEIGHT,ZWEIGHT
      DOUBLE PRECISION,ALLOCATABLE::X12(:)
      DOUBLE PRECISION,ALLOCATABLE::M(:)
      DOUBLE PRECISION,ALLOCATABLE::WORK(:)
      DOUBLE PRECISION SXBD,SYBD,SZBD
      INTEGER,ALLOCATABLE::IWORK(:)
      INTEGER,ALLOCATABLE::IA(:)
      INTEGER,ALLOCATABLE::JA(:)
      REAL,ALLOCATABLE::VELS(:)
      INTEGER,ALLOCATABLE::INDEX44(:),INDEX5(:),INDX5(:)
      INTEGER,ALLOCATABLE::INDEX1(:),INDEX2(:),INDEX4(:)
      INTEGER*2,ALLOCATABLE::ICAST(:)
c     integer*2,ALLOCATABLE::INDEX6(:)
      RFLAG=-1.0E+10
      OPEN(1,FILE='/dev/null')
      CALL GETARG(1,CHARINPUT)
      READ(CHARINPUT,'(I1)')ICONVERGENCE
      CALL GETARG(2,CFACTORDIVDBZ)
      IF(CFACTORDIVDBZ.EQ.'          ')THEN
         FACTORDIVDBZ=100000.
      ELSE
         READ(CFACTORDIVDBZ,*)FACTORDIVDBZ
      ENDIF
      WRITE(6,*)'FACTORDIVDBZ = ',FACTORDIVDBZ
      CTR=3.14159/180.
      LUOUT=6
      LU=90
      LUSCAN=96
      KEYWORDB='WIND'
      CREATIME='unknown'
      EXTRA1='SVN VERSION 66'
      RADAR='TAIL'
      RA=-999.
      CO1=-999.
      CO2=-999.
      AZMCOR=-999.
      ELCOR=-999.
      THRESH=-999.
      POWERT=-999.
      BIEL=-999.
      AZBIEL=-999.
      ETIME1=-999.
      STIME2=-999.
      EXTRA6=-999.
      EXTRA7=-999.
      IUNFLD=1
      IATTEN=0
      FLAG=0
      EXTRA2=-999
      EXTRA3=-999
      DO N=1,100000
       ITOP(N)=0
      ENDDO
c      WRITE(6,*)'WARNING--With this version you should not change'
c      WRITE(6,*)'your weighting parameters'
c      WRITE(6,*)'DBZ ONLY (no winds) Y(1)/N(0)?'
c      READ(1,*)IDBZONLY
      IDBZONLY=0
      WRITE(6,*)'Would you like to use a command file?'
C      READ(1,'(A)')COMYES
      COMYES='Y'
      IF(COMYES.EQ.'Y'.OR.COMYES.EQ.'y')THEN
       LUIN=16
c       WRITE(6,*)'Enter command file name'
c       READ(1,'(A)')FILNAM(1)
       FILNAM(1)='jobfile_radar'
       OPEN(16,FILE=FILNAM(1),STATUS='OLD')
      ELSE
       LUIN=1
      ENDIF
c      WRITE(6,*)'Enter flight name 8 characters or less'
      READ(LUIN,'(A8)')FLTNAME
      WRITE(6,1501)FLTNAME
1501  FORMAT('Flight name entered is: ',A8)
c      WRITE(6,*)'Enter Experiment Name 32 characters or less'
      READ(LUIN,'(A32)')EXPERIMENT
      WRITE(6,1502)EXPERIMENT
1502  FORMAT('Experiment name entered is: ',A32)
      STMNAME=EXPERIMENT(1:12)
c      WRITE(6,*)'How many DOP3D files will be used in this program?'
c      READ(LUIN,*)NFILE
      NFILE=2
      WRITE(6,1503)NFILE
1503  FORMAT('Number of scan files to be synthesized is ',I3)
      IF(NFILE.GT.40)THEN
       WRITE(6,*)'Too many files'
       STOP
      ENDIF
      ETIME=0
      STIME=200000
      READ(LUIN,'(3I2,X,3I2)')IB,JB,KB,IE,JE,KE
      OSUMFILENAME(1)='SUMFILE_aft_helped'
      OSUMFILENAME(2)='SUMFILE_fore_helped'
c      READ(LUIN,'(A80)')OSUMFILENAME(NF)
      DO NF=1,NFILE
c       WRITE(6,*)'Enter Doppler scanfile name for file # ',NF
c       READ(LUIN,'(A80)')FILNAM(NF)
c       WRITE(6,*)'How much would you like to multiply dbz by?'
c       READ(LUIN,*)DBZFACT(NF),XSHIFT(NF),YSHIFT(NF)
c       WRITE(6,*)'Enter beginning and ending times to use data in',
c     +  ' HHMMSS HHMMSS'
       WRITE(6,1506)NF,IB,JB,KB
1506   FORMAT('Start time for file ',I3,' is ',3I2)
       WRITE(6,1507)NF,IE,JE,KE
1507   FORMAT('End time for file ',I3,' is ',3I2)
       TSTART=IB*3600.+JB*60+KB
       STIMENEW=TSTART
       TEND=IE*3600.+JE*60.+KE
       ETIMENEW=TEND
       IF(ETIMENEW.LT.STIMENEW)THEN
        TEND=ETIMENEW+86400.
        ETIMENEW=TEND
       ELSE
        TEND=ETIME
       ENDIF
       IF(STIMENEW.LT.STIME)STIME=STIMENEW
       IF(ETIMENEW.GT.ETIME)ETIME=ETIMENEW
       WRITE(6,*)'STIME,ETIME,TSTART,TEND = ',
     +            STIME,ETIME,TSTART,TEND 
       WRITE(6,*)'STIMENEW,STIME = ',STIMENEW,STIME
       WRITE(6,*)'ETIMENEW,ETIME = ',ETIMENEW,ETIME             
       TSTARTARRAY(NF)=TSTART
       TENDARRAY(NF)=TEND
c       WRITE(6,*)'Enter the SUMFILE for this flight leg'
c       READ(LUIN,*)IVTSUB(NF)
       IVTSUB(NF)=1
       IF(IVTSUB(NF).NE.0)THEN
        WRITE(6,*)'Fallspeed projection will be subtracted ',
     +   'from this file'
       ELSE
        WRITE(6,*)'Fallspeed projection will not be subtracted ',
     +   'from this file'
       ENDIF
C       READ(LUIN,'(A80)')OSUMFILENAME(NF)
       WRITE(6,1508)NF,OSUMFILENAME(NF)
1508   FORMAT('Input sumfile name for file ',I3,' is ',A56)
      ENDDO
c      WRITE(6,*)'Mean storm velocity for this flight leg'
      READ(LUIN,*)SMOTIONU,SMOTIONV
c      WRITE(6,*)'Enter center time HHMMSS'
      READ(LUIN,'(3I2)')IH,IM,IS
c      CENTIME=IH*3600+IM*60+IS
c      IF(CENTIME.LT.STIME)CENTIME=CENTIME+86400.
c      WRITE(6,*)'Enter latitude and longitude of anchor point'
      READ(LUIN,*)OLAT,OLON
      WRITE(6,1511)OLAT,OLON
1511  FORMAT('Latitude and longitude of anchor point are ',2F9.3)
      WRITE(6,*)'OLAT = ',OLAT,'   OLON = ',OLON
      I1REMOVE=0
c      WRITE(6,*)'Enter SX,SY,SZ OF OUTPUT FILE'
      READ(LUIN,*)SXBD,SYBD,SZBD
      WRITE(6,1512)SXBD,SYBD,SZBD
1512  FORMAT('x-, y-, and z-resolution of grid (km) are ',3F8.2)
      SXB=SXBD
      SYB=SYBD
      SZB=SZBD
c      WRITE(6,*)'Enter XZ,YZ,ZZ,ROT OF OUTPUT FILE'
      READ(LUIN,*)XZB,YZB,ZZB,ROTB
      WRITE(6,1513)XZB,YZB
1513  FORMAT('Anchor position (x,y) relative to lower-left corner ',
     + 'in synthesis will be ',2F8.2)
      WRITE(6,1514)ZZB
1514  FORMAT('Vertical level 1 will be at height ',F8.2,' km')
      WRITE(6,1515)ROTB
1515  FORMAT('Clockwise rotation of analysis y-axis from north ',
     + 'will be ',F8.2,' degrees')
c      ZZB=0.
c      WRITE(6,*)'Enter IMAX,JMAX,KMAX of output file'
      READ(LUIN,*)IMAXB,JMAXB,KMAXB
      WRITE(6,1516)IMAXB,JMAXB,KMAXB
      N1=IMAXB*JMAXB*KMAXB+1000
      N2=N1*2
      NPOINTS=3*IMAXB*JMAXB*KMAXB+5000
      NARRAY=160*N1
      NWORK=64*N1
      ALLOCATE(VELS(NPOINTS))
      DO N=1,NPOINTS
       VELS(N)=0.
      ENDDO
      ALLOCATE(UFIT(N1))
      ALLOCATE(VFIT(N1))
      ALLOCATE(WFIT(N1))
      ALLOCATE(SUM1(N1))
      ALLOCATE(SUM2(N1))
      ALLOCATE(SUM3(N1))
      ALLOCATE(SUM4(N1))
      ALLOCATE(SUM5(N1))
      ALLOCATE(SUM6(N1))
      ALLOCATE(SUM7(N1))
      ALLOCATE(SUM8(N1))
      ALLOCATE(SUM9(N1))
      ALLOCATE(SUM10(N1))
      ALLOCATE(SUM11(N1))
      ALLOCATE(SUM12(N1))
      ALLOCATE(SUM13(N1))
      ALLOCATE(SUMWTSAVE(N1))
      ALLOCATE(SUMDBZ(N1))
      ALLOCATE(SUMDB(N1))
      ALLOCATE(UGUESS(N1))
      ALLOCATE(VGUESS(N1))
      ALLOCATE(WGUESS(N1))
      ALLOCATE(XWEIGHT(N1))
      ALLOCATE(YWEIGHT(N1))
      ALLOCATE(ZWEIGHT(N1))
      ALLOCATE(RHS(NPOINTS))
      ALLOCATE(U(N1))
      ALLOCATE(V(N1))
      ALLOCATE(W(N1))
      ALLOCATE(DIVDBZ(N1))
      ALLOCATE(BAND1(NPOINTS))
      ALLOCATE(DIV(N1))
      ALLOCATE(X12(NPOINTS))
      ALLOCATE(M(NARRAY))
      ALLOCATE(WORK(NWORK))
      ALLOCATE(IWORK(NARRAY))
      ALLOCATE(IA(NPOINTS))
      ALLOCATE(JA(NARRAY))
      ALLOCATE(INDEX44(N1))
      ALLOCATE(INDEX5(N1))
      ALLOCATE(INDX5(N1))
      ALLOCATE(INDEX1(NPOINTS))
      ALLOCATE(INDEX2(NPOINTS))
      ALLOCATE(INDEX4(N1))
      ALLOCATE(ICAST(N1))
1516  FORMAT('Integral x-, y-, and z-domains will be ',3I4)
c      WRITE(6,*)'Enter horizontal, vertical maximum radii of ',
c     1 ' influence in km'       
      DO N=1,N1
       U(N)=RFLAG
       V(N)=RFLAG
       DIV(N)=0.     
       W(N)=RFLAG
       SUMDBZ(N)=RFLAG
      ENDDO
      NCHECK=IMAXB*JMAXB*KMAXB
      IF(NCHECK.GT.N1)THEN
       WRITE(6,*)'Total number of grid points is ',NCHECK
       WRITE(6,*)'Which is greater than the allowed ',N1
      ELSE
       WRITE(6,*)'N1,NCHECK = ',N1,NCHECK
      ENDIF
      READ(LUIN,*)ITAPEDUMMY
      READ(LUIN,*)IBSTDUMMY,INOBDUMMY
      DO I=1,4
       READ(LUIN,*)DUMMY1,DUMMY2,DUMMY3
      ENDDO
      READ(LUIN,*)DUMMY1,DUMMY2,DUMMY3,DUMMY4
      READ(LUIN,*)DUMMY
c      READ(LUIN,*)RHMAX,RZMAX
c      WRITE(6,*)'Enter horizontal, vertical e-folding radius'
c      READ(LUIN,*)EHMAX,EZMAX
c      WRITE(6,*)'Enter acceptable x,y,z displacement'
c      READ(LUIN,*)XACC,YACC,ZACC
      XACC=2.*SXB
      YACC=2.*SYB
      ZACC=2.*SZB
c      XACC=SXB
c      YACC=SYB
c      ZACC=SZB
c      IF(XACC.LT.1.)XACC=1.
c      IF(YACC.LT.1.)YACC=1.
      IF(ZACC.LT.1.)ZACC=1.
c      WRITE(6,*)'Enter name of output file'
c      READ(LUIN,'(A80)')OFILNAM
c      WRITE(6,*)'Enter ruv or wind file'
C      READ(1,*)KEYWORDOUT
      KEYWORDOUT='WIND'
      IF(KEYWORDB.EQ.'ruv '.OR.KEYWORDB.EQ.'RUV ')THEN
       IUVB=1
      ELSE
       IUVB=0
      ENDIF
      WRITE(6,*)'XACC = ',XACC
      WRITE(6,*)'YACC = ',YACC
      WRITE(6,*)'ZACC = ',ZACC
c      WRITE(6,*)'Enter kmin and kmax for computation'
C      READ(LUIN,*)KMIN2,KMAX2
      KMIN2=1
      KMAX2=KMAXB
      WRITE(6,1519)KMIN2,KMAX2
1519  FORMAT('Entered kmin2, kmax2 are ',2I4)
      IF(KMAX2.GT.KMAXB)KMAX2=KMAXB
      WRITE(6,1520)KMIN2,KMAX2
1520  FORMAT('KMIN2,KMAX2 are ',2I4)
c      WRITE(6,*)'Enter maximum acceptable elevation angle'
c      READ(LUIN,*)SINTOL
c      IF(SINTOL.GE.90.)THEN
c       SINTOL=1.
c      ELSE
c       SINTOL=SINTOL*3.14159/180.
c       SINTOL=SIN(SINTOL)
c      ENDIF
c      WRITE(6,*)'Max abs(sin(elev)) = ',SINTOL      
c      WRITE(6,*)'Enter maximum acceptable condition number'
c      READ(LUIN,*)TOLERANCE
      TOLERANCE=1000.
C      WRITE(6,*)'Would you like to enter a fallspeed correction ',
C     + '(constant) y(1)/n(0)'
C      READ(LUIN,*)IFALLCOR
C      IF(IFALLCOR.EQ.1)THEN
C       WRITE(6,*)'Enter correction amount'
C       READ(LUIN,*)FALLCOR
C      ELSE
       FALLCOR=0.
C      ENDIF
C      WRITE(6,*)'Would you like to enter angle corrections other ',
C     +  'than those used in DOP3D or FAST3D y(1)/n(0)?'
C      READ(LUIN,*)IELCOR
C      IF(IELCOR.EQ.1)THEN
C       WRITE(6,*)'Enter elevation correction in deg, approx ground ',
C     +  'speed in m/s'
C       READ(LUIN,*)ELCORR,GS
C       WRITE(6,*)'Enter pitch and drift corrections in degrees'
C       READ(LUIN,*)PCOR,DCOR
C       PCOR=SIN(3.14159/180.*PCOR)*GS
C       DCOR=SIN(3.14159/180.*DCOR)*GS
C       EVRCOR=SIN(3.14159*ELCORR/180.)*GS
C      ELSE
       GS=0.
       PCOR=0.
       DCOR=0.
       EVRCOR=0.
C      ENDIF
C Test to make sure all files actually exist
C      WRITE(6,*)'Do you want to compute vertical wind y(1)/n(0)?'
C      READ(LUIN,*)IVWIND
      IVWIND=1
      WRITE(6,*)'i got here'
C      WRITE(6,*)'Enter horizontal, vertical smoothing factors'
      FACTRH=.01
      FACTRZ=100.
c      READ(LUIN,*)FACTRH,FACTRZ
      WRITE(6,1540)FACTRH,FACTRZ
1540  FORMAT('Horizontal/vertical filter factors are ',F8.3)
c      WRITE(6,*)'Enter continuity factor,FACTWP,FACTWBOT'
C      READ(LUIN,*)FACTZ,FACTWP,FACTWBOT,FACTVR,FACTVR2,FACTWTOP
      READ(LUIN,*)IDUMMY1,IDUMMY2
      READ(LUIN,*)FACTZ
C      FACTZ=1.
      FACTWP=0.
      FACTWBOT=1.
      FACTWTOP=1.
      FACTVR2=1.
      FACTVR=(SZB*1000.)+1.
      WRITE(6,*)'4th order continuity factor is ',FACTZ
      WRITE(6,*)'2nd order continuity factor is ',FACTWP
      WRITE(6,*)'bottom,top boundary factors are ',FACTWBOT,FACTWTOP
      WRITE(6,*)'Doppler radial weight is ',FACTVR2
      WRITE(6,*)'Thickness of top in meters is ',FACTVR
      FACTM=1.
c      WRITE(6,*)'Use the continuity equation (1) or solve ',
c     + 'directly (0, you need 3 Vrs'
C      READ(LUIN,*)ICONTINUITY
      ICONTINUITY=1
      IF(ICONTINUITY.EQ.1)THEN
       WRITE(6,*)'Synthesis will use continuity equation'
      ELSEIF(ICONTINUITY.EQ.0)THEN
       WRITE(6,*)'Synthesis will be determined from radials only'
      ELSE
       WRITE(6,*)'Problem with ICONTINUITY'
       STOP
      ENDIF
c      WRITE(6,*)'Is there a starting-guess wind3d file? y(1)/n(0)'
c      READ(1,*)IGUESS
c      IGUESS=0
c      WRITE(6,*)'Use starting guess only as a mask? y(1)/n(0)'
C      READ(1,*)IGUESSER
c      IGUESSER=0
c      WRITE(6,*)'Reverse the Vrs (very old file) y(1)/n(0)'
C      READ(1,*)IREVERSE
      IGUESS=0
      IGUESSER=0
      IREVERSE=1
C      WRITE(6,*)'Do you want to read a SUMFILE y(1)/n(0)'
C      READ(LUIN,*)IREADABCD
C      WRITE(6,*)'Do you want to write a SUMFILE y(1)/n(0)'
C      READ(LUIN,*)IWRITEABCD
C      WRITE(6,*)'Do you want to use SUMFILE values? (1) or '
C      WRITE(6,*)'just pass them on (0)?'
C      READ(LUIN,*)IREADABCD
      IREADABCD=1
      IWRITEABCD=0
C      WRITE(6,*)'Joss and Waldvogel (0) or Willis gamma (1)'
C      READ(LUIN,*)IRSW
      IRSW=0
      IF(IRSW.EQ.0)THEN
       WRITE(6,*)'Joss and Waldvogel will be used'
      ELSE
       WRITE(6,*)'Fall speeds from Willis gamma function will be used'  
      ENDIF
c      WRITE(6,*)'Enter melting band height, depth in original run'
c      READ(LUIN,*)HB1,DPB1
c      WRITE(6,*)'Enter new melting band height, depth'
      READ(LUIN,*)HB2,DPB2
      HB1=HB2
      DPB1=DPB2
      WRITE(6,1570)HB2,DPB2
1570  FORMAT('Melting-band height, depth are ',2F8.3,' km')
C      WRITE(6,*)'Enter dbz slope correction factor'
C      READ(LUIN,*)SLOPE1
C      WRITE(6,*)'Enter Dotmin'
C      READ(LUIN,*)DOTMIN
      DOTMIN=.9999999
C      WRITE(6,*)'Enter weight for u-v and w boundary condition normal'
C      READ(LUIN,*)BOUND,WBOUND,WTOP
C      WRITE(6,*)'Enter range delay'
       RDEL=0.
       BOUND=0.
       WBOUND=0.
       WTOP=0.
C      READ(LUIN,*)RDEL
C      WRITE(6,*)'Enter minimum dBZ and range to include data'
C      READ(1,*)DBZTEST,RRRR
C      DBZTEST=-2000.
C      RRRR=10.
C      WRITE(6,*)'Enter zlow and zhigh above melting level'
      READ(LUIN,*)ZLOW,ZHIGH
      WRITE(6,1560)ZLOW
1560  FORMAT('Reflecitivity below which all ice at T<0 is ',F8.3)
      WRITE(6,1561)ZHIGH
1561  FORMAT('Reflecitivity below which all water at T<0 is ',F8.3)
C      WRITE(6,*)'Set a bottom boundary condition? y(1)/n(o)'
C      READ(1,*)IBOTTOP
      IBOTTOP=1
C      WRITE(6,*)'Enter maximum number of iterations and number of'
C      WRITE(6,*)'iterations between writing interim solution'
C      READ(1,*)ITMAX,ITMAXDIV
      ITMAX=1000 
      ITMAXDIV=1000
c      WRITE(6,*)'How many independent VRs are needed to find a '
c      WRITE(6,*)'wind solution (should be greater than or equal to 2)'
c      READ(1,*)IVRTEST
      IVRTEST=2
C      WRITE(6,*)'Use rams files for position--yes(1) or no (0)?'
C      READ(1,*)IRAMSFILES
      IRAMSFILES=0
C      WRITE(6,*)'SUBTRACT VT YES (1) OR NO (0)?'
C      WRITE(6,*)'Subtract winds as echo motion yes(1) or no (0)?'
C      READ(LUIN,*)IECHO
      IECHO=0
c      WRITE(6,*)'BOTTOM (1), TOP (10), OR BOTH (11) '
c      WRITE(6,*)'OR EITHER (20) BOUND(S) NEEDED?'
c      READ(1,*)IBOUNDTEST
       IBOUNDTEST=20
c      WRITE(6,*)'ENTER HIGHEST LEVEL TO EXTEND BOTTOM B.C.'
c      READ(1,*)ZBOTMAX
      ZBOTMAX=40.
C      WRITE(6,*)'ENTER LOWEST LEVEL TO EXTEND TOP B.C.'
C      READ(1,*)ZTOPMIN
      ZTOPMIN=-1.
C      WRITE(6,*)'ENTER LOWEST LEVEL TO SET AS A TOP FOR B.C.s'
C      READ(1,*)ZTOPPER
      ZTOPPER=-1.
      IRAMSFILES=0
      IF(IRAMSFILES.EQ.1)THEN
       DO NF=1,NFILE
        READ(LUIN,'(A80)')RAMSFILES(NF)
       ENDDO
      ENDIF
      WRITE(6,*)'READING OFILNAM'
      READ(LUIN,'(A80)')OFILNAM
      WRITE(6,'(A80)')OFILNAM
      WRITE(6,*)'SHOULD HAVE WRITTEN OFILNAM'
      READ(OFILNAM,'(A16)')OFILEFIRST
      WRITE(OFILEREL,"(A16,'_rel.w')")OFILEFIRST
      WRITE(6,'(A80)')OFILEREL
      READ(LUIN,*)AZIDUMMY1,AZIDUMMY2
      READ(LUIN,'(A1)')CDUMMY
      READ(LUIN,*)IFRANCE
      READ(LUIN,*)ISTORMNO
C      WRITE(6,*)'Enter minimum angle between radials from ',
C     + 'different files'
      SINMIN=15.
c      SINMIN=5.
C      READ(1,*)SINMIN
      SINMIN=SIN(SINMIN*3.14159/180.)
C      WRITE(6,*)'ENTER WEIGHT FOR BACKGROUND FOR U,V,W'
C      READ(1,*)WTBACKU,WTBACKV,WTBACKW
      WTBACKU=0.03
      WTBACKV=0.03
      WTBACKW=0.03
      IF(WTBACKU.GT.0..OR.WTBACKV.GT.0..OR.WTBACKW.GT.0.)THEN
C
C If desired, enter first-guess wind field
C
C       WRITE(6,*)'Set background wind to zero (0) or '
C       WRITE(6,*)'use guess field (1)?'
C       READ(1,*)ISETZERO
c       ISETZERO=0
       ISETZERO=1
       IF(ISETZERO.EQ.0)THEN
        DO I=1,N1
         UFIT(I)=RFLAG
         VFIT(I)=RFLAG
         WFIT(I)=RFLAG
        ENDDO
       ENDIF
       IF(ISETZERO.NE.0)THEN
c        WRITE(6,*)'Enter WIND3D file name'
c        READ(1,'(A80)')WINDFILE
        WINDFILE='first_guess_fourier_xy.w'
        LULDPLN=99
        CALL READHEADER(LULDPLN,WINDFILE,KEYWORD,FLTNAME,
     +   STMNAME,RADAR,EXPERIMENT,
     +   CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     +   IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME3,ETIME3,OLAT,OLON,
     +   SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +   POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
        WRITE(6,*)CREATIME
        WRITE(6,*)FLTNAME
        WRITE(6,*)STMNAME
        WRITE(6,*)'KEYWORD,RADAR,EXPERIMENT'
        WRITE(6,'(A4,2X,A4,2X,A32)')KEYWORD,RADAR,EXPERIMENT
        WRITE(6,*)'EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN'
        WRITE(6,*)EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,IUNFLD,IATTEN
        write(6,*)'just read header of first_guess_fourier_xy.w'
        WRITE(6,*)'FLAG,EXTRA2'
        WRITE(6,*)FLAG,EXTRA2
        WRITE(6,*)'EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ'
        WRITE(6,*)EXTRA3,STIME3,ETIME3,OLAT,OLON,SXB,SYB,SZB,
     +           XZB,YZB,ZZB
        WRITE(6,*)'ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL'
        WRITE(6,*)ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL
        WRITE(6,*)'AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7'
        WRITE(6,*)AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7
        IF(KEYWORD.EQ.'ruv '.OR.KEYWORD.EQ.'RUV ')THEN
         IUV=1
        ELSE
         IUV=0
        ENDIF
        CALL LDPLNW(LULDPLN,UFIT,VFIT,WFIT,IMAXB,JMAXB,KMAXB,IUV,
     1     ZZB,SZB)
        CLOSE(LULDPLN)
        CALL DIVER3(UFIT,VFIT,WFIT,
     1             IMAXB,JMAXB,KMAXB,SXBD,SYBD,SZBD,DIV)
       ELSE
        DO IJK=1,N1
         UGUESS(IJK)=0.
         VGUESS(IJK)=0.
         WGUESS(IJK)=0.
        ENDDO
       ENDIF
      ELSE
       DO IJK=1,N1
        UGUESS(IJK)=0.
        VGUESS(IJK)=0.
        WGUESS(IJK)=0.
       ENDDO
       IGUESS=1
      ENDIF
92532 LUW=95
      NNN1=N1
      N4=NNN1
      NN1=NPOINTS
      NNNN1=NPOINTS
      NNNNN=NARRAY
      LUOUT=6
C
C Determine horizontal divergence of wind field
C
      CALL DIVER(U,V,DIV,IMAXB,JMAXB,KMAX2,SXB,SYB)
       LUO=91
       KEYWORDB='WIND'
      IF(KEYWORDB.EQ.'ruv '.OR.KEYWORDB.EQ.'RUV ')THEN
       IUVB=1
      ELSE
       IUVB=0
      ENDIF
C       TESTFILE='TESTFILE'
C       CALL WRITEHEADER(LUO,TESTFILE,KEYWORDB,FLTNAME,
C     +  STMNAME,RADAR,EXPERIMENT,
C     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
C     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
C     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
C     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
CC
CC Write result to output file
CC
Cc       WRITE(6,*)'ENTERING WRPLN'
C       CALL WRPLNEU(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,SUMDB,
C     +  IUVB,ZZB,SZB,INDEX4,OLAT,OLON,SXB,SYB,XZB,YZB,IH,IM,IS,
C     +  IB,JB,KB,IE,JE,KE,FLTNAME)
Cc       WRITE(6,*)'LEAVING WRPLN'
C      CLOSE(LUO)
c      WRITE(6,*)'BEFORE ENTERING SPARSE, FACTZ,FACTR = ',FACTZ,FACTR
      DO I=1,N1
       INDEX5(I)=0
       SUMDBZ(I)=RFLAG
      ENDDO
C      WRITE(6,*)'MULTIPLE VRS (0) OR MULTIPLE PAIRS (1)?'
C      READ(1,*)IMULTI
      IMULTI=1 
      IF(IMULTI.EQ.0)THEN
       CALL WCHECK(IMAXB,JMAXB,KMAXB,KMAX2,SUM1,SUM2,SUM3,SUM4,
     +   SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,INDEX4,
     +   OSUMFILENAME,NFILE,SUMWTSAVE,SUMDBZ,SUMDB,XWEIGHT,YWEIGHT,
     +  ZWEIGHT,XACC,YACC,ZACC,IVRTEST,U,V,W,SZB,ZZB)
       DO NTOP=1,100000
        ITOP(NTOP)=1
       ENDDO
      ELSE
       DO L=1,N1
        INDEX4(L)=0
       ENDDO
       DO L=NFILE,2,-1
        SUMFILENAME(2)=OSUMFILENAME(L)
        DO LL=1,L-1
         write(6,*)'calling wzero'
         SUMFILENAME(1)=OSUMFILENAME(LL)
         write(6,'(A80)')SUMFILENAME(1)
         write(6,'(A80)')SUMFILENAME(2)
         CALL WZERO(IMAXB,JMAXB,KMAXB,KMAX2,SUM1,SUM2,SUM3,SUM4,
     +   SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,INDEX4,
     +   SUMFILENAME,NFILE,SUMWTSAVE,SUMDBZ,SUMDB,XWEIGHT,YWEIGHT,
     +   ZWEIGHT,XACC,YACC,ZACC,IVRTEST,U,V,W,SZB,ZZB,SINMIN,
     +   VELS(1),VELS(N1+1),VELS(N1+N1+1))
        ENDDO
       ENDDO
      ENDIF
      NZ=NARRAY
      NW=NWORK
      NINSIDE=ITMAX/ITMAXDIV
       IF(IWRITEABCD.EQ.1)THEN
        DO IJK=1,N1
         UGUESS(IJK)=0.
         VGUESS(IJK)=0.
         WGUESS(IJK)=0.
        ENDDO
       ENDIF
      IF(IDBZONLY.NE.1)THEN
      write(6,*)'call sparse kmaxb,nnn1,nn1 = ',kmaxb,nnn1,nn1
      write(6,*)extra1
       CALL SPARSE(M,RHS,U,V,IMAXB,JMAXB,KMAXB,SXBD,SYBD,SZBD,NNN1,NN1,
     + INDEX1,INDEX2,IPOS,SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     + SUM10,SUM11,SUM12,SUM13,
     + XWEIGHT,YWEIGHT,ZWEIGHT,XACC,YACC,ZACC,
     + OSUMFILENAME,NZ,NFILE,IWORK,NW,INDEX4,
     + FACTZ,FACTRH,FACTRZ,ICAST,W,BOUND,WBOUND,ZZB,NNNN1,
     + SUMDBZ,SUMWTSAVE,DBZTEST,NORM,NNNNN,INDXN,WTOP,IBOTTOP,
     + IA,JA,IGUESSER,UGUESS,VGUESS,WGUESS,
     + BAND1,HB2,DPB2,IRSW,ZLOW,ZHIGH,
     1 FACTWP,DUMMY1,FACTVR,FACTVR2,FACTWTOP,
     1 IGUESS,FACTWBOT,DIV,KT,KMAX2,ITOP,IVTSUB,INDX5,ZTOPPER,
     1 WTBACKU,WTBACKV,WTBACKW,VELS(1),VELS(1+N1),UFIT,VFIT,WFIT)    
c ,INDEX6)
       DO JIJ=1,NPOINTS
        VELS(JIJ)=0.
       ENDDO
       write(6,*)'index1(1) = ',index1(1)
        KEYWORDB=KEYWORDOUT
        IF(KEYWORDB.EQ.'ruv '.OR.KEYWORDB.EQ.'RUV ')THEN
         IUVB=1
        ELSE
         IUVB=0
        ENDIF
        DIVERFILE='diverfile'
        write(6,*)'writing diverfile'
        write(6,*)extra1
        CALL WRITEHEADER(LUO,DIVERFILE,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)

C Write result to output file

c        CALL MINMAX(U,V,W,IMAXB,JMAXB,KMAXB)
        CALL WRPLN(LUO,IMAXB,JMAXB,KMAXB,UGUESS,VGUESS,WGUESS,
     +  DIV,SUMDBZ,
     +  IUVB,ZZB,SZB)
        CLOSE(LUO)
       IF(IGUESSER.EQ.1)THEN
        DO IJK=1,N1
         UGUESS(IJK)=0.
         VGUESS(IJK)=0.
         WGUESS(IJK)=0.
        ENDDO
       ENDIF
       DO JKI=1,NINSIDE
        WRITE(6,*)'BEGINNING SOLUTION LOOP NUMBER ',JKI
        DO IJK=1,N1
         JJK=IJK+N1
         KJK=IJK+N2
         IF((JKI.EQ.1.AND.IGUESSER.EQ.1).OR.JKI.GT.1)THEN
          VELS(IJK)=UGUESS(IJK)
          VELS(JJK)=VGUESS(IJK)
          VELS(KJK)=WGUESS(IJK)
         ENDIF
        ENDDO
        KEYWORDB=KEYWORDOUT
        IF(KEYWORDB.EQ.'ruv '.OR.KEYWORDB.EQ.'RUV ')THEN
         IUVB=1
        ELSE
         IUVB=0
        ENDIF
        WRITE(6,*)'SOLVESPARSE,STIME,ETIME = ',STIME,ETIME
        write(6,*)extra1
        CALL SOLVESPARSE(IMAXB,JMAXB,KMAXB,NNN1,NN1,NNNN1,IPOS,SXB,
     + SYB,SZB,VELS,LUOUT,M,RHS,C,R,P,AP,INDEX1,INDEX2,DOTMIN,
     + LUO,OFILNAM,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,
     +  DIV,SUMDBZ,SUMWTSAVE,IGUESS,X12,C12,U,V,W,IUVB,NORM,NNNNN,
     +  INDXN,UGUESS,VGUESS,WGUESS,
     +  NZ,NW,IA,JA,IWORK,WORK,ITMAXDIV,JKI,INDEX4,N4,ICONVERGENCE)
        DO IJK=1,N1
         JJK=IJK+N1
         KJK=IJK+N2
         U(IJK)=VELS(IJK)
         V(IJK)=VELS(JJK)
         W(IJK)=VELS(KJK)
        ENDDO
        CALL DIVER3(U,V,W,IMAXB,JMAXB,KMAXB,SXBD,SYBD,SZBD,DIV)
        LUO=91
        KEYWORDB=KEYWORDOUT
        WRITE(6,*)'FINAL FILE STIME,ETIME = ',STIME,ETIME
        write(6,*)extra1
        CALL WRITEHEADER(LUO,OFILNAM,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C
C Write result to output file
C
c        CALL MINMAX(U,V,W,IMAXB,JMAXB,KMAXB)
C        DO LJIM=1,N1
C         INDEX4(LJIM)=1
C        ENDDO
c        CALL DEFRECKLEXYZ(IMAXB,JMAXB,KMAXB,U,V,W,SUM1,SUM2,SUM3,
c     +  ZZB,SZB)
        DO I=1,N1
         IF(INDEX4(I).LE.0)THEN
          U(I)=RFLAG
          V(I)=RFLAG
          W(I)=RFLAG
         ENDIF
        ENDDO
        WRITE(6,8692)(U(I),I=1,100)
        WRITE(6,8692)(V(I),I=1,100)
        CALL WRPLNEU(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,SUMDBZ,
     +  IUVB,ZZB,SZB,INDEX4,OLAT,OLON,SXB,SYB,XZB,YZB,IH,IM,IS,
     +  IB,JB,KB,IE,JE,KE,FLTNAME,ISTORMNO)
        CLOSE(LUO)
        WRITE(6,8692)(U(I),I=1,100)
        WRITE(6,8692)(V(I),I=1,100)
        OFILNAM='divergence.w'
        CALL WRITEHEADER(LUO,OFILNAM,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C
C Write result to output file
C
c        CALL MINMAX(U,V,W,IMAXB,JMAXB,KMAXB)
C        DO LJIM=1,N1
C         INDEX4(LJIM)=1
C        ENDDO
c        CALL DEFRECKLEXYZ(IMAXB,JMAXB,KMAXB,U,V,W,SUM1,SUM2,SUM3,
c     +  ZZB,SZB)
        DO I=1,N1
         IF(DIV(I).GT.RFLAG)THEN
            DIVDBZ(I)=DIV(I)*FACTORDIVDBZ
         ELSE
            DIVDBZ(I)=RFLAG
         ENDIF
         IF(INDEX4(I).LE.0)THEN
          U(I)=RFLAG
          V(I)=RFLAG
          W(I)=RFLAG
         ENDIF
        ENDDO
        WRITE(6,8692)(U(I),I=1,100)
        WRITE(6,8692)(V(I),I=1,100)
        WRITE(6,*)'CALLING WRPLN TO WRITE divergence.w'
        CALL WRPLN(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,DIVDBZ,
     +   IUVB,ZZB,SZB)
        CLOSE(LUO)
        WRITE(6,8692)(U(I),I=1,100)
        WRITE(6,8692)(V(I),I=1,100)
 8692   FORMAT(6F13.1)
        CALL WREL(U,V,IMAXB,JMAXB,KMAXB,SMOTIONU,SMOTIONV,ZZB,SZB)
        CALL WRITEHEADER(LUO,OFILEREL,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C
C Write result to output file
C
c        CALL MINMAX(U,V,W,IMAXB,JMAXB,KMAXB)
C        DO LJIM=1,N1
C         INDEX4(LJIM)=1
C        ENDDO
c        CALL DEFRECKLEXYZ(IMAXB,JMAXB,KMAXB,U,V,W,SUM1,SUM2,SUM3,
c     +  ZZB,SZB)
c        ISTORMNO=-99
c        CALL WRPLNEU(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,SUMDBZ,
c     +  IUVB,ZZB,SZB,INDEX4,OLAT,OLON,SXB,SYB,XZB,YZB,IH,IM,IS,
c     +  IB,JB,KB,IE,JE,KE,FLTNAME,ISTORMNO)
c        CLOSE(LUO)
        CALL WRPLN(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,SUMDBZ,
     +   IUVB,ZZB,SZB)
        DO IJK=1,N1
         UGUESS(IJK)=U(IJK)
         VGUESS(IJK)=V(IJK)
         WGUESS(IJK)=W(IJK)
        ENDDO
       ENDDO
      ELSE
       DO IJK=1,N1
        U(IJK)=1.
        V(IJK)=1.
        W(IJK)=1.
        DIV(IJK)=0.
       ENDDO
      ENDIF
      IF(IDBZONLY.EQ.1)THEN
       OFILNAM='DBZ'
       LUO=91
       KEYWORDB=KEYWORDOUT
       CALL WRITEHEADER(LUO,OFILNAM,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,IMAXB,JMAXB,KMAXB,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  SXB,SYB,SZB,XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C
C Write result to output file
C
       CALL MINMAX(U,V,W,IMAXB,JMAXB,KMAXB)
       CALL WRPLN(LUO,IMAXB,JMAXB,KMAXB,U,V,W,DIV,SUMDBZ,
     +  IUVB,ZZB,SZB)
      CLOSE(LUO)
      ENDIF
      STOP
      END
      SUBROUTINE WZERO(IMAXB,JMAXB,KMAXB,KMAX2,SUM1,SUM2,SUM3,
     + SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,INDEX1,
     + OSUMFILENAME,NFILE,SUMWTSAVE,SUMDBZ,SUMDB,
     + XWSAVE,YWSAVE,ZWSAVE,XACC,YACC,ZACC,IVRTEST,U,V,W,SZB,ZZB,
     + SINMIN,UTEST,VTEST,WTEST)
      REAL UTEST(IMAXB,JMAXB,KMAXB),VTEST(IMAXB,JMAXB,KMAXB)
      REAL WTEST(IMAXB,JMAXB,KMAXB)
      REAL SUM1(IMAXB,JMAXB,KMAXB),SUM2(IMAXB,JMAXB,KMAXB)
      REAL SUM3(IMAXB,JMAXB,KMAXB),SUM4(IMAXB,JMAXB,KMAXB)
      REAL SUM5(IMAXB,JMAXB,KMAXB),SUM6(IMAXB,JMAXB,KMAXB)
      REAL SUM7(IMAXB,JMAXB,KMAXB),SUM8(IMAXB,JMAXB,KMAXB)
      REAL SUM9(IMAXB,JMAXB,KMAXB)
      REAL SUMWTSAVE(IMAXB,JMAXB,KMAXB)
      REAL SUM10(IMAXB,JMAXB,KMAXB),SUM11(IMAXB,JMAXB,KMAXB)
      REAL SUM12(IMAXB,JMAXB,KMAXB),SUM13(IMAXB,JMAXB,KMAXB)
      REAL U(IMAXB,JMAXB,KMAXB),V(IMAXB,JMAXB,KMAXB)
      REAL W(IMAXB,JMAXB,KMAXB)
      REAL SUMDBZ(IMAXB,JMAXB,KMAXB),SUMDB(IMAXB,JMAXB,KMAXB)
      REAL XWSAVE(IMAXB,JMAXB,KMAXB),YWSAVE(IMAXB,JMAXB,KMAXB)
      REAL ZWSAVE(IMAXB,JMAXB,KMAXB)
      REAL RHOK(200)
      INTEGER INDEX1(IMAXB,JMAXB,KMAXB)
      CHARACTER*80 OSUMFILENAME(2)
      FLAG=-1.0E+10
      write(6,*)'entered wzero'
      HSINMIN=.25*SINMIN
      DO K=1,KMAXB
       HEIGHT=ZZB+(K-1)*SZB
       RHOK(K)=EXP(-HEIGHT*.10437052)
       DO J=1,JMAXB
        DO I=1,IMAXB
C         INDEX1(I,J,K)=0
         SUMWTSAVE(I,J,K)=0.
c         SUMDBZ(I,J,K)=FLAG
        ENDDO
       ENDDO
      ENDDO
      LUW=95
      DO NF=1,2
       OPEN(LUW,FILE=OSUMFILENAME(NF),FORM='UNFORMATTED')
       CALL READABCD(LUW,IMAXB,JMAXB,KMAXB,SUM1,SUM2,SUM3,SUM4,
     +               SUM5,SUM6,SUM7,SUM8,SUM9,
     +               SUM10,SUM11,SUM12,SUM13,
     +    SUMDB,KMAX2,XWSAVE,YWSAVE,ZWSAVE)
       DO K=1,KMAX2
        DO J=1,JMAXB
         DO I=1,IMAXB
          IF(NF.EQ.1)THEN
           UTEST(I,J,K)=0.
           VTEST(I,J,K)=0.
           WTEST(I,J,K)=0.
           U(I,J,K)=0.
           V(I,J,K)=0.
           W(I,J,K)=0.
          ENDIF
c          WRITE(6,*)'NF,I,J,K,XW,YZ,ZW = ',NF,I,J,K,XWSAVE(I,J,K),
c     +    YWSAVE(I,J,K),ZWSAVE(I,J,K)
          IF(ABS(XWSAVE(I,J,K)).LT.XACC.
     +       AND.ABS(YWSAVE(I,J,K)).LT.YACC.
     +       AND.ABS(ZWSAVE(I,J,K)).LT.ZACC)THEN
           IF(NF.EQ.2)THEN
            RLENGTH12=UTEST(I,J,K)*UTEST(I,J,K)
     +      +VTEST(I,J,K)*VTEST(I,J,K)+WTEST(I,J,K)*WTEST(I,J,K)
            RLENGTH22=SUM10(I,J,K)*SUM10(I,J,K)
     +      +SUM11(I,J,K)*SUM11(I,J,K)+SUM12(I,J,K)*SUM12(I,J,K)
            IF(RLENGTH12.GT.0..AND.RLENGTH22.GT.0.)THEN
             RLENGTH1=SQRT(RLENGTH12)
             RLENGTH2=SQRT(RLENGTH22)
             U1=UTEST(I,J,K)/RLENGTH1
             V1=VTEST(I,J,K)/RLENGTH1
             W1=WTEST(I,J,K)/RLENGTH1
             U2=SUM10(I,J,K)/RLENGTH2
             V2=SUM11(I,J,K)/RLENGTH2
             W2=SUM12(I,J,K)/RLENGTH2
             UX=V1*W2-W1*V2
             VX=W1*U2-U1*W2
             WX=U1*V2-V1*U2
             UVW2=UX*UX+VX*VX+WX*WX
             RLENGTH=SQRT(UVW2)
             SINTEST=RLENGTH
c             IF(J.GT.76.AND.J.LE.80.AND.I.GT.19.AND.I.LT.23)THEN
c       WRITE(6,*)'I,J,K,U1,V1,W1,U2,V2,W2,UX,VX,WX,SINMIN,SINTEST = ',
c     +        I,J,K,U1,V1,W1,U2,V2,W2,UX,VX,WX,SINMIN,SINTEST
c             ENDIF
            ELSE
             SINTEST=0.
            ENDIF
           ENDIF
           U(I,J,K)=U(I,J,K)+SUM5(I,J,K)
           V(I,J,K)=V(I,J,K)+SUM3(I,J,K)
           W(I,J,K)=W(I,J,K)+SUM8(I,J,K)
           UTEST(I,J,K)=UTEST(I,J,K)+SUM10(I,J,K)
           VTEST(I,J,K)=VTEST(I,J,K)+SUM11(I,J,K)
           WTEST(I,J,K)=WTEST(I,J,K)+SUM12(I,J,K)
          ELSE
           SINTEST=0.
c           SUMDB(I,J,K)=FLAG
          ENDIF
          IF(NF.EQ.2)THEN
           INDEXX=0
           RLENGTH2=U(I,J,K)+V(I,J,K)+W(I,J,K)
           TESTMIN=1.
           IF(RLENGTH2.GT.0.)THEN
            U1=SQRT(U(I,J,K)/RLENGTH2-(UTEST(I,J,K)/RLENGTH2)**2.)
 7627       FORMAT(6F10.4)
            IF(U1.GT.HSINMIN)INDEXX=1
            V1=SQRT(V(I,J,K)/RLENGTH2-(VTEST(I,J,K)/RLENGTH2)**2.)
            IF(V1.GT.HSINMIN)INDEXX=INDEXX+1
            W1=SQRT(W(I,J,K)/RLENGTH2-(WTEST(I,J,K)/RLENGTH2)**2.)
            IF(W1.GT.HSINMIN)INDEXX=INDEXX+1
c            IF(RLENGTH2.LT.1.001.AND.INDEXX.GE.1)THEN
c             WRITE(6,'(3I3)')I,J,K
c             WRITE(6,7627)U(I,J,K),V(I,J,K),W(I,J,K),RLENGTH2
c             WRITE(6,7627)U1,V1,W1
c             WRITE(6,7628)INDEXX
c 7628       FORMAT(I3)
c            ENDIF 
           UTEST(I,J,K)=W1
            VTEST(I,J,K)=SUM12(I,J,K)/RLENGTH2
C            IF(J.GT.95.AND.J.LT.106)THEN
CAND.I.GT.70.AND.I.LT.80)THEN
C       WRITE(6,*)'I,J,K,U1,V1,W1,UX,VX,WX,RLENGTH2,SINTEST,INDEXX = ',
C     + I,J,K,U1,V1,W1,UX,VX,WX,RLENGTH2,SINTEST,INDEXX
C            ENDIF
           ELSE
            UTEST(I,J,K)=0.
            VTEST(I,J,K)=0.
           ENDIF
c           IF(INDEXX.GE.1.OR.SINTEST.GT.SINMIN)INDEXX=2
           IF(SINTEST.GT.SINMIN.OR.INDEXX.GE.1)THEN
            INDEXX=2
           ELSE
            INDEXX=0
           ENDIF
           IF(INDEXX.GE.IVRTEST)THEN
            INDEX1(I,J,K)=1
c           ELSE
c            INDEX1(I,J,K)=0
           ENDIF
c           if(k.eq.1)write(6,*)'i,j,sintest,indexx,index1,ivrtest = ',
c     1     i,j,sintest,indexx,index1(i,j,k),ivrtest
          ENDIF
c          IF(SUMDB(I,J,K).GT.-100..AND.
c     1     ABS(XWSAVE(I,J,K)).LT.XACC.AND.
c     1     ABS(YWSAVE(I,J,K)).LT.YACC.AND.
c     1     ABS(ZWSAVE(I,J,K)).LT.ZACC)THEN
           IF(SUMDB(I,J,K).GT.SUMDBZ(I,J,K))SUMDBZ(I,J,K)=SUMDB(I,J,K)
           IF(SUMDBZ(I,J,K).GT.75.)SUMDBZ(I,J,K)=75.
c          ENDIF
c         write(6,*)'i,j,k,sum3,sum5,sum8,indexbefore,indexafter = ',
c     1       i,j,k,sum3(i,j,k),sum5(i,j,k),sum8(i,j,k),
c     1       indexbefore,index1(i,j,k)
         ENDDO
        ENDDO
       ENDDO
       CLOSE(LUW)
      ENDDO
      write(6,*)'leaving wzero'
      RETURN
      END
      SUBROUTINE CHARACTERISTIC(IMAX,JMAX,KMAX,U,V,W,INDEX3,
     1 SX,SY,SZ,BOT,TOP,ITOP,INDEX4,INDEX5,IBOUNDTEST,
     1 ZBOTMAX,ZTOPMIN,ZTOPPER)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      INTEGER INDEX4(IMAX,JMAX,KMAX),INDEX5(IMAX,JMAX,KMAX)
      INTEGER INDEX3(IMAX,JMAX,KMAX)
      INTEGER ITOP(IMAX,JMAX)
      REAL DIST(2,2,2),UU(2,2,2),VV(2,2,2),WW(2,2,2)
      FLAG=-1.0E+10
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      ITOT=2*IMAX-1
      JTOT=2*JMAX-1
      DO J=1,JMAX
       DO I=1,IMAX
        ITOP(I,J)=0
       ENDDO
      ENDDO
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         INDEX3(I,J,K)=0
        ENDDO
       ENDDO
      ENDDO
      WRITE(6,*)'GOT TO BOTTOM BOUNDARY CONDITION'
      IF(BOT.LE.0)GO TO 101
      DO LX=1,2
       FACT=1.
       IF(LX.EQ.1)FACT=-1.
       DO JT=1,JTOT
        YSTART=(JT-1)*.5*SY
        DO IT=1,ITOT
         if(it.eq.1)write(6,*)'jt,it,lx = ',jt,it,lx
        XSTART=(IT-1)*.5*SX
        X1=XSTART
        Y1=YSTART
        Z1=0.
        ICOUNTER=0
1       IX1=INT(X1/SX)+1
        IX2=INT(X1/SX)+2
        IY1=INT(Y1/SY)+1
        IY2=INT(Y1/SY)+2
        IZ1=INT(Z1/SZ)+1
        IZ2=INT(Z1/SZ)+2
        IF(X1.LT.0.)THEN
         IX1=0
         IX2=1
        ENDIF
        IF(Y1.LT.0.)THEN
         IY1=0
         IY2=1
        ENDIF
        IF(Z1.LT.0.)THEN
         IZ1=0
         IZ2=1
        ENDIF
        ICOUNTER=ICOUNTER+1
        IF(ICOUNTER.GT.10000)GO TO 77
        ITESTER=0
        if(icounter.le.-3)then
         write(6,*)'ix1,ix2,iy1,iy2,iz1,iz2 = ',ix1,ix2,iy1,iy2,iz1,iz2
        endif
        IF(IX1.LT.1.OR.IX2.GT.IMAX)GO TO 77
        IF(IY1.LT.1.OR.IY2.GT.JMAX)GO TO 77
        IF(IZ1.LT.1.OR.IZ2.GT.KMAX.OR.Z1.LT.0.)GO TO 77
        DO II=IX1,IX2
         III=II-IX1+1
         DO JJ=IY1,IY2
          JJJ=JJ-IY1+1
          DO KK=IZ1,IZ2
           KKK=KK-IZ1+1
           IF(U(II,JJ,KK).LE.FLAG)THEN
            ITESTER=1
C           if(jt.eq.4.and.it.gt.67)then
C            WRITE(6,*)'II,JJ,KK,U,V,W = ',II,JJ,KK,
C     1      U(II,JJ,KK),V(II,JJ,KK),W(II,JJ,KK)
C           endif
c            GO TO 78
           ENDIF
           UU(III,JJJ,KKK)=U(II,JJ,KK)
           VV(III,JJJ,KKK)=V(II,JJ,KK)
           WW(III,JJJ,KKK)=W(II,JJ,KK)
C          if(jt.eq.4.and.it.gt.67)then
C           WRITE(6,*)'III,JJJ,KKK,UU,VV,WW = ',III,JJJ,KKK,
C     1      UU(III,JJJ,KKK),VV(III,JJJ,KKK),WW(III,JJJ,KKK)
C          endif
          ENDDO
         ENDDO
        ENDDO
78      IF(ICOUNTER.le.-3)WRITE(6,*)'ITESTER,UU = ',ITESTER,UU     
        IF(ITESTER.EQ.0)THEN
         XX1=(IX1-1)*SX
         XX2=(IX2-1)*SX
         YY1=(IY1-1)*SY
         YY2=(IY2-1)*SY
         ZZ1=(IZ1-1)*SZ
         ZZ2=(IZ2-1)*SZ
         ZXYFACT=SX*SY/SZ/SZ
         DIST(1,1,1)=(X1-XX1)*(X1-XX1)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
         IF(DIST(1,1,1).GT.0.)DIST(1,1,1)=SQRT(DIST(1,1,1))
         DIST(2,1,1)=(X1-XX2)*(X1-XX2)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
         IF(DIST(2,1,1).GT.0.)DIST(2,1,1)=SQRT(DIST(2,1,1))
         DIST(1,2,1)=(X1-XX1)*(X1-XX1)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
         IF(DIST(1,2,1).GT.0.)DIST(1,2,1)=SQRT(DIST(1,2,1))
         DIST(2,2,1)=(X1-XX2)*(X1-XX2)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
         IF(DIST(2,2,1).GT.0.)DIST(2,2,1)=SQRT(DIST(2,2,1))
         DIST(1,1,2)=(X1-XX1)*(X1-XX1)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
         IF(DIST(1,1,2).GT.0.)DIST(1,1,2)=SQRT(DIST(1,1,2))
         DIST(2,1,2)=(X1-XX2)*(X1-XX2)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
         IF(DIST(2,1,2).GT.0.)DIST(2,1,2)=SQRT(DIST(2,1,2))
         DIST(1,2,2)=(X1-XX1)*(X1-XX1)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*XYZFACT
         IF(DIST(1,2,2).GT.0.)DIST(1,2,2)=SQRT(DIST(1,2,2))
         DIST(2,2,2)=(X1-XX2)*(X1-XX2)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
         IF(DIST(2,2,2).GT.0.)DIST(2,2,2)=SQRT(DIST(2,2,2))
         USUM=0
         VSUM=0
         WSUM=0
         DISTSUM=0
         DO K=1,2
          DO J=1,2
           DO I=1,2
            IF(DIST(I,J,K).EQ.0)THEN
             UX=UU(I,J,K)*FACT*SX
             VX=VV(I,J,K)*FACT*SX
             WX=WW(I,J,K)*FACT*SX
             IF(ICOUNTER.LE.-3)THEN
              WRITE(6,*)'ZERO,FACT,UX,VX,WX = ',FACT,UX,VX,WX
             ENDIF
             GO TO 79
            ELSE
c             IF(DIST(I,J,K).LT..5*SX)THEN
             IF(DIST(I,J,K).LT..75*SX)THEN
c             IF(DIST(I,J,K).LT.3.*SX)THEN
              II=IX1+I-1
              JJ=IY1+J-1
              KK=IZ1+K-1
c              IF(LX.EQ.2.AND.INDEX3(II,JJ,KK).GT.0)THEN
c               WRITE(6,*)'BEGIN II,JJ,KK,INDEX3(II,JJ,KK)',
c     +             II,JJ,KK,INDEX3(II,JJ,KK)
c              ENDIF
              IF(LX.EQ.1)THEN
               INDEX3(II,JJ,KK)=1
              ELSEIF(LX.EQ.2.AND.INDEX3(II,JJ,KK).EQ.1)THEN
               INDEX3(II,JJ,KK)=11
              ELSEIF(LX.EQ.2.AND.INDEX3(II,JJ,KK).EQ.11)THEN
               INDEX3(II,JJ,KK)=11
              ELSE
               INDEX3(II,JJ,KK)=2
              ENDIF
             ENDIF
             USUM=USUM+UU(I,J,K)/DIST(I,J,K)
             VSUM=VSUM+VV(I,J,K)/DIST(I,J,K)
             WSUM=WSUM+WW(I,J,K)/DIST(I,J,K)
             DISTSUM=DISTSUM+1./DIST(I,J,K)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
         UX=USUM/DISTSUM*FACT*SX
         VX=VSUM/DISTSUM*FACT*SX
         WX=WSUM/DISTSUM*FACT*SX
         IF(ICOUNTER.LE.-3)THEN
          WRITE(6,*)'NOT ZERO,FACT,UX,VX,WX = ',FACT,UX,VX,WX
         ENDIF
C79       if(jt.eq.4.and.it.gt.68)then
C         WRITE(6,*)'X1,Y1,Z1 = ',X1,Y1,Z1
C         endif
79       X1=X1+UX*.02*SZ/SX
         Y1=Y1+VX*.02*SZ/SX
         Z1=Z1+WX*.02*SZ/SX
         if(icounter.le.-3)write(6,*)'icounter,itester,x1,y1,z1 = ',
     1     icounter,itester,x1,y1,z1
C         if(jt.eq.4.and.it.gt.67)then
C         WRITE(6,*)'UX,VX,WX,X1,Y1,Z1 = ',UX,VX,WX,X1,Y1,Z1        
C         endif
         GO TO 1
        ENDIF
77     ENDDO
       ENDDO
      ENDDO
101   WRITE(6,*)'GOT TO TOP BOUNDARY CONDITION'
      IF(TOP.LE.0..AND.IBOUNDTEST.EQ.1)GO TO 102
      DO JT=1,JTOT
       YSTART=(JT-1)*.5*SY
       DO IT=1,ITOT
        if(it.eq.1)write(6,*)'jt,it = ',jt,it
        DO LX=1,2
         FACT=1.
         IF(LX.EQ.1)FACT=-1.
         XSTART=(IT-1)*.5*SX
         X1=XSTART
         Y1=YSTART
         IX1=INT(X1/SX)+1
         IY1=INT(Y1/SY)+1
         DO K=KMAX,1,-1
          IF(U(IX1,IY1,K).GT.FLAG)THEN
           Z1=(K-1)*SZ-.1
           GO TO 20
          ENDIF
         ENDDO
         GO TO 277
20       IF(Z1.LT.ZTOPPER)GO TO 277
         ICOUNTER=0
         U3=U(IX1,IY1,K)
         V3=V(IX1,IY1,K)
         W3=W(IX1,IY1,K)
         SPEED3=SQRT(U3*U3+V3*V3+W3*W3)
         WTESTER=W3/SPEED3
c         write(6,*)'wtester,top = ',wtester,top
         IF(ABS(WTESTER).LT..0.AND.TOP.GT.0.)THEN
          GO TO 277
         ELSE
          ITOP(IX1,IY1)=1
         ENDIF
21       IX1=INT(X1/SX)+1
         IX2=INT(X1/SX)+2
         IY1=INT(Y1/SY)+1
         IY2=INT(Y1/SY)+2
         IZ1=INT(Z1/SZ)+1
         IZ2=INT(Z1/SZ)+2
         IF(X1.LT.0.)THEN
          IX1=0
          IX2=1
         ENDIF
         IF(Y1.LT.0.)THEN
          IY1=0
          IY2=1
         ENDIF
         IF(Z1.LT.0.)THEN
          IZ1=0
          IZ2=1
         ENDIF
         ICOUNTER=ICOUNTER+1
         IF(ICOUNTER.GT.10000)GO TO 277
         ITESTER=0
c        write(6,*)'ix1,iy1,k,u,v,w,speed,wtester = ',
c     +             ix1,iy1,k,u3,v3,w3,speed3,wtester
c        write(6,*)'ix1,ix2,iy1,iy2,iz1,iz2 = ',ix1,ix2,iy1,iy2,iz1,iz2
         IF(IX1.LT.1.OR.IX2.GT.IMAX)GO TO 277
         IF(IY1.LT.1.OR.IY2.GT.JMAX)GO TO 277
         IF(IZ1.LT.1.OR.IZ2.GT.KMAX.OR.Z1.LT.0.)GO TO 277
         DO II=IX1,IX2
          III=II-IX1+1
          DO JJ=IY1,IY2
           JJJ=JJ-IY1+1
           DO KK=IZ1,IZ2
            KKK=KK-IZ1+1
            IF(U(II,JJ,KK).LE.FLAG)THEN
             ITESTER=1
c            WRITE(6,*)'II,JJ,KK,U,V,W = ',II,JJ,KK,
c     1      U(II,JJ,KK),V(II,JJ,KK),W(II,JJ,KK)
             GO TO 278
            ENDIF
            UU(III,JJJ,KKK)=U(II,JJ,KK)
            VV(III,JJJ,KKK)=V(II,JJ,KK)
            WW(III,JJJ,KKK)=W(II,JJ,KK)
c           WRITE(6,*)'III,JJJ,KKK,UU,VV,WW = ',III,JJJ,KKK,
c     1      UU(III,JJJ,KKK),VV(III,JJJ,KKK),WW(III,JJJ,KKK)
           ENDDO
          ENDDO
         ENDDO
278      IF(ITESTER.EQ.0)THEN
          XX1=(IX1-1)*SX
          XX2=(IX2-1)*SX
          YY1=(IY1-1)*SY
          YY2=(IY2-1)*SY
          ZZ1=(IZ1-1)*SZ
          ZZ2=(IZ2-1)*SZ
          ZXYFACT=SX*SY/SZ/SZ
          DIST(1,1,1)=(X1-XX1)*(X1-XX1)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
          IF(DIST(1,1,1).GT.0.)DIST(1,1,1)=SQRT(DIST(1,1,1))
          DIST(2,1,1)=(X1-XX2)*(X1-XX2)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
          IF(DIST(2,1,1).GT.0.)DIST(2,1,1)=SQRT(DIST(2,1,1))
          DIST(1,2,1)=(X1-XX1)*(X1-XX1)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
          IF(DIST(1,2,1).GT.0.)DIST(1,2,1)=SQRT(DIST(1,2,1))
          DIST(2,2,1)=(X1-XX2)*(X1-XX2)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ1)*(Z1-ZZ1)*ZXYFACT
          IF(DIST(2,2,1).GT.0.)DIST(2,2,1)=SQRT(DIST(2,2,1))
          DIST(1,1,2)=(X1-XX1)*(X1-XX1)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
          IF(DIST(1,1,2).GT.0.)DIST(1,1,2)=SQRT(DIST(1,1,2))
          DIST(2,1,2)=(X1-XX2)*(X1-XX2)+(Y1-YY1)*(Y1-YY1)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
          IF(DIST(2,1,2).GT.0.)DIST(2,1,2)=SQRT(DIST(2,1,2))
          DIST(1,2,2)=(X1-XX1)*(X1-XX1)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
          IF(DIST(1,2,2).GT.0.)DIST(1,2,2)=SQRT(DIST(1,2,2))
          DIST(2,2,2)=(X1-XX2)*(X1-XX2)+(Y1-YY2)*(Y1-YY2)+
     1    (Z1-ZZ2)*(Z1-ZZ2)*ZXYFACT
          IF(DIST(2,2,2).GT.0.)DIST(2,2,2)=SQRT(DIST(2,2,2))
          USUM=0
          VSUM=0
          WSUM=0
          DISTSUM=0
          DO K=1,2
           DO J=1,2
            DO I=1,2
             IF(DIST(I,J,K).EQ.0)THEN
              UX=UU(I,J,K)*FACT*SX
              VX=VV(I,J,K)*FACT*SX
              WX=WW(I,J,K)*FACT*SX
              GO TO 279
             ELSE
c              IF(DIST(I,J,K).LT..5*SX)THEN
              IF(DIST(I,J,K).LT..75*SX)THEN
c              IF(DIST(I,J,K).LT.3.*SX)THEN
               II=IX1+I-1
               JJ=IY1+J-1
               KK=IZ1+K-1
               IF(INDEX3(II,JJ,KK).LT.100)THEN
                INDEX3(II,JJ,KK)=INDEX3(II,JJ,KK)+100
               ENDIF
              ENDIF
              USUM=USUM+UU(I,J,K)/DIST(I,J,K)
              VSUM=VSUM+VV(I,J,K)/DIST(I,J,K)
              WSUM=WSUM+WW(I,J,K)/DIST(I,J,K)
              DISTSUM=DISTSUM+1./DIST(I,J,K)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
          UX=USUM/DISTSUM*FACT*SX
          VX=VSUM/DISTSUM*FACT*SX
          WX=WSUM/DISTSUM*FACT*SX
c279       WRITE(6,*)'X1,Y1,Z1 = ',X1,Y1,Z1
279       X1=X1+UX*.02*SZ/SX
          Y1=Y1+VX*.02*SZ/SX
          Z1=Z1+WX*.02*SZ/SX
c         WRITE(6,*)'UX,VX,WX,X1,Y1,Z1 = ',UX,VX,WX,X1,Y1,Z1        
          GO TO 21
         ENDIF
c277      write(6,*)'icounter = ',icounter
c        ENDDO
277     ENDDO
       ENDDO
      ENDDO
c102   DO K=1,KMAX
102   NUMINDEX=0
      NUMINDEX3=0
      DO KK=1,KMAX
       Z1=(KK-1)*SZ-.1
       DO JJ=1,JMAX
        DO II=1,IMAX
c         write(6,*)ii,jj,kk
c         write(6,*)index3(ii,jj,kk)
         IF(INDEX3(II,JJ,KK).EQ.2)INDEX3(II,JJ,KK)=1
         IF(INDEX3(II,JJ,KK).EQ.1.AND.Z1.GT.ZBOTMAX)INDEX3(II,JJ,KK)=0
         IF(INDEX3(II,JJ,KK).EQ.100.AND.Z1.GE.ZTOPMIN)THEN
          INDEX3(II,JJ,KK)=10
         ELSEIF(INDEX3(II,JJ,KK).EQ.100)THEN
          INDEX3(II,JJ,KK)=0
         ENDIF
c         write(6,*)index3(ii,jj,kk)
         IF(IBOUNDTEST.EQ.20.AND.INDEX3(II,JJ,KK).GT.0)THEN
          INDEX3(II,JJ,KK)=20
         ENDIF
c         write(6,*)index3(ii,jj,kk)
        ENDDO
       ENDDO
      ENDDO
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         IF(IBOUNDTEST.EQ.1)THEN
          IF(INDEX3(I,J,K).EQ.1.OR.INDEX3(I,J,K).EQ.11)THEN
           INDEX5(I,J,K)=INDEX5(I,J,K)+1
          ENDIF
         ELSEIF(IBOUNDTEST.EQ.10)THEN
          IF(INDEX3(I,J,K).EQ.10.OR.INDEX3(I,J,K).EQ.11)THEN
           INDEX5(I,J,K)=INDEX5(I,J,K)+1
          ENDIF
         ELSEIF(IBOUNDTEST.EQ.11)THEN
          IF(INDEX3(I,J,K).EQ.11)THEN
           INDEX5(I,J,K)=INDEX5(I,J,K)+1
          ENDIF
         ELSEIF(INDEX3(I,J,K).EQ.20)THEN
          INDEX5(I,J,K)=INDEX5(I,J,K)+1
         ENDIF
         IF(INDEX3(I,J,K).NE.0)NUMINDEX3=NUMINDEX3+1
         IF(INDEX5(I,J,K).EQ.0)THEN
          U(I,J,K)=FLAG
          V(I,J,K)=FLAG
c          W(I,J,K)=FLAG
         ELSEIF(TOP.EQ.0..AND.IBOUNDTEST.NE.1
     +          .AND.INDEX5(I,J,K).LE.1)THEN
          U(I,J,K)=FLAG
          V(I,J,K)=FLAG
c          W(I,J,K)=FLAG
         ELSE
          NUMINDEX=NUMINDEX+1
          INDEX4(I,J,K)=1
          U(I,J,K)=0
          V(I,J,K)=0
c          W(I,J,K)=0
         ENDIF
        ENDDO
       ENDDO
      ENDDO         
      WRITE(6,*)'NUMINDEX,NUMINDEX3 = ',NUMINDEX,NUMINDEX3
      RETURN
      END
      SUBROUTINE WCHECK(IMAXB,JMAXB,KMAXB,KMAX2,SUM1,SUM2,SUM3,
     + SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,INDEX1,
     + OSUMFILENAME,NFILE,SUMWTSAVE,SUMDBZ,SUMDB,
     + XWSAVE,YWSAVE,ZWSAVE,XACC,YACC,ZACC,IVRTEST,U,V,W,SZB,ZZB)
      REAL SUM1(IMAXB,JMAXB,KMAXB),SUM2(IMAXB,JMAXB,KMAXB)
      REAL SUM3(IMAXB,JMAXB,KMAXB),SUM4(IMAXB,JMAXB,KMAXB)
      REAL SUM5(IMAXB,JMAXB,KMAXB),SUM6(IMAXB,JMAXB,KMAXB)
      REAL SUM7(IMAXB,JMAXB,KMAXB),SUM8(IMAXB,JMAXB,KMAXB)
      REAL SUM9(IMAXB,JMAXB,KMAXB)
      REAL SUMWTSAVE(IMAXB,JMAXB,KMAXB)
      REAL SUM10(IMAXB,JMAXB,KMAXB),SUM11(IMAXB,JMAXB,KMAXB)
      REAL SUM12(IMAXB,JMAXB,KMAXB),SUM13(IMAXB,JMAXB,KMAXB)
      REAL U(IMAXB,JMAXB,KMAXB),V(IMAXB,JMAXB,KMAXB)
      REAL W(IMAXB,JMAXB,KMAXB)
      REAL SUMDBZ(IMAXB,JMAXB,KMAXB),SUMDB(IMAXB,JMAXB,KMAXB)
      REAL XWSAVE(IMAXB,JMAXB,KMAXB),YWSAVE(IMAXB,JMAXB,KMAXB)
      REAL ZWSAVE(IMAXB,JMAXB,KMAXB)
      REAL RHOK(200)
      INTEGER INDEX1(IMAXB,JMAXB,KMAXB)
      CHARACTER*80 OSUMFILENAME(80)
      FLAG=-1.0E+10
      write(6,*)'entered wcheck'
      DO K=1,KMAXB
       DO J=1,JMAXB
        DO I=1,IMAXB
         INDEX1(I,J,K)=0
         SUMDBZ(I,J,K)=FLAG
        ENDDO
       ENDDO
      ENDDO
      LUW=95
      DO NF=1,NFILE
       OPEN(LUW,FILE=OSUMFILENAME(NF),FORM='UNFORMATTED')
       CALL READABCD(LUW,IMAXB,JMAXB,KMAXB,SUM1,SUM2,SUM3,SUM4,
     +               SUM5,SUM6,SUM7,SUM8,SUM9,
     +               SUM10,SUM11,SUM12,SUM13,
     +    SUMDB,KMAX2,XWSAVE,YWSAVE,ZWSAVE)
       DO K=1,KMAX2
        DO J=1,JMAXB
         DO I=1,IMAXB
          IF(SUMDB(I,J,K).GT.SUMDBZ(I,J,K).AND.
     +     ABS(XWSAVE(I,J,K)).LT.XACC.AND.
     +     ABS(YWSAVE(I,J,K)).LT.YACC.AND.
     +     ABS(ZWSAVE(I,J,K)).LT.ZACC)SUMDBZ(I,J,K)=SUMDB(I,J,K)  
          IF((SUM3(I,J,K).EQ.0.AND.SUM5(I,J,K).EQ.0.AND.
     +     SUM8(I,J,K).EQ.0.).OR.
     +      ABS(XWSAVE(I,J,K)).GT.XACC.OR.
     +      ABS(YWSAVE(I,J,K)).GT.YACC.OR.
     +      ABS(ZWSAVE(I,J,K)).GT.ZACC)THEN
            U(I,J,K)=FLAG
            V(I,J,K)=FLAG
            W(I,J,K)=FLAG
          ELSE 
            U(I,J,K)=0
            V(I,J,K)=0
            W(I,J,K)=0
            INDEX1(I,J,K)=INDEX1(I,J,K)+1
c            WRITE(6,*)'I,J,K,INDEX1 = ',I,J,K,INDEX1(I,J,K)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
       CLOSE(LUW)
      ENDDO
      write(6,*)'leaving wcheck'
      DO K=1,KMAXB
       DO J=1,JMAXB
        DO I=1,IMAXB
         IF(INDEX1(I,J,K).GE.IVRTEST)THEN
          INDEX1(I,J,K)=1
c          WRITE(6,*)'PASSED TEST I,J,K,INDEX1 = ',
c     1     I,J,K,INDEX1(I,J,K)
         ELSE
          INDEX1(I,J,K)=0
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE WREL(U,V,IMAXB,JMAXB,KMAXB,SMOTIONU,SMOTIONV,ZZB,SZB)
      REAL U(IMAXB,JMAXB,KMAXB),V(IMAXB,JMAXB,KMAXB),RHOK(100)
      OPEN(92,FILE='recalc')
      DO K=1,KMAXB
       HEIGHT=ZZB+(K-1)*SZB
       RHOK(K)=EXP(-HEIGHT*.10437052)
       DO J=1,JMAXB
        WRITE(92,*)'BEFORE REL J,K = ',J,K
        WRITE(92,100)(U(I,J,K),I=1,IMAXB)
        DO I=1,IMAXB
         IF(U(I,J,K).GT.-200.)THEN
          U(I,J,K)=U(I,J,K)-SMOTIONU*RHOK(K)
          V(I,J,K)=V(I,J,K)-SMOTIONV*RHOK(K)
         ENDIF
        ENDDO
        WRITE(92,*)'AFTER REL J,K = ',J,K
        WRITE(92,100)(U(I,J,K),I=1,IMAXB)
 100    FORMAT(8F10.2)
       ENDDO
      ENDDO
      CLOSE(92)
      RETURN
      END




