	program dump_headers
C changed back to formatted out put so Paul's
C python code can work with the dumped headers. 16 May 2018
C changed to unformatted output 22 July 2016
C added ws, wd and vws to output 28 july 2016
CRead a list of sweeps, open each sweep, read in and then sort rays bytime and
C then output extended header values, to enable
C plotting time series of ine vs gps locations and flight level a/c motions
C 6 May 2015
C note this code is ugly as is created by cutting down and adding to
C rvp8 display routines
CC
C June 13 2018...had to add argument to indicate
C starting date of flight as midnight may have
C been crossed by the time this is called. Can this code get any uglier?
C
C==== ddeclarations ================================
	implicit none 
	integer nh, num_rays 
	integer i,j, itemp
	real p_ave,d_ave,r_ave,lat_ave,lon_ave
	real wspd_ave, wdir_ave, vws_ave
	real airs_age_ave, gps_age_ave, aamps_age_ave
C header flags:
	integer*4 nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag

	integer max_rays, max_gates
	parameter(max_rays = 500, max_gates = 2048)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, sweeps_list
	integer list_lu
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
C  this make latest external header availe:
	include "TDR_hdr_common.f"
 
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_si
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	real sweep_start_time
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
	type ( TDR_hdr ) air_hdr(max_rays)



C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C array of flags to select data
	integer data_sel_flags(3)
C
	real good_time(max_rays)
C
	character*132 swp_fn
	character prefix*15, ext_fn*19
C
	integer year,day

	integer jday_start,jday
 
	integer igood_read
	integer isweep, ifl, ir
	integer num_sweeps, num_bins(max_rays)
	integer ir_want, ifl_want
	real dt_min, del_time
C shit for midnight crossing:
	real day_secs
	logical first_sweep
	integer*4 flt_st_yr, flt_st_month, flt_st_day

C added array to hold pointers for proper temporal sequencing of rays
	integer ray_tbl(max_rays)
	integer out_lu
C === end declarations =========================
C
C default data types to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	day_secs = 24.0 * 3600.0
	first_sweep = .true.
C

	igood_read = 1 ! for testing io_error in get tdr ray
	nav_flag = 2
	alt_flag = 2
	attitude_flag = 1
	gdspd_flag = 1
	wind_flag = 3

	call set_hdr_flags(nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag)
c
C First read starting date from /dev/shm/FLID and set jday_start:
	open(10,file='/dev/shm/FLID',form='formatted',status='OLD')
	read(10,'(i4.4,i2.2,i2.2)')flt_st_yr,flt_st_month, flt_st_day
	close(10)
	call cal_to_mjd(flt_st_yr,flt_st_month,flt_st_day,jday_start)
	write(6,987)flt_st_yr,flt_st_month,flt_st_day,jday_start
987	format("Flight start: ",i4,1x,i2,1x,i2,1x,"mod Julday", i6)
C get sweep file list:
	call getarg(1,sweeps_list)
	if(sweeps_list .eq. ' ')then
	  write(6,*)'enter sweep file listname:'
	  read(5,'(a)')sweeps_list
	end if
C
	list_lu = 10
	out_lu = 11
	open(list_lu,file=sweeps_list,form="formatted")
C following changed 30 August 2018 so a new file
C is opened each time...to avoid endless reading of last
C instance fo file when new one should be empty because of empty
C sweeps list.
	open(out_lu,file="rvp8_hdr_dump.dat",form="formatted",
     +		status = 'replace')
C)
cout	  write(out_lu, 1234)
1234	format("ray_time,gps lat,long,airs lat,long",
     +  "gps vel_e, vel_n, vel_v, airs vel_e, vel_n,vel_v,",
     +  "pitch,roll,drift,",
     +  "gps_age, airs_age, swp fn")

C ======  open file, read in data, save array of hdrs..
C
123	read(list_lu,'(a)', end=999, err=999)sweep_fn
	call open_iris_file(swp_lu, sweep_fn, iostat)
C Only need to do thisfor first file, if at all...
	if(first_sweep)then
	call check_byte_swapping(swp_lu, swapped)
	first_sweep = .false.
	end if
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	call read_product_hdr(0, prod_conf, prod_end)
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C print task_calib_info.flag bits
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a do loop here.
	num_sweeps = t_scan%num_sweeps
C change 19 June 2012
C file with multiple sweeps will list more than one
C associated file for each variable...
	num_fields = i_config%num_assoc_files/num_sweeps
C
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	start_time_str = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, start_time_str)
	time = start_time_str%seconds + is100 * 0.01

	sweep_start_time= time
C now deal with  blessed midnight crossing
C Modified 13 June 2018 so that jday_start is specified at start
C from flight argument instead of for first sweep in list!
C
	call cal_to_mjd(iyear,month,iday,jday)

cout	if(first_sweep)then
cout	  first_sweep = .false.
cout	  jday_start = jday
cout	end if
	sweep_start_time = sweep_start_time +(jday -jday_start)*day_secs	
C dump ingest data header variavles

	num_rays = idh(1)%num_rays_in_file
cout	call flush(6)

C finally read the rays and expand the data, including the extended headers
	  num_rays = idh(num_fields)%expected_num_rays
	  do i = 1, num_rays

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		write(6,*)'crud. read ray error: ', io_error
		go to 333 ! break out
	   end if
C update time:
	  good_time(i) = sweep_start_time + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	  call convert_time(good_time(i),ih,im,is)
	  is100 = (time-ih*3600.0-im*60.0-is)*100
C
	   num_bins(i) = rh(i)%num_bins_in_ray
	  end do ! rays loop

	  if(nrem .gt. 0) then
	     call skip_iris_words(swp_lu, nrem)
	     nrem = 0
	  end if
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)

C ===============================
C check hdrs for age, weird values...
	nh = 0
	p_ave = 0
	d_ave = 0
	r_ave = 0
	lat_ave = 0
	lon_ave = 0
	wspd_ave = 0
	wdir_ave = 0
	vws_ave = 0
	airs_age_ave = 0
	gps_age_ave = 0
	aamps_age_ave = 0
c
	do i = 1, num_rays
	 if(num_bins(i).gt.0) then
	  gps_age = air_hdr(i)%gps_age    ! /**< Time in milliseconds since last GPS Input */
		  airs_age = air_hdr(i)%irs_age    ! /**< Time in milliseconds since last IRS Input */
			  aamps_age = air_hdr(i)%aamps_age  ! /**< Time in milliseconds since last AAMPS Input */	 i
		 nh= nh + 1
	  call read_TDR_hdr(0, air_hdr(i))

	  p_ave = p_ave + pitch
	  d_ave = d_ave + drift
	  r_ave = r_ave + roll
	  lat_ave = lat_ave + rlat
	  lon_ave = lon_ave + rlon
	  wspd_ave = wspd_ave + ws
	  wdir_ave = wdir_ave + wd
	  vws_ave = vws_ave + vws
	  airs_age_ave = airs_age_ave + airs_age
	  gps_age_ave = gps_age_ave + gps_age
	  aamps_age_ave = aamps_age_ave + aamps_age
	 end if
	end do
C
	if(nh .gt. 0) then
	p_ave = p_ave / nh
	d_ave = d_ave / nh
	r_ave = r_ave / nh
	lat_ave = lat_ave / nh
	lon_ave = lon_ave / nh
	wspd_ave = wspd_ave/nh
	wdir_ave = wdir_ave/nh
	vws_ave = vws_ave/nh
	airs_age_ave = airs_age_ave/nh
	gps_age_ave = gps_age_ave/nh
	aamps_age_ave = aamps_age_ave/nh
C
C 
cout	write(6,*)'Mum non-zero rays: ',nh
cout	write(6,1205)lat_ave, lon_ave
1205	format("Lat, Lon: ",2(1x,f7.2) )
cout	write(6,1215)p_ave, r_ave, d_ave
1215	format('Pitch, Drift, Roll: ',3(1x,f5.2) )
cout	write(6,1251)wspd_ave, wdir_ave, vws_ave
1251	format( "Wind dir, spd, vert spd: ", 3(1x,f7.2))
cout	write(6,1252)airs_age_ave,gps_age_ave,aamps_age_ave
1252	format(" Ages (msec) irs,gps, aamps: ",3(1x,f8.1) )
C
	else
	  write(6,*)sweep_fn,' has no non-zero rays'
	end if

C now sort the rays in time and write out desired extended header information:
	do i = 1, num_rays
		ray_tbl(i) = i
	end do
	do i = 1, num_rays
	  do j = i+1,num_rays
		if(good_time(ray_tbl(j)).lt.good_time(ray_tbl(i)))then
		  itemp = ray_tbl(i)
		  ray_tbl(i) = ray_tbl(j)
		  ray_tbl(j) = itemp
		end if
C i know...slow bubble sort
	  end do
	end do
C fucking debug statement:
cout	write(6, 4321)ray_tbl(1),good_time(ray_tbl(1))
cout	write(6,4321)ray_tbl(num_rays), good_time(ray_tbl(num_rays))
4321	format('ray ptr: ',i3,1x,f10.3)
	do i = 1, num_rays
	  if(num_bins(ray_tbl(i)).gt.0) then
C read header again to load up commn block with all the decoded values.
	  call read_TDR_hdr(0, air_hdr(ray_tbl(i)))
C check for spikes in gps data:
	if((gps_vel_e.le.-1000.0).or.(gps_vel_e.ge.1000.0).or.
     +	 (gps_vel_n.le.-1000.0) .or. (gps_vel_n.ge. 1000.0) .or.
     +	(gps_vel_v.lt.-1000.0).or.(gps_vel_v.gt.1000.0))then
	  write(6,*)'WTF gps u,v, w :  ',gps_vel_e, gps_vel_n,gps_vel_v
C and flag gps vels as bad!
	   gps_vel_n = -999.0
	gps_vel_e = -999.0
	  gps_vel_v = -999.0
C
	end if

	call wrt_hdr(out_lu,good_time(ray_tbl(i)),sweep_fn)
	end if
	end do


C get another sweep and do all over again
	go to 123
C
999	close(list_lu)
	close(out_lu)
	end
