C Link to this instead of hplib to write plot 10 stuff to X windows.
C Call c code in plot10_xlib_functions.c
C Only reason I need this Fortran shell is so that I can 
C hide the structure that holds X info that I pass to C code
C Mod 28 March 2007 to include ibkgd_fgd in post_guphe
C If ibkgd_fgd = 2 then on X window I am using white on black blgd, 
C but I dont want that for PS output, so new pn needs to know.
	subroutine initl(plotter, ires, iwid, iht, im1, im2, im3)
	integer plotter, ires, iwid, iht, im1, im2, im3
	integer error
	character*64 outfile
	character*80 string 
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
	data ifirst/ 1/ ! on next call will be 2 etc...
	data ipst_cap / 0/
	data scale /1.0 /
C
	if( plotter .gt. 0) then ! X Windows stuff
	   ibkgd_fgd = im1
	   if( ifirst .eq. 1)then
	 	width_in = iwid * 0.1
	  	height_in = iht * 0.1
		call my_initl( width_in, height_in, ibkgd_fgd,
     +			im_struct, error)
		im3 = error
		write(6,*) 'arrange window then hit return.'
		read(5,*)
		ifirst = ifirst + 1
	    else ! we are drawing a new plot in this window, so clear it
		call clear_it(ibkgd_fgd, im_struct)
	    end if
	else if( plotter .lt. 0 )then ! turn on postscript capture
	    ipst_cap = 1
	    ipst_file = im1 ! i/o unit, so no clash with units open in main
	    ifont_pts = im2 ! font size in points ( 1/72 of inch)
	    ipage_orien = im3 ! 0 - portrait (default), 1 - landscape
	    write(6,*)' Enter postscript output file (< 64 ch): '
	    read(5,'(a)')outfile
	    open(ipst_file, file = outfile, form = 'formatted')
C write prologue to file. This contains procedure definitions etc.
	    in = ipst_file + 1 
	    open(in, file = '/home/peter/graphic_subs.d/ps_prolog.dat',
     +      	form = 'formatted', status = 'old')
COUT	    open(in, file = 'ps_prolog.dat',
COUT  +      	form = 'formatted', status = 'old')
	    do i = 1, 4
		read(in,11,end = 12)string
11		format(a) 
		write(ipst_file,11)string
	    end do
	    iur_x = iwid * 7.2 ! inches x 10 to points
	    iur_y = iht *7.2
	    write(ipst_file,111)0,0, iur_x, iur_y
111	    format('%%BoundingBox:',4(1x,i4))
10	    read(in,11,end = 12)string
	    write(ipst_file,11)string
      	    go to 10
12	    close(in) 
	    xp0 = 0.0
	    yp0 = 0.0
C If needed, set for landscape mode:
	    if( ipage_orien .eq. 1 ) then
		write(ipst_file,*)'% Set to landscape orientation'
		write(ipst_file,*)' 90 rotate'
		write(ipst_file,*)' 0 -612 translate'
	    end if
C Set font
	    write(ipst_file, *)'/Times-Roman findfont'
	    write(ipst_file, *)ifont_pts,' scalefont'
	    write(ipst_file, *)'setfont'
	end if
	return
	end
C ======================================================
	subroutine init_ps_plot(ires, iwid, iht, im1, im2, im3, ps_file)
C ue this to initiaite PS plotting without user input
	integer plotter, ires, iwid, iht, im1, im2, im3
	integer error
	character*(*) ps_file
	character*80 string 
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
	data ifirst/ 1/ ! on next call will be 2 etc...
	data ipst_cap / 0/
	data scale /1.0 /
C
	    ipst_cap = 1
	    ipst_file = im1 ! i/o unit, so no clash with units open in main
	    ifont_pts = im2 ! font size in points ( 1/72 of inch)
	    ipage_orien = im3 ! 0 - portrait (default), 1 - landscape
Cout	    write(6,*)' Enter postscript output file (< 64 ch): '
Cout	    read(5,'(a)')outfile
	    open(ipst_file, file = ps_file, form = 'formatted')
C write prologue to file. This contains procedure definitions etc.
	    in = ipst_file + 1 
	    open(in, file = '/home/peter/graphic_subs.d/ps_prolog.dat',
     +      	form = 'formatted', status = 'old')
COUT	    open(in, file = 'ps_prolog.dat',
COUT  +      	form = 'formatted', status = 'old')
	    do i = 1, 4
		read(in,11,end = 12)string
11		format(a) 
		write(ipst_file,11)string
	    end do
	    iur_x = iwid * 7.2 ! inches x 10 to points
	    iur_y = iht *7.2
	    write(ipst_file,111)0,0, iur_x, iur_y
111	    format('%%BoundingBox:',4(1x,i4))
10	    read(in,11,end = 12)string
	    write(ipst_file,11)string
      	    go to 10
12	    close(in) 
	    xp0 = 0.0
	    yp0 = 0.0
C If needed, set for landscape mode:
	    if( ipage_orien .eq. 1 ) then
		write(ipst_file,*)'% Set to landscape orientation'
		write(ipst_file,*)' 90 rotate'
		write(ipst_file,*)' 0 -612 translate'
	    end if
C Set font
	    write(ipst_file, *)'/Helvetica findfont'
	    write(ipst_file, *)ifont_pts,' scalefont'
	    write(ipst_file, *)'setfont'
	return
	end
C ==========================================================================
	subroutine plot(x, y, ipen)
	real x, y
	integer ipen
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts,ibkgd_fgd
	call my_plot(x, y, ipen, im_struct)
	if( ipst_cap .eq. 1 ) then
	   call my_ps_plot(x, y, ipen, ipst_file, 
     +		xp0, yp0, scale, last_pen)
	   last_pen = ipen
	end if
	return
	end
C ================================================================
	subroutine newpn( ipen)
	integer ipen
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
	call my_newpn(ipen, im_struct)
	if( ipst_cap .eq. 1) then
		call my_ps_newpn( ipen, ipst_file, last_pen, ibkgd_fgd)
	end if
	return
	end
C =================================================================
	subroutine symbl(x, y, csize, istring, orien, num_ch)
	real x, y, csize, orien
	integer num_ch
	integer*2 istring(50)
	character string*100
C X Lib doesn't support rotated text, so I ignore orien for time being
C Also right now I ignore csiz, although I could load different fonts
C
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts,ibkgd_fgd 
C
	nwds = nint( (num_ch+1) * 0.5)
	write(string,100)(istring(i), i = 1, nwds)
100	format(50(a2))
COUT	write(6,*)' Attempting to write string :',string
	if( csize .lt. 0.0) then
		call my_symbl(x, y, -num_ch, im_struct, string)
	else
		call my_symbl(x, y, num_ch, im_struct, string)
	end if
	if( ipst_cap .eq. 1 ) then ! ps can handle rotated text
		new_font_pts = nint(ifont_pts * scale)
		if( new_font_pts .ne. ifont_pts ) then ! resize font
		   write(ipst_file, *)'/Times-Roman findfont'
		   write(ipst_file, *)new_font_pts,' scalefont'
		   write(ipst_file, *)'setfont'
		end if
		if( csize .lt. 0.0) then
		call my_ps_symbl(x, y, -num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale)
		else
		call my_ps_symbl(x, y, num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale)
		end if
	end if
	return
	end
C =====================================================================
	subroutine rstr(icode)
	integer icode
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
C
	call my_plot(0.0, 0.0, 998, im_struct)
	if( ipst_cap .eq. 1 ) then
		call my_ps_plot(0.0, 0.0, 998, ipst_file, 
     +			xp0, yp0, scale, last_pen)
	end if
	return
	end
C =================================================================
	subroutine numbr(x, y, csize, data, rotation, nfrac)
C Plots real numbers, using nfrac decimal places.
	real x, y, csize, data, rotation
	integer nfrac
	integer whole
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
	character rm_str*10, wh_str*10, outstring*22
	integer*2 istring(11)
C I do the formatting here and pass to C function for printing.
	outstring = ' '
	wh_str = ' '
	rm_str = ' '
	if( nfrac .le. 0) then ! round integer part
	   whole = nint(abs(data) )
	   if( data .lt. 0) whole = -whole
	   if( abs(whole) .ge. 1)then
		nw = int( log10( float(abs(whole)) )) + 1
		write(wh_str,'(i10)')whole
		if (data .lt. 0.0) then
			nw = nw + 1
		end if
	   else if (whole .eq. 0) then
		if( data .lt. 0.0) then
		   nw = 2
		   wh_str(9:10) = '-0'
		else
		   nw = 1
		   wh_str(10:10) = '0'
		end if
	   end if
	   if( nfrac .eq. 0) then
	  	outstring = wh_str(11-nw:10)//'.'
	  	num_ch = nw + 1
	   else if( nfrac .lt. 0) then
	  	outstring = wh_str(11-nw:10)
	  	num_ch = nw
	   end if
	else ! nfrac > 0  ..................................................
C Max decimal pts i allow is 10, and 53 places on other side...
	   if( nfrac .gt. 10)then
		iend = 10
	   else
		iend = nfrac
	   end if
C extract the decimal part
	   whole = int( data ) ! NOT nint...
	   write(outstring,'(i20)')nint(data * 10.0 **nfrac)
	   do i = 1, nfrac
		rm_str(11-i:11-i) = outstring(21-i:21-i)
	   end do
	   if( abs(whole) .gt. 0 )then
		nw = int( log10( float(abs(whole)) )) + 1
		write(wh_str,'(i10)')whole
		if (data .lt. 0.0) then
			nw = nw + 1
		end if
	else if (whole .eq. 0) then
		if( data .lt. 0.0) then
		   nw = 2
		   wh_str(9:10) = '-0'
		else
		   nw = 1
		   wh_str(10:10) = '0'
		end if
	end if
	num_ch = nw + 1 + nfrac
	outstring = wh_str(11-nw:10)//'.'//rm_str(11-nfrac:10)
	end if ! .......................................................
	read(outstring,'(11a2)')(istring(i), i = 1,11)
cd	write(6,*)'For value', data,' Outstring is ',outstring,
cd    +			' num_ch', num_ch
	call symbl(x, y, csize, istring, rotation, num_ch)
	return
	end
C -------------
	subroutine plot10_circle(x, y, radius, w, vis)
	real x, y, radius, w(4)
	logical vis, down
C
	common /hideyhole/ im_struct(30)
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
C
	if( ipst_cap .eq. 1 ) then
C turn off ps out put, so pen draws not saved to file
	   ipst_cap = -100
	end if
	vis = .false.
	if(inside(x+radius,y,w).eq.0)then
		down = .true.
		call plot(x + radius, y, 3)
	else
		down = .false.
	end if
	do i = 2, 360, 2
		  ang = i
		  dx = radius * cosd(ang)
		  dy = radius * sind(ang)
		  xn = x + dx
		  yn = y + dy
		  if( inside(xn,yn,w) .eq. 0) then
			if(down) then
			  call plot(xn, yn, 2)
			  vis = .true. ! drew an arc
		  	else
			  down = .true.
  			  call plot(xn, yn, 3)
			end if
		  else
			down = .false.
		  end if
	end do
	if( ipst_cap .eq. -100 ) then
		ipst_cap = 1 ! restore
C and make Postscript code to draw circle, clipped to window defined by w
		if( vis ) then ! part of arc visible, so do postscript circle
		   call my_ps_circle(x, y, radius, w, ipst_file, scale)
		end if
	end if
	return
	end
C ---
	subroutine penup
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts
	if( ipst_cap .eq. 1 ) then
	   last_pen = 3
	end if
	return
	end
C ----
	subroutine pendn
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts,ibkgd_fgd
	if( ipst_cap .eq. 1 ) then
	   last_pen = 2
	end if
	return
	end
C -----
	subroutine factr(ratio)
C This is called to scale a plot. So need to add appropriate
C PostScript code later....
	common /post_guphe/ipst_cap, ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, ibkgd_fgd
	scale = ratio
	return
	end
