$ tables off
$ pagewidth 132
	subroutine pack_row(bits, nbytes, compar, maxcomp, ncomp)
C Fortran 77 version of packer.c from CBM IFF disk (Fred Fish # 184)
	integer nbytes, ncomp, maxcomp
	integer bits(0:nbytes), compar(0:maxcomp), buf(0:256)
	integer current, lastc, mode, dump, run, row_size, outptr,
     +		rstart
	parameter( dump = 0, run = 1, min_run = 3, max_run = 128,
     +		max_dat = 128)
C
	rstart = 0
	row_size = nbytes + 1
	mode = dump
	outptr = 0
	current = bits(0)
	lastc = current
	buf(0) = lastc
	nbuf = 1
	inptr = 1
	row_size = row_size - 1
Cout	do while( row_size .gt. 0)
	do while( inptr .le. nbytes )
		current = bits( inptr )
		inptr = inptr + 1
		buf(nbuf) = current
		nbuf = nbuf + 1
		row_size = row_size - 1
C DUMP:
		if( mode .eq. dump ) then
		  if( nbuf.gt. max_dat ) then
			call PutDump(buf,nbuf-1,compar,maxcomp,outptr)
			buf(0) = current
			nbuf = 1
			rstart = 0
		  else if(current .eq. lastc) then
		    if( nbuf - rstart .ge. min_run) then
			if( rstart .gt. 0) then
				call PutDump(buf,rstart,compar,
     +					maxcomp,outptr)
			end if
			mode = run
		    else if(rstart .eq.  0) then
			mode = run
		    end if
		  else
		    rstart = nbuf - 1
		  end if
C RUN:
		else if(mode .eq. run)then
		  if( ( current .ne. lastc) .or. 
     +			(nbuf - rstart .gt. max_run) ) then
			call PutRun(nbuf-1-rstart,lastc,
     +				compar,maxcomp,outptr)
			buf(0) = current
			nbuf = 1
			rstart = 0
			mode = dump
		  end if
		end if
		lastc = current
	end do
C now dump the last stuff
	if( mode .eq. dump) then
		call PutDump(buf,nbuf,compar, maxcomp, outptr)
	else
		call PutRun(nbuf-rstart,lastc,compar,maxcomp, outptr)
	end if
	ncomp = outptr - 1 ! because outptr always pointed to next byte
	return
	end
C -------------------------------------------------------
	subroutine PutRun( nr, ival, dest, maxout, outptr)
	integer nr, ival, dest(0:maxout), outptr
C
	dest(outptr) = - (nr -1)
	dest(outptr+1) = ival
	outptr = outptr + 2
	return
	end
C -------------------------------------------------------
	subroutine PutDump(buf, nd, dest,maxout, outptr)
	integer buf(0:128), nd, ival, dest(0:maxout), outptr
C
	dest(outptr) = nd - 1
	do i = 0, nd-1
		outptr = outptr + 1
		dest(outptr) = buf(i)
	end do
	outptr = outptr + 1
	return
	end




