      PROGRAM RADAZI
      REAL AZI(400),RLATITUDE(400),RLONGITUDE(400)
      REAL SUMSIN(400),SUMCOS(400),SUM(400),RALT(400),SUMRA(400)
      REAL SUMRLAT(400),SUMRLON(400),SUMSECS(400),SECS(400)
      REAL SUMWIND(400),SUMU(400),SUMV(400),SUMW(400),SUMVGW(400)
      REAL U(400),V(400),W(400),VGW(400),X(400),Y(400),Z(400)
      REAL SUMX(400),SUMY(400),SUMZ(400)
      CHARACTER*1 CDUMMY
      DO I=1,400
       SUMSIN(I)=0.
       SUMCOS(I)=0.
       SUM(I)=0.
       SUMRA(I)=0.
       SUMRLAT(I)=0.
       SUMRLON(I)=0.
       SUMSECS(I)=0.
       SUMWIND(I)=0.
       SUMU(I)=0.
       SUMV(I)=0.
       SUMW(I)=0.
       SUMVGW(I)=0.
       SUMX(I)=0.
       SUMY(I)=0.
       SUMZ(I)=0.
      ENDDO
      OPEN(77,FILE='inoutradazi.txt')
      OPEN(78,FILE='jobfile_radar_profile_in')
      READ(78,*)CDUMMY
      READ(78,*)CDUMMY
      READ(78,'(3I2,1X,3I2)')ISH,ISM,ISS,IEH,IEM,IES
      READ(78,*)CDUMMY
      READ(78,*)CDUMMY
      READ(78,*)CDUMMY
      READ(78,*)SR
      ISTART=ISH*10000+ISM*100+ISS
      IEND=IEH*10000+IEM*100+IES
1     READ(77,*,END=999)INOUT,RADIUS,AZIMUTH,ITIME,RA,RLAT,RLON,
     + UIN,VIN,WIN,VGWIN,XX,YY,ZZ
      IHOURS=ITIME/10000
      IMINS=(ITIME-IHOURS*10000)/100
      ISEC=ITIME-IHOURS*10000-IMINS*100
      ISCS=IHOURS*3600+IMINS*60+ISEC
c      WRITE(6,*)ITIME,ISCS
      IF(INOUT.EQ.1)THEN
       IRAD=NINT(RADIUS/SR)
       IF(IRAD.GE.1.AND.IRAD.LE.400.AND.
     1  ITIME.GE.ISTART.AND.ITIME.LE.IEND.AND.AZIMUTH.GT.-900.)THEN
        SUM(IRAD)=SUM(IRAD)+1.
        SINE=SIN(AZIMUTH*3.14159/180.)
        COSINE=COS(AZIMUTH*3.14159/180.)
        SUMSIN(IRAD)=SUMSIN(IRAD)+SINE
        SUMCOS(IRAD)=SUMCOS(IRAD)+COSINE
        SUMRA(IRAD)=SUMRA(IRAD)+RA
        SUMRLAT(IRAD)=SUMRLAT(IRAD)+RLAT
        SUMRLON(IRAD)=SUMRLON(IRAD)+RLON
        SUMSECS(IRAD)=SUMSECS(IRAD)+ISCS
        SUMX(IRAD)=SUMX(IRAD)+XX
        SUMY(IRAD)=SUMY(IRAD)+YY
        SUMZ(IRAD)=SUMZ(IRAD)+ZZ
       ENDIF
       IF(IRAD.GE.1.AND.IRAD.LE.400.AND.
     1  ITIME.GE.ISTART.AND.ITIME.LE.IEND.AND.WIN.GT.-900.)THEN
        SUMWIND(IRAD)=SUMWIND(IRAD)+1.
        SUMW(IRAD)=SUMW(IRAD)+WIN
        SUMU(IRAD)=SUMU(IRAD)+UIN
        SUMV(IRAD)=SUMV(IRAD)+VIN
        SUMVGW(IRAD)=SUMVGW(IRAD)+VGWIN
       ENDIF
      ENDIF
      GO TO 1
999   DO I=1,400
       IF(SUM(I).GT.0.)THEN
        SINE=SUMSIN(I)/SUM(I)
        COSINE=SUMCOS(I)/SUM(I)
        ANG=ATAN2(SINE,COSINE)*180./3.14159
        IF(ANG.GT.360.)ANG=ANG-360.
        IF(ANG.LT.0.)ANG=ANG+360.
        AZI(I)=ANG
        RALT(I)=SUMRA(I)/SUM(I)
        RLATITUDE(I)=SUMRLAT(I)/SUM(I)
        RLONGITUDE(I)=SUMRLON(I)/SUM(I)
        SECS(I)=SUMSECS(I)/SUM(I)
        X(I)=SUMX(I)/SUM(I)
        Y(I)=SUMY(I)/SUM(I)
        Z(I)=SUMZ(I)/SUM(I)
       ELSE
        AZI(I)=-999.9
        RALT(I)=-999.9
        RLATITUDE(I)=-999.9
        RLONGITUDE(I)=-999.9
        SECS(I)=-999.9
        X(I)=-999.9
        Y(I)=-999.9
        Z(I)=-999.9
       ENDIF
       IF(SUMWIND(I).GT.0.)THEN
        W(I)=SUMW(I)/SUMWIND(I)
        U(I)=SUMU(I)/SUMWIND(I)
        V(I)=SUMV(I)/SUMWIND(I)
        VGW(I)=SUMVGW(I)/SUMWIND(I)
       ELSE
        W(I)=-999.9
        U(I)=-999.9
        V(I)=-999.9
        VGW(I)=-999.9
       ENDIF
      ENDDO
      OPEN(75,FILE='aziradin')
      WRITE(75,'(8F10.4)')(AZI(I),I=1,400)
      WRITE(75,'(8F10.4)')(RALT(I),I=1,400)
      WRITE(75,'(8F10.4)')(RLATITUDE(I),I=1,400)
      WRITE(75,'(8F10.4)')(RLONGITUDE(I),I=1,400)
      WRITE(75,'(8F10.3)')(SECS(I),I=1,400)
      WRITE(75,'(8F10.3)')(U(I),I=1,400)
      WRITE(75,'(8F10.3)')(V(I),I=1,400)
      WRITE(75,'(8F10.3)')(W(I),I=1,400)
      WRITE(75,'(8F10.3)')(VGW(I),I=1,400)
      WRITE(75,'(8F10.3)')(X(I),I=1,400)
      WRITE(75,'(8F10.3)')(Y(I),I=1,400)
      WRITE(75,'(8F10.3)')(Z(I),I=1,400)
      STOP
      END

