C 	sigmet_dsp_data_types_f90.h
C  /* SIGMET IRIS data typse, lifted friom the IRIS docs */

	integer*2 DB_XHDR   ! /* Extended Headers */
	integer*2 DB_DBT   ! /* Total power  1 byte */ 
	integer*2 DB_DBZ    ! /* Reflectivity  1 byte */ 
	integer*2 DB_VEL   ! /* Velocity  1 byte */ 
	integer*2 DB_WIDTH    ! /* Width  1 byte */ 
	integer*2 DB_ZDR   ! /* Differential reflectivity  1 byte */ 
	integer*2 DB_DBZC    ! /* Corrected reflectivity  1 byte */ 
	integer*2 DB_DBT2    ! /* Total power  2 byte */ 
	integer*2 DB_DBZ2    ! /* Reflectivity  2 byte */ 
	integer*2 DB_VEL2    ! /* Velocity  2 byte */ 
	integer*2 DB_WIDTH2    ! /* Width  2 byte */ 
	integer*2 DB_ZDR2    ! /* Differential reflectivity  2 byte */ 
	integer*2 DB_RAINRATE2    ! /* Rainfall rate  2 byte */ 
	integer*2 DB_KDP  ! /* KDP Differential phase   1 byte */ 
	integer*2 DB_KDP2   ! /* KDP  Differential phase   2 byte */ 
	integer*2 DB_PHIDP    ! /* PhiDP Differential phase   1 byte */ 
	integer*2 DB_VELC    ! /* Corrected velocity  1 byte */ 
	integer*2 DB_SQI    ! /* SQI  1 byte */ 
	integer*2 DB_RHOHV    ! /* RhoHV  1 byte */ 
	integer*2 DB_RHOHV2    ! /* RhoHV  2 byte */ 
	integer*2 DB_DBZC2    ! /* Corrected Reflectivity  2 byte */ 
	integer*2 DB_VELC2    ! /* Corrected velocity  2 byte */ 
	integer*2 DB_SQI2    ! /* SQI  2 byte */ 
	integer*2 DB_PHIDP2    ! /* PhiDP  Differential phase   2 byte */ 
	integer*2 DB_LDRH    ! /* LDR xmt H, rcv V  1 byte */ 
	integer*2 DB_LDRH2    ! /* LDR xmt H, rcv V  2 byte */ 
	integer*2 DB_LDRV   ! /* LDR xmt V, rcv H  1 byte */ 
	integer*2 DB_LDRV2   ! /* LDR xmt V, rcv H  2 byte */ 
C /* 29 to 31 not yet used */
	integer*2 DB_HEIGHT    ! /* Height  1/10 km   1 byte */
	integer*2 DB_VIL2  ! /* Linear liquid .001 mm 2 byte */

C  set the values of the constans
	parameter (DB_XHDR =  0 ) ! /* Extended Headers */
	parameter (DB_DBT = 1 ) ! /* Total power  1 byte */ 
	parameter (DB_DBZ = 2  ) ! /* Reflectivity  1 byte */ 
	parameter (DB_VEL = 3 ) ! /* Velocity  1 byte */ 
	parameter (DB_WIDTH =  4  ) ! /* Width  1 byte */ 
	parameter (DB_ZDR = 5  ) ! /* Differential reflectivity  1 byte */ 
	parameter (DB_DBZC = 7  ) ! /* Corrected reflectivity  1 byte */ 
	parameter (DB_DBT2 = 8  ) ! /* Total power  2 byte */ 
	parameter (DB_DBZ2 = 9  ) ! /* Reflectivity  2 byte */ 
	parameter (DB_VEL2 = 10  ) ! /* Velocity  2 byte */ 
	parameter (DB_WIDTH2 = 11  ) ! /* Width  2 byte */ 
	parameter (DB_ZDR2 = 12  ) ! /* Differential reflectivity  2 byte */ 
	parameter (DB_RAINRATE2 = 13  ) ! /* Rainfall rate  2 byte */ 
	parameter (DB_KDP = 14 ) ! /* KDP Differential phase   1 byte */ 
	parameter (DB_KDP2 = 15 ) ! /* KDP  Differential phase   2 byte */ 
	parameter (DB_PHIDP = 16  ) ! /* PhiDP Differential phase   1 byte */ 
	parameter (DB_VELC = 17  ) ! /* Corrected velocity  1 byte */ 
	parameter (DB_SQI = 18  ) ! /* SQI  1 byte */ 
	parameter (DB_RHOHV = 19  ) ! /* RhoHV  1 byte */ 
	parameter (DB_RHOHV2 = 20  ) ! /* RhoHV  2 byte */ 
	parameter (DB_DBZC2 = 21  ) ! /* Corrected Reflectivity  2 byte */ 
	parameter (DB_VELC2 = 22  ) ! /* Corrected velocity  2 byte */ 
	parameter (DB_SQI2 = 23  ) ! /* SQI  2 byte */ 
	parameter (DB_PHIDP2 = 24  ) ! /* PhiDP  Differential phase   2 byte */ 
	parameter (DB_LDRH = 25  ) ! /* LDR xmt H, rcv V  1 byte */ 
	parameter (DB_LDRH2 = 26  ) ! /* LDR xmt H, rcv V  2 byte */ 
	parameter (DB_LDRV = 27 ) ! /* LDR xmt V, rcv H  1 byte */ 
	parameter (DB_LDRV2 = 28 ) ! /* LDR xmt V, rcv H  2 byte */ 
C /* 29 to 31 not yet ised */
	parameter (DB_HEIGHT = 32  ) ! /* Height  1/10 km   1 byte */
	parameter (DB_VIL2 = 33) ! /* Linear liquid .001 mm 2 byte */

