C mod 15 dec 2015 to eliminatte sweep filename output	
C mod july 2016 to output unformatted and also added 
C flight level winds
	subroutine wrt_hdr(lu, ray_time,swp_fn)
c
C write out extended header values forlater plotting and
C manipulation in matlab.
C   6 May 2015....
c OUTPUT IS FORMATTED TO MaKE EASIER TO INSPECT. IF
c OUT PUT FILES TOO BIG, MAYBE CHANGE TO RAW OR FORTRAN BINARY OUTPUT....
C 4 May 2018...reinstated formatted out put
	integer lu
	real ray_time
	character*80 swp_fn
 
C This commonholds  latest extended header
C already unpacked and scaled to degs, m/s etc...
 	include "TDR_hdr_common.f"
C and this include has all the RVP stuff:
	include "TDR_hdr_f90.h"
 
C
	include "hrd_radar_common_blocks.f"
C   This is where you can change what is writtten out
C look at the sub below to get the data names for attitude angles,
C flight level winds and aamps values...
	  write(lu,123)ray_time,gps_lat,gps_long,airs_lat,airs_long,
     +  gps_vel_e, gps_vel_n, gps_vel_v,
     +   airs_vel_e, airs_vel_n,airs_vel_v,
     +  airs_pitch, airs_roll, airs_drift,
cout     +	wd,ws,vws,heading,
     +  gps_age, airs_age
123	format(f10.3,10(1x,f9.4),3(1x,f7.2),2(1x,f8.1))
 	return
	end 
c =======================================
C this subroutine prints EVERYTHING
	subroutine print_all__TDR_header(lu)
	integer*4 lu
	include "TDR_hdr_common.f"
C
	write(lu,*)'gps lat, long: ',gps_lat,gps_long
	write(lu,*)'gps_alt: ',gps_alt
      	write(lu,*)'gps vel e, n: ',gps_vel_e, gps_vel_n
	write(lu,*)'gps_vel_v: ',gps_vel_v
C Inertial:
	write(lu,*)'airs lat, long: ',airs_lat, airs_long
      	write(lu,*)'airs_pitch: ',airs_pitch
	write(lu,*)'airs_roll: ',airs_roll
      	write(lu,*)'airs_heading: ',airs_heading
	write(lu,*)'airs_drift: ',airs_drift
      	write(lu,*)'airs_tru_track: ',airs_tru_track
      	write(lu,*)'airs_pitch_r: ',airs_pitch_r
      	write(lu,*)'airs_roll_r: ',airs_roll_r
	write(lu,*)'airs_yaw_r: ',airs_yaw_r
      	write(lu,*)'airs_vel_e: ',airs_vel_e
	write(lu,*)'airs_vel_n: ',airs_vel_n
      	write(lu,*)'airs_vel_v: ',airs_vel_v
      	write(lu,*)'airs_wind_dir: ',airs_wind_dir
      	write(lu,*)'airs_wind_vel: ',airs_wind_vel
C AAMPS:
	write(lu,*)'aamps lat, long: ',aamps_lat, aamps_long
      	write(lu,*)'aamps_alt: ',aamps_alt
      	write(lu,*)'aamps_pitch: ',aamps_pitch
	write(lu,*)'aamps_roll: ',aamps_roll
      	write(lu,*)'aamps_heading: ',aamps_heading
	write(lu,*)'aamps_drift: ',aamps_drift
      	write(lu,*)'aamps_track: ',aamps_track
	write(lu,*)'aamp_ground_vel: ',aamp_ground_vel
      	write(lu,*)'aamps_radalt_val: ',aamps_radalt_val
      	write(lu,*)'aamps_wind_vel: ',aamps_wind_vel
      	write(lu,*)'aamps_wind_dir: ',aamps_wind_dir
      	write(lu,*)'aamps_wind_vel_v: ',aamps_wind_vel_v
      	write(lu,*)'aamps_vel_v: ',aamps_vel_v

	write(lu,*)'time stamp: ',time_stamp
	write(lu,*)' time_since_sweep_start: ',time_since_sweep_start
	write(lu,*)'cal_sig_level: ',cal_sig_level
	write(lu,*)'gps_age: ', gps_age
      	write(lu,*)'airs_age: ',airs_age
      	write(lu,*)'aamps_age: ',aamps_age

	return
	end

