C Subroutines for creating tiff files from X windows
C ------------
	subroutine x_to_tiff(im_struct, tif_file_name)
C read X window, save as TIFF
	integer*4 im_struct(47)
	parameter( imax = 640, jmax = 480)
	integer*4 width
	integer*4 im_array(imax, jmax)
	integer*4 red_ctab(32), green_ctab(32), blue_ctab(32)
C i*2 arrays for tiff maker:
	integer*2 tif_red(256), tif_blue(256), tif_green(256)
	integer*2 tif_image(imax, jmax)
C
	character*(*) tif_file_name
	call get_color_table(im_struct,red_ctab, green_ctab, blue_ctab)
	width = imax
	call rasx_get_image(width, im_array, im_struct)
C now make tiff file
	do j = 1, jmax
		do i = 1, imax
			tif_image(i,j) = im_array(i,j)
		end do
	end do
	do i = 1, 32
		tif_red(i) = red_ctab(i)
		tif_green(i) = green_ctab(i)
		tif_blue(i) = blue_ctab(i)
	end do
	do i = 33, 256
		tif_red(i) = i
		tif_green(i) = i
		tif_blue(i) = i
	end do
	idata_form = 2
	nbit_pl = 8
	ioutlu = 25
	idimen = imax -1
	jdimen = jmax -1
	ixl = 0
	ixr = idimen
	iyb = 0
	iyt = jdimen
	call make_tiff(idata_form, tif_image, idimen, jdimen, 
     +		ixl, iyb, ixr, iyt, nbit_pl,
     +		tif_red, tif_green, tif_blue, ioutlu, ierror, 
     +		tif_file_name)
	return
	end



