C Version for compolong on GNU fortran...
C Fortran 90 structure for Sigmet extended header created for GIV 
c Tail Doppler Radar.
C /* To make the numner of bytes in the extemded header data match the 
C * sizeof( struct malibu_header) I added three initial wlwmenys from the
C * Sigmet docs. 25 Feb 2008
C */
	TYPE TDR_hdr
	integer*4 time_since_sweep_start
	integer*2 cal_sig_level
	integer*2 num_bytes
	integer*2 pad_1 ! _pad_1 in C code		
	integer*2 gps_age !   /**< Time in milliseconds since last GPS Input */
	integer*2 irs_age !   /**< Time in milliseconds since last IRS Input */
	integer*2 aamps_age ! /**< Time in milliseconds since last AAMPS Input */
	integer*4  gps_lat !   /**< GPS latitude (BAM) */
	integer*4  gps_long !  /**< GPS Longitude (BAM) */
	integer*4  gps_alt !   /**< GPS Altitude (?cm?ft?) */
	integer*4  gps_vel_e ! /**< GPS Ground Speed East (cm/second) */
	integer*4  gps_vel_n ! /**< GPS Ground Speed North (cm/second) */
	integer*4  gps_vel_v ! /**< GPS Ground Speed Up (cm/second) */
	integer*4  irs_lat !   /**< IRS latitude (BAM) */
	integer*4  irs_long !  /**< IRS Longitude (BAM) */
	integer*4  irs_vel_e ! /**< IRS Ground Speed East (cm/second) */
	integer*4  irs_vel_n ! /**< IRS Ground Speed North (cm/second) */
	integer*4  irs_vel_v ! /**< IRS Ground Speed Up (cm/second) */
	integer*2  irs_pitch !     /**< IRS Pitch (BAM) */
	integer*2  irs_roll !      /**< IRS Roll (BAM) */
	integer*2  irs_heading !   /**< IRS Heading (BAM) */
	integer*2  irs_drift !     /**< IRS Drift (BAM) */
	integer*2  irs_tru_track ! /**< IRS True Track (BAM) */
	integer*2  irs_pitch_r !   /**< IRS Pitch rate (BAM/sec) */
	integer*2  irs_roll_r !    /**< IRS Roll rate (BAM/sec) */
	integer*2  irs_yaw_r !     /**< IRS Yaw rate (BAM/sec) */
	integer*4  irs_wind_vel !  /**< IRS Wind speed (cm/second) */
	integer*2  irs_wind_dir !  /**< IRS Wind direction (BAM) */
	integer*2  pad_2 ! __pad_2 in C version
	integer*4  aamps_lat !   /**< aamps latitude (BAM) */
	integer*4  aamps_long !  /**< aamps Longitude (BAM) */
	integer*4  aamps_alt !   /**< aamps Altitude (cm) */
	integer*4  aamps_ground_vel ! /**< aamps Ground Speed (cm/second) */
	integer*4  time_stamp ! /**< aamps time since epoch (second) */
	integer*4  aamps_vel_v ! /**< aamps Ground Speed Up (cm/second) */
	integer*2  aamps_pitch !     /**< aamps Pitch (BAM) */
	integer*2  aamps_roll !      /**< aamps Roll (BAM) */
	integer*2  aamps_heading !   /**< aamps Heading (BAM) */
	integer*2  aamps_drift !     /**< aamps Drift (BAM) */
	integer*2  aamps_track !     /**< aamps Track (BAM) */
	integer*2  pad_4 ! __pad_4 in C version
	integer*4  aamps_radalt_val !  /**< aamps altitude (cm) */
	integer*4  aamps_wind_vel ! horiz wind speed in cm/s
	integer*2  aamps_wind_dir  ! horiz wind dir, 16 bit bin and
	integer*2  pad_5 ! __pad_5 in C version
 	integer*4  aamps_wind_vel_v !  /**< AAMPS Wind Speed Up (cm/second) */
	END TYPE

