	Subroutine Contour(count)

	Implicit none
	
	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

        Integer i,j,ix,iy
        Integer flag,count,line_count
	Real qline_flag1,qline_flag2,qmove_flag1,qmove_flag2

	line_count=1

	Write (95,*) '% contour level is ',zct,' dBZ' 

	IF (zct.EQ.0) THEN
	 Write (95,10)zero_linewidth
10	 Format (F4.2,' setlinewidth')
	ENDIF

	IF (zct.LT.0) THEN
	 Write (95,11)dash_on,dash_off,dash_beg 
11	 Format ('[',I2,1X,I2,'] ',I2,' setdash')
	ENDIF

	zct = zct+cont_offset 

       DO 5 I=1,II-1
        DO 5 J=1,JJ-1
5 	 IM(I,J) = 0 

*.....................SEARCH FOR A SQUARE THAT CONTAINS A CONTOUR LINE:
98 	Continue
*	Print*, 'Starting new line' 
	IX = 0
99 	IX = IX + 1
	IY = 0
100 	Continue
	IY = IY + 1
	IF (IY.GE.JJ)        go to  99
	IF (IX.GE.II)        go to 998
	IF (IM(IX,IY).GE.15) go to 100
	Call Getz (ix,iy)
	zmx = amax1(Z1,Z2,Z3,Z4)
	zmn = amin1(Z1,Z2,Z3,Z4)
	IF (zct.GT.zmx.OR.zct.LT.zmn) THEN
	 im(IX,IY) = 16
	 go to 100
	ENDIF

*.......LOOK AT THE Sid1ES OF THE SQUARE TO FIND THE START OF A CONTOUR:
*                  (ALWAYS DRAW CLOCKWISE CONTOURS AROUND A "HIGH" AND
*                       COUNTER-CLOCKWISE CONTOURS AROUND A "LOW")
        IF ((z1.LT.zct.AND.z2.GT.zct).OR.
     $      (z1.GT.zct.AND.z2.LT.zct)) THEN
* go to 110 (bottom side)
         test1 = 110
        ELSEIF((z2.LT.zct.AND.z3.GT.zct).OR.
     $         (z2.GT.zct.AND.z3.LT.zct)) THEN
* go to 120 (right side)
         test1 = 120
        ELSEIF((z3.LT.zct.AND.z4.GT.zct).OR.
     $         (z3.GT.zct.AND.z4.LT.zct)) THEN
* go to 130 (top side)
         test1 = 130
        ELSEIF((z1.LT.zct.AND.z4.GT.zct).OR.
     $         (z1.GT.zct.AND.z4.LT.zct)) THEN
* go to 140 (left side)
         test1 = 140
        ENDIF

	Call FindCont (ix,iy,flag)

210	Call EnterSide (ix,iy)

	Call Getz (ix,iy)

211	Call LBranch (ix,iy,line_count,flag)

        IF (endloop.EQ.980) go to 980
        IF (test5.EQ.310.OR.test5.EQ.320.OR.
     $      test5.EQ.330.OR.test5.EQ.340) THEN
         go to 310
        ENDIF
        IF (test2.EQ.210.OR.test2.EQ.220.OR.
     $      test2.EQ.230.OR.test2.EQ.240) THEN
         go to 210
        ENDIF
        IF (test4.EQ.212.OR.test4.EQ.222.OR.
     $      test4.EQ.232.OR.test4.EQ.242) THEN
         go to 212
        ENDIF

212	Call  RBranch (ix,iy,line_count,flag)

	IF (endloop.EQ.980) go to 980
        IF (test5.EQ.310.OR.test5.EQ.320.OR.
     $      test5.EQ.330.OR.test5.EQ.340) THEN
         go to 310
        ENDIF
        IF (test2.EQ.210.OR.test2.EQ.220.OR.
     $      test2.EQ.230.OR.test2.EQ.240) THEN
         go to 210
        ENDIF
	IF (endloop.EQ.980) go to 980

310	Call HitBord (ix,iy,line_count,flag)

        IF (endloop.EQ.980) go to 980
        IF (test5.EQ.310.OR.test5.EQ.320.OR.
     $      test5.EQ.330.OR.test5.EQ.340) THEN
         go to 310
        ENDIF
        IF (test2.EQ.210.OR.test2.EQ.220.OR.
     $      test2.EQ.230.OR.test2.EQ.240) THEN
         go to 210
        ENDIF

980	Continue
	endloop=0

*........END LINE SEGMENT - DRAW, FILL, PAINT, ETC.
	
*	Print*, 'ending line'
*	Write(506,*), 'ending line'
*	Print*, 'line count: ',line_count
         clspath = 0
	 Call PrintLines(line_count)
	 Call CloseC (count,line_count)
	 IF ((fill_flag.EQ.'N'.OR.fill_flag.EQ.'n').AND.
     $   (zct-cont_offset).NE.0) THEN
*     $   (zct-cont_offset).NE.0.AND.plot_type.EQ.2) THEN
	  Call LabelContour (count,line_count)
	 ENDIF
	 Call Initialize (line_count)
	 
         go to 98
*--------------------------------------------------
*..............IF NECESSARY, DRAW "NON-ZERO WINDING NUMBER RULE" BORDER
*                                             (for PostScript printers)
998	Continue
	id1 = 998
	
	
	qmove_flag1=ix1
	qmove_flag2=iy1
       	IF (iedge.EQ.0.AND.fld_data(1,1,cont).GE.zct) THEN
	  Call Qmove(qmove_flag1,qmove_flag2)
	  qline_flag1=ix1
	  qline_flag2=iy2
	  Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	  qline_flag1=ix2
	  qline_flag2=iy2
	  Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	  qline_flag1=ix2
	  qline_flag2=iy1
	  Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	  Call CloseC (count,line_count)
        ENDIF
*--------------------------------------------------
*........THAT'S ALL FOLKS!
51      Continue
50      Continue
999 	CONTINUE

*      	Write(95,8551)
*8551 	Format(' stroke')
	
        IF (fill_flag.EQ.'Y') Write (95,*) count,' o fill'
      	IF (zct-cont_offset.LT.0) THEN
       	 Write (95,*)'[] 0 setdash'
      	ENDIF

      	IF (zct-cont_offset.EQ.0) THEN
         Write (95,22) linewidth
22       Format (F4.2,' setlinewidth')
      	ENDIF

* setgray back to black
        Write (95,*) '0 setgray'

	Return
	End
**************************************************
	Subroutine  RBranch (ix,iy,line_count,flag)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'
	
	Integer ix,iy,line_count,flag
	Real qline_flag1,qline_flag2

*	Print*, 'Calling RBranch'

10	Continue

	IF (test4.EQ.212) THEN
	 IF ((Z2.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z2.GT.ZCT.AND.Z5.LT.ZCT)) THEN
          id1 = 212
          KX2 = IX1 + NINT(XINT*(IX     - 0.5*(ZCT-Z2)/(Z5-Z2)))
          KY2 = IY1 + NINT(YINT*((IY-1) + 0.5*(ZCT-Z2)/(Z5-Z2)))
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
	  Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z2.LT.zct.AND.z3.GT.zct).OR.
     c  (z2.GT.zct.AND.z3.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*IX)
           KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z2)/(Z3-Z2)))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	    endloop = 980
	    go to 11
	   ENDIF
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c      z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
           IF (IX.GE.II-1) THEN
            test5 = 320
	    test2 = 0
	    test4 = 0
	    go to 11
	   ENDIF
	   test2 = 240
	   test5 = 0
	   test4 = 0
	   go to 11
          ENDIF
	  IF ((z3.LT.zct.AND.z5.GT.zct).OR.
     c     (z3.GT.zct.AND.z5.LT.zct)) THEN
	   test4 = 222
	   go to 10
          ENDIF
          WRITE(*,812)
812       FORMAT(2X,'PROBLEM:  BLOCK 210-R')
         ENDIF
	 test2 = 220
	 test5 = 0
	ENDIF

	IF (test4.EQ.222) THEN
	 IF ((Z3.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z3.GT.ZCT.AND.Z5.LT.ZCT)) THEN
          id1 = 222
          KX2 = IX1 + NINT(XINT*(IX     - 0.5*(ZCT-Z3)/(Z5-Z3)))
          KY2 = IY1 + NINT(YINT*(IY     - 0.5*(ZCT-Z3)/(Z5-Z3)))
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z3.LT.zct.AND.z4.GT.zct).OR.
     c (z3.GT.zct.AND.z4.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z4)/(Z3-Z4)))
           KY2 = IY1 + NINT(YINT*IY)
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	    endloop = 980
	    go to 11
	   ENDIF
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c    z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
           IF (IY.GE.JJ-1) THEN
	    test5 = 330
	    test2 = 0
	    test4 = 0
	    go to 11
	   ENDIF
           test2 = 210 
	   test5 = 0
	   test4 = 0
	   go to 11
          ENDIF
	  IF ((z4.LT.zct.AND.z5.GT.zct).OR.
     c  (z4.GT.zct.AND.z5.LT.zct)) THEN
	   test4 = 232
	   go to 10
          ENDIF
          WRITE(*,822)
822       FORMAT(2X,'PROBLEM:  BLOCK 220-R')
         ENDIF
	 test2 = 230
	 test5 = 0
	ENDIF

	IF (test4.EQ.232) THEN
	 IF ((z4.LT.zct.AND.z5.GT.zct).OR.
     c    (z4.GT.zct.AND.z5.LT.zct)) THEN
          id1 = 232
          KX2 = IX1 + NINT(XINT*((IX-1) + 0.5*(ZCT-Z4)/(Z5-Z4)))
          KY2 = IY1 + NINT(YINT*(IY     - 0.5*(ZCT-Z4)/(Z5-Z4)))
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c  z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z1.LT.zct.AND.z4.GT.zct).OR.
     c     (z1.GT.zct.AND.z4.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*(IX-1))
           KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z1)/(Z4-Z1)))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN
	    endloop = 980
	    go to 11
	   ENDIF 
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c  z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
           IF (IX.LE.1) THEN
	    test5 = 340 
	    test2 = 0
	    test4 = 0
	    go to 11
	   ENDIF
	   test2 = 220
	   test5 = 0
	   test4 = 0
	   go to 11
          ENDIF
	  IF ((z1.LT.zct.AND.z5.GT.zct).OR.
     c (z1.GT.zct.AND.z5.LT.zct)) THEN
	   test4 = 242
	   go to 10
          ENDIF
          WRITE(*,832)
832       FORMAT(2X,'PROBLEM:  BLOCK 230-R')
         ENDIF
	 test2 = 240
	 test5 = 0
	ENDIF

	IF (test4.EQ.242) THEN
	 IF ((Z1.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z1.GT.ZCT.AND.Z5.LT.ZCT)) THEN
          id1 = 242
          KX2 = IX1 + NINT(XINT*((IX-1) + 0.5*(ZCT-Z1)/(Z5-Z1)))
          KY2 = IY1 + NINT(YINT*((IY-1) + 0.5*(ZCT-Z1)/(Z5-Z1)))
          IF (z1.LT.-900.OR.z2.LT.-900.
     c  OR.z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z1.LT.zct.AND.z2.GT.zct).OR.
     c (z1.GT.zct.AND.z2.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z1)/(Z2-Z1)))
           KY2 = IY1 + NINT(YINT*(IY-1))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN
	    endloop = 980
	    go to 11
	   ENDIF 
          IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
           flag = 2
	   clspath = 1
          ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
           IF (IY.LE.1) THEN
	    test5 = 310 
	    test2 = 0
	    test4 = 0
	    go to 11
	   ENDIF
	   test2 = 230
	   test5 = 0
	   test4 = 0
	   go to 11
          ENDIF
	  IF ((z2.LT.zct.AND.z5.GT.zct).OR.
     c (z2.GT.zct.AND.z5.LT.zct)) THEN
	   test4 = 212
	   go to 10
          ENDIF
          WRITE(*,842)
842       FORMAT(2X,'PROBLEM:  BLOCK 240-R')
         ENDIF
	 test5 = 310
	 test2 = 0
	ENDIF

11	Continue

	flag = 0

	Return
	End
**************************************************
	Subroutine LBranch (ix,iy,line_count,flag)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy,line_count,flag
	Real qline_flag1,qline_flag2

*	Print*, 'Calling LBranch'

	qline_flag1=kx2
	qline_flag2=ky2

10	Continue

	IF (test3.EQ.211) THEN
	 IF ((z1.LT.zct.AND.z5.GT.zct).OR.
     c (z1.GT.zct.AND.z5.LT.zct)) THEN
          id1 = 211
          KX2 = IX1 + NINT(XINT*((IX-1) + 0.5*(ZCT-Z1)/(Z5-Z1)))
          KY2 = IY1 + NINT(YINT*((IY-1) + 0.5*(ZCT-Z1)/(Z5-Z1)))
	  IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	   flag = 2
	   clspath = 1
	  ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z1.LT.zct.AND.z4.GT.zct).OR.
     c (z1.GT.zct.AND.z4.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*(IX-1))
           KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z1)/(Z4-Z1)))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN
	    endloop = 980
	    go to 11
	   ENDIF
	   IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	    flag = 2
	    clspath = 1
	   ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	   IF (ix.LE.1) THEN
	    test5 = 340
	    test2 = 0
	    test4 = 0
	    go to 11
	   ENDIF
	   test2 = 220
	   test5 = 0
	   test4 = 0
	   go to 11
          ENDIF
	  IF ((z4.LT.zct.AND.z5.GT.zct).OR.
     c (z4.GT.zct.AND.z5.LT.zct)) THEN
	   test3 = 241
	   go to 10
          ENDIF
          WRITE(*,811)
811       FORMAT(2X,'PROBLEM:  BLOCK 210-L')
         ENDIF
	 test4 = 212
	 test5 = 0
	 test2 = 0
	ENDIF

	IF (test3.EQ.221) THEN
	 IF ((z2.LT.zct.AND.z5.GT.zct).OR.
     c (z2.GT.zct.AND.z5.LT.zct)) THEN
          id1 = 221
	  KX2 = IX1 + NINT(XINT*(IX     - 0.5*(ZCT-Z2)/(Z5-Z2)))
	  KY2 = IY1 + NINT(YINT*((IY-1) + 0.5*(ZCT-Z2)/(Z5-Z2)))
	  IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	   flag = 2
	   clspath = 1
	  ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((Z1.LT.ZCT.AND.Z2.GT.ZCT).OR.
     c (Z1.GT.ZCT.AND.Z2.LT.ZCT)) THEN
	   KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z1)/(Z2-Z1)))
	   KY2 = IY1 + NINT(YINT*(IY-1))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	    endloop = 980
	    go to 11
	   ENDIF
	   IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	    flag = 2
	    clspath = 1
	   ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	    IF (iy.LE.1) THEN
	     test5 = 310
	     test2 = 0
	     test4 = 0
	     go to 11
	    ENDIF
	    test2 = 230
	    test5 = 0
	    test4 = 0
	    go to 11
          ENDIF
	  IF ((Z1.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z1.GT.ZCT.AND.Z5.LT.ZCT)) THEN
	   test3 = 211
	   go to 10
          ENDIF
          WRITE(*,821)
821       FORMAT(2X,'PROBLEM:  BLOCK 220-L')
         ENDIF
	 test4 = 222
	 test5 = 0
	 test2 = 0
	ENDIF

	IF (test3.EQ.231) THEN
	 IF ((Z3.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z3.GT.ZCT.AND.Z5.LT.ZCT)) THEN
          id1 = 231
	  KX2 = IX1 + NINT(XINT*(IX     - 0.5*(ZCT-Z3)/(Z5-Z3)))
	  KY2 = IY1 + NINT(YINT*(IY     - 0.5*(ZCT-Z3)/(Z5-Z3)))
	  IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	   flag = 2
	   clspath = 1
	  ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((Z2.LT.ZCT.AND.Z3.GT.ZCT).OR.
     c (Z2.GT.ZCT.AND.Z3.LT.ZCT)) THEN
	   KX2 = IX1 + NINT(XINT*IX)
	   KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z2)/(Z3-Z2)))
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	    endloop = 980
	    go to 11
	   ENDIF
	   IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	    flag = 2
	    clspath = 1
	   ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	    IF (ix.GE.ii-1) THEN
	     test5 = 320
	     test2 = 0
	     test4 = 0
	     go to 11
	    ENDIF
	    test2 = 240
	    test5 = 0
	    test4 = 0
	    go to 11
          ENDIF
	  IF ((Z2.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z2.GT.ZCT.AND.Z5.LT.ZCT)) THEN
	   test3 = 221
	   go to 10
          ENDIF
	  WRITE(*,831)
831       FORMAT(2X,'PROBLEM:  BLOCK 230-L')
         ENDIF
	 test4 = 232
	 test5 = 0
	 test2 = 0
	ENDIF

	IF (test3.EQ.241) THEN
	 IF ((Z4.LT.ZCT.AND.Z5.GT.ZCT).OR.
     c (Z4.GT.ZCT.AND.Z5.LT.ZCT)) THEN
          id1 = 241
	  KX2 = IX1 + NINT(XINT*((IX-1) + 0.5*(ZCT-Z4)/(Z5-Z4)))
          KY2 = IY1 + NINT(YINT*(IY     - 0.5*(ZCT-Z4)/(Z5-Z4)))
	  IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	   flag = 2
	   clspath = 1
	  ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          KX1 = KX2
          KY1 = KY2
	  IF ((z4.LT.zct.AND.z3.GT.zct).OR.
     c (z4.GT.zct.AND.z3.LT.zct)) THEN
           KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z4)/(Z3-Z4)))
           KY2 = IY1 + NINT(YINT*IY)
           IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	    endloop = 980
	    go to 11
	   ENDIF
	   IF (z1.LT.-900.OR.z2.LT.-900.OR.
     c z3.LT.-900.OR.z4.LT.-900) THEN
	    flag = 2
	    clspath = 1
	   ENDIF
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
	    IF (iy.GE.jj-1) THEN
	     test5 = 330
	     test2 = 0
	     test4 = 0
	     go to 11
	    ENDIF
	    test2 = 210
	    test5 = 0
	    test4 = 0
	    go to 11
          ENDIF
	  IF ((z3.LT.zct.AND.z5.GT.zct).OR.
     c (z3.GT.zct.AND.z5.LT.zct)) THEN
	   test3 = 231
	   go to 10
          ENDIF
          WRITE(*,850)
850       FORMAT(2X,'PROBLEM:  BLOCK 240-L')
         ENDIF
	 test4 = 242
	 test5 = 0
	 test2 = 0
	ENDIF

11	Continue

	flag = 0

	Return
	End
**************************************************
	Subroutine HitBord (ix,iy,line_count,flag)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy,line_count,flag
	Real qline_flag1,qline_flag2

	qline_flag1=kx2
	qline_flag2=ky2

	flag = 1
	clspath = 1

*	Print*, 'Calling Hitbord'

10	Continue

        IF (test5.EQ.310) THEN
         id1 = 310
         test6 = 311
        ELSEIF (test5.EQ.320) THEN
         id1 = 320
         test6 = 321
        ELSEIF (test5.EQ.330) THEN
         id1 = 330
         test6 = 331
        ELSEIF (test5.EQ.340) THEN
         id1 = 340
         test6 = 341
        ENDIF

        IEDGE = 1
        KX1 = KX2
        KY1 = KY2

20	Continue

	IF (test6.EQ.311) THEN
	 IF (IX.LE.1) THEN
	  KX2 = IX1
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IY = IY-1
	  test5 = 340
	  test2 = 0
	  test6 = 0
	  go to 10
         ENDIF
	 IX = IX - 1
	 Call BorderGetz(ix,iy)
         IF (z1.LT.zct.AND.z2.GT.zct) THEN
	  KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z1)/(Z2-Z1)))
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IY = IY-1
	  test2=210
	  test5 = 0
	  test6 = 0
	  go to 11
         ELSE
	  test6 = 311
	  go to 20
	 ENDIF
	ENDIF

	IF (test6.EQ.321) THEN
	 IF (IY.LE.1) THEN
	  KY2 = IY1
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IX = IX+1
	  test5 = 310
	  test2 = 0
	  test6 = 0
	  go to 10
         ENDIF
	 IY = IY - 1
         Call BorderGetz(ix,iy)
         IF (z2.LT.zct.AND.z3.GT.zct) THEN
	  KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z2)/(Z3-Z2)))
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IX = IX+1
	  test2= 220
	  test5 = 0
	  test6 = 0
	  go to 11
         ELSE
	  test6 = 321
	  go to 20
         ENDIF
	ENDIF

	IF (test6.EQ.331) THEN
	 IF (IX.GE.II-1) THEN
	  KX2 = IX2
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IY = IY+1
	  test5 = 320
	  test2 = 0
	  test6 = 0
	  go to 10
         ENDIF
	 IX = IX + 1
         Call BorderGetz(ix,iy)
         IF (z3.LT.zct.AND.z4.GT.zct) THEN
	  KX2 = IX1 + NINT(XINT*((IX-1) + (ZCT-Z4)/(Z3-Z4)))
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IY = IY+1
	  test2=230
	  test5 = 0
	  test6 = 0
	  go to 11
         ELSE
	  test6 = 331
	  go to 20
         ENDIF
	ENDIF

	IF (test6.EQ.341) THEN
	 IF (IY.GE.JJ-1) THEN
          KY2 = IY1 + NINT(YINT*IY)
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IX = IX-1
	  test5 = 330
	  test2 = 0
	  test6 = 0
	  go to 10
         ENDIF
	 IY = IY + 1
         Call BorderGetz(ix,iy)
         IF (z1.GT.zct.AND.z4.LT.zct) THEN
	  KY2 = IY1 + NINT(YINT*((IY-1) + (ZCT-Z1)/(Z4-Z1)))
          IF (KX2.EQ.ISTX.AND.KY2.EQ.ISTY) THEN 
	   endloop = 980
	   go to 11
	  ENDIF 
	  qline_flag1=kx2
	  qline_flag2=ky2
          Call CalcLine (qline_flag1,qline_flag2,flag,line_count)
          IX = IX-1
	  test2=240
	  test5 = 0
	  test6 = 0
	  go to 11
         ELSE
	  test6 = 341
	  go to 20
         ENDIF
	ENDIF

11	Continue

	flag = 0

	Return
	End
**************************************************
	Subroutine FindCont (ix,iy,flag)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy,flag
	Real qmove_flag1,qmove_flag2

	qmove_flag1=kx2
	qmove_flag2=ky2

*	Print*, 'Calling FindCont'

10 	Continue

	IF (test1.EQ.110) THEN
	  IF (Z1.GT.Z2) THEN
           test1 = 120
	   go to 10
	  ENDIF
          ISTX = IX1 + NINT(XINT*((IX-1) + (ZCT-Z1)/(Z2-Z1)))
          ISTY = IY1 + NINT(YINT*(IY-1))
          IY = IY - 1
	  test2 = 210
	 ENDIF

	IF (test1.EQ.120) THEN
	 IF ((Z2.LT.ZCT.AND.Z3.GT.ZCT).OR.
     c (Z2.GT.ZCT.AND.Z3.LT.ZCT)) THEN
          IF (z2.GT.z3) THEN
           test1 = 130 
	   go to 10
	  ENDIF
          ISTX = IX1 + NINT(XINT*IX)
          ISTY = IY1 + NINT(YINT*((IY-1) + (ZCT-Z2)/(Z3-Z2)))
	  IX = IX + 1
	  test2 = 220
	 else
	  test1 = 130
	 ENDIF
	ENDIF

	IF (test1.EQ.130) THEN
	 IF ((Z3.LT.ZCT.AND.Z4.GT.ZCT).OR.
     c (Z3.GT.ZCT.AND.Z4.LT.ZCT)) THEN
          IF (z3.GT.z4) THEN
           test1 = 140 
	   go to 10
	  ENDIF
          ISTX = IX1 + NINT(XINT*((IX-1) + (ZCT-Z4)/(Z3-Z4)))
          ISTY = IY1 + NINT(YINT*IY)
          IY = IY + 1
	  test2 = 230
	 else
	  test1 = 140
	 ENDIF
	ENDIF

	IF (test1.EQ.140) THEN
	 IF ((Z1.LT.ZCT.AND.Z4.GT.ZCT).OR.
     c (Z1.GT.ZCT.AND.Z4.LT.ZCT)) THEN
          IF (z4.GT.z1) THEN
           test1 = 150
	   go to 10
	  ENDIF
          ISTX = IX1 + NINT(XINT*(IX-1))
          ISTY = IY1 + NINT(YINT*((IY-1) + (ZCT-Z1)/(Z4-Z1)))
	  IX = IX - 1
	  test2 = 240
	 else
	  test1 = 150
	 ENDIF
	ENDIF

	IF (test1.EQ.150) THEN
	 WRITE(*,880)
880      FORMAT(2X,'PROGRAM GOT LOST LOOKING AT SQUARES') 
	else
         KX2 = ISTX
         KY2 = ISTY
	ENDIF

	qmove_flag1=kx2
	qmove_flag2=ky2
	Call Qmove (qmove_flag1,qmove_flag2)

*	Call qmove(kx2,ky2)

	Return
	End
**************************************************
	Subroutine EnterSide (ix,iy)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy

*	Print*, 'Calling EnterSide'

* move to beginning of line segment

	IF (test2.EQ.210) THEN
	 IY = IY + 1		
	 test3 = 211
	ENDIF
	IF (test2.EQ.220) THEN
	 IX = IX - 1		
	 test3 = 221
	ENDIF
	IF (test2.EQ.230) THEN
	 IY = IY - 1		
	 test3 = 231
	ENDIF
	IF (test2.EQ.240) THEN
	 IX = IX + 1		
	 test3 = 241
	ENDIF

	IM(IX,IY) = 16
	KX1 = KX2
	KY1 = KY2


	Return 
	End
**************************************************
	Subroutine Getz (ix,iy)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy
	Real delta

	delta = 1.0E-4

*	Print*, 'Calling Getz'

        Z1 = fld_data(IX,IY,cont)
        Z2 = fld_data(IX+1,IY,cont)
        Z3 = fld_data(IX+1,IY+1,cont)
        Z4 = fld_data(IX,IY+1,cont)
        Z5 = (Z1+Z2+Z3+Z4)/4.0

	IF (zct.LT.0) THEN
	 delta = delta*(-1)
	ENDIF

        IF (Z1.EQ.ZCT) Z1 = Z1 + DELTA
        IF (Z2.EQ.ZCT) Z2 = Z2 + DELTA
        IF (Z3.EQ.ZCT) Z3 = Z3 + DELTA
        IF (Z4.EQ.ZCT) Z4 = Z4 + DELTA
        IF (Z5.EQ.ZCT) Z5 = Z5 + DELTA

	return
	end
**************************************************
	Subroutine BorderGetz (ix,iy)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer ix,iy
	Real delta

	delta = 1.0E-4

*	Print*, 'Calling BorderGetz'

	IF (test6.EQ.311) THEN
          Z1 = fld_data(IX,1,cont)
          Z2 = fld_data(IX+1,1,cont)
          Z3 = fld_data(IX+1,2,cont)
          Z4 = fld_data(IX,2,cont)
	ELSEIF (test6.EQ.321) THEN
          Z1 = fld_data(II-1,IY,cont)
          Z2 = fld_data(II,IY,cont)
          Z3 = fld_data(II,IY+1,cont)
          Z4 = fld_data(II-1,IY+1,cont)
	ELSEIF (test6.EQ.331) THEN
          Z1 = fld_data(IX,JJ-1,cont)
          Z2 = fld_data(IX+1,JJ-1,cont)
          Z3 = fld_data(IX+1,JJ,cont)
          Z4 = fld_data(IX,JJ,cont)
	ELSEIF (test6.EQ.341) THEN
          Z1 = fld_data(1,IY,cont)
          Z2 = fld_data(2,IY,cont)
          Z3 = fld_data(2,IY+1,cont)
          Z4 = fld_data(1,IY+1,cont)
	ENDIF

	IF (zct.LT.0) THEN
	 delta = delta*(-1)
	ENDIF

        IF (Z1.EQ.ZCT) Z1 = Z1 + DELTA
        IF (Z2.EQ.ZCT) Z2 = Z2 + DELTA
        IF (Z3.EQ.ZCT) Z3 = Z3 + DELTA
        IF (Z4.EQ.ZCT) Z4 = Z4 + DELTA

	return
	end
**************************************************
	Subroutine CalcLine (qline_flag1,qline_flag2,flag,line_count)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer flag,line_count
	Real x2,y2,qline_flag1,qline_flag2
C Don't know why this was done this way, but is illegal in f90 to
C take the float of a real.
Cout        x2 = float(qline_flag1)/1000.0
Cout        y2 = float(qline_flag2)/1000.0
        x2 = qline_flag1 / 1000.0
        y2 = qline_flag2 / 1000.0

*	Print*, 'Calling CalcLine'

* Keep track of number of lines & insert 'closepath' so that the
* printer won't run out of memory

	line_count = line_count + 1

	IF (fill_flag.EQ.'N'.OR.fill_flag.EQ.'n') THEN
	 xline(line_count)=X2
	 yline(line_count)=Y2
	 IF (flag.EQ.1.OR.flag.EQ.2) THEN
	  pscommand(line_count)='m'
	 ELSE
	  pscommand(line_count)='l'
	 ENDIF
	ENDIF

	IF (fill_flag.EQ.'Y'.OR.fill_flag.EQ.'y') THEN
	 xline(line_count)=X2
	 yline(line_count)=Y2
	 pscommand(line_count)='l'
	ENDIF

        RETURN
        END
**************************************************
	Subroutine Qmove (qmove_flag1,qmove_flag2)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

      	Real x1,y1,qmove_flag1,qmove_flag2

*	Print*, 'Calling Qmove'

C This stuff is illegal in F90:
Cout      	x1 = FLOAT(qmove_flag1)/1000.0
Cout      	y1 = FLOAT(qmove_flag2)/1000.0
      	x1 = qmove_flag1 / 1000.0
      	y1 = qmove_flag2 / 1000.0

	xline(1)=x1
	yline(1)=y1
	pscommand(1)='m'
	
      	RETURN
      	END
**************************************************
	Subroutine PrintLines(line_count)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer line_count,temp,i,num
	Real maxmem
	character*3 end_flag

*	Print*, 'Calling PrintLines'
*	Print*, 'line_count: ',line_count

	maxmem = 1450.
	end_flag='no'
	num=0

* IF too many lines, THEN caculate how many lines to delete 
10	IF (end_flag.EQ.'no ') THEN
	 num=num+1
	 IF (line_count.LT.(maxmem*num)) end_flag='yes'
	 go to 10
	ENDIF 

	IF (num.EQ.1.OR.num.GT.2) THEN
	 DO i=1,line_count,num
	  Write (95,20)xline(i),hkm,yline(i),vkm,pscommand(i)
20	  Format (F10.2,1X,A,1X,F10.2,1X,A,1X,A) 
	 ENDDO
	ELSEIF (num.EQ.2) THEN
	 temp=nint(maxmem/(line_count-maxmem))
	 IF (temp.EQ.1) temp=temp+1
	 DO i=1,line_count
	  IF (mod(i,temp).NE.0) THEN
	   Write (95,30)xline(i),hkm,yline(i),vkm,pscommand(i)
30	   Format (F10.2,1X,A,1X,F10.2,1X,A,1X,A) 
	  ELSEIF (mod(i,temp).EQ.0) THEN
*	   Print*, 'MAXIMUM MEMORY EXCEEDED: SKIPPING LINE'
	  ENDIF
	 ENDDO
	ENDIF
	
*	  Write (95,813)xline(i),hkm,yline(i),vkm,pscommand(i)
*813	  Format (F10.2,1X,A,1X,F10.2,1X,A,1X,A) 

C if previous command moveto, the end with moveto else lineto
	IF (pscommand(line_count-1).EQ."m") THEN
 	 Write (95,814)xline(1),hkm,yline(1),vkm,pscommand(1)
814	 Format (F10.2,1X,A,1X,F10.2,1X,A,1X,A) 
	ELSE
	 Write (95,815)xline(1),hkm,yline(1),vkm
815	 Format (F10.2,1X,A,1X,F10.2,1X,A,' l') 
	ENDIF

	Return
	End
**************************************************
	Subroutine LabelContour (count,line_count)
	
	Implicit none

        Include 'common1.h'
        Include 'common2.h'
        Include 'common3.h'

        Integer line_count,i,label_count,label_every,count
	Real xtext_pos(100),ytext_pos(100),theta(100)

*	Print*, 'Calling LabelContour'

	label_count=0

	IF (line_count.LE.10) go to 10
*	IF (line_count.GT.0.AND.line_count.LE.10) label_every=5
	IF (line_count.GT.10.AND.line_count.LE.100) label_every=10
Cout		IF (line_count.GT.100) label_every=ifix(line_count/25)
C HP F90 doesn't want to ifix an integer!
	IF (line_count.GT.100) label_every=ifix(line_count/25.0)
	
C Initialize
        DO i=1,100
	 xtext_pos(i)=0. 
	 ytext_pos(i)=0. 
	 theta(i)=0.
        ENDDO

        DO i = 1,line_count
	 IF (mod(i,label_every).EQ.0.AND.pscommand(i).EQ.'l'.
     $       AND.pscommand(i-1).EQ.'l') THEN
	  label_count=label_count+1
	  Call CalcPosLabel (i,xtext_pos,ytext_pos,theta,label_count)
	 ENDIF
        ENDDO

*	IF (mod(count,2).EQ.0) THEN
	Call WriteLabel (xtext_pos,ytext_pos,theta,label_count,count)
*	ENDIF

10	Continue

	Return
	End
**************************************************
	Subroutine Initialize (line_count)
	
	Implicit none

        Include 'common1.h'
        Include 'common2.h'
        Include 'common3.h'

	Integer i,line_count


	DO i=1,line_count
	 xline(i)=0.
	 yline(i)=0.
	 pscommand(i)=''
	ENDDO

	line_count=1

	Return
	End
**************************************************
	Subroutine CalcPosLabel (i,xtext_pos,ytext_pos,theta,label_count)

	Implicit none

        Include 'common1.h'
        Include 'common2.h'
        Include 'common3.h'

	integer i,label_count
	Real xtext_pos(100),ytext_pos(100),theta(100),xlength,ylength,r

*	Print*, 'Calling CalcPosLabel'

C Calculate length in horizontal & vertical directions
	IF (pscommand(i-3).EQ."l".AND.pscommand(i+3).EQ."l") THEN
	 xlength=xline(i+3)-xline(i-3)
	 ylength=yline(i+3)-yline(i-3)
	ELSEIF (pscommand(i-2).EQ."l".AND.pscommand(i+2).EQ."l") THEN
	 xlength=xline(i+2)-xline(i-2)
	 ylength=yline(i+2)-yline(i-2)
	ELSEIF (pscommand(i).EQ."l".AND.pscommand(i-1).EQ."l") THEN
	 xlength=xline(i)-xline(i-1)
	 ylength=yline(i)-yline(i-1)
	ENDIF
C Calculate radius
	r=sqrt(xlength**2+ylength**2)
C Calculate theta
	IF (r.GT.0) THEN
	 theta(label_count)=asin(abs(ylength/r))*57.3 
	 IF ((xlength.LT.0.AND.ylength.LT.0).OR.
     $   (xlength.GT.0.AND.ylength.LT.0)) THEN
	  theta(label_count)=theta(label_count)*(-1)
	 ENDIF
C Calculate text position
	 xtext_pos(label_count)=xline(i)
	 ytext_pos(label_count)=yline(i)
	ELSE
	 theta(label_count)=-999
	 xtext_pos(label_count)=-999
	 ytext_pos(label_count)=-999
	ENDIF

	Return
	End
**************************************************
	Subroutine WriteLabel (xtext_pos,ytext_pos,theta,
     +		label_count,count)
	
	Implicit none

        Include 'common1.h'
        Include 'common2.h'
        Include 'common3.h'

	Integer label_count,label,i,frmat,zct_int,count
	Real xtext_pos(100),ytext_pos(100),theta(100)
	Character comment

*	Print*, 'Calling WriteLabel'

	label=nint(label_count*.50)
	zct_int=nint(zct-cont_offset)

C Calculate which format to use
	IF (zct_int.GE.0.AND.zct_int.LT.10) frmat=11
	IF ((zct_int.GE.10.AND.zct_int.LT.100).OR.
     $      (zct_int.LT.0.AND.zct_int.GT.-10)) frmat=12
	IF ((zct_int.GT.-100 .AND. zct_int.LE.-10) .OR.
     +		(zct_int.GE.100)) frmat=13
	IF (zct_int.LE.-100) frmat=14
C Write out every label, but comment out all but the middle one...so user 
C can choose which label to print

	DO i=1,label_count
	 IF (i.EQ.label) THEN
	  IF (theta(i).NE.-999.AND.xtext_pos(i).NE.-999.AND.
     $    ytext_pos(i).NE.-999) THEN
	   comment=''
	   IF (mod(count,2).NE.0) comment='%' 
	  ENDIF
	 ELSE
	  IF (theta(i).NE.-999.AND.xtext_pos(i).NE.-999.AND.
     $    ytext_pos(i).NE.-999) THEN
	   comment='%'
	  ENDIF
	 ENDIF
	 IF (xtext_pos(i).NE.-999.AND.ytext_pos(i).NE.-999) THEN

	 IF (frmat.EQ.11) THEN
	  Write (95,11)comment,xtext_pos(i),hkm,ytext_pos(i),vkm,
     $    theta(i),zct_int,spacex,spacey
	 ELSEIF (frmat.EQ.12) THEN
	  Write (95,12)comment,xtext_pos(i),hkm,ytext_pos(i),vkm,
     $    theta(i),zct_int,spacex,spacey
	 ELSEIF (frmat.EQ.13) THEN
	  Write (95,13)comment,xtext_pos(i),hkm,ytext_pos(i),vkm,
     $    theta(i),zct_int,spacex,spacey
	 ELSEIF (frmat.EQ.14) THEN
	  Write (95,14)comment,xtext_pos(i),hkm,ytext_pos(i),vkm,
     $    theta(i),zct_int,spacex,spacey
	 ENDIF

	 ENDIF
	ENDDO

11	   Format (A,F10.2,1X,A,1X,F10.2,1X,A,1X,F6.2,
     +		'(',I1,') -2 2 text_pos',
     $ 		1X,I1,1X,I1,' text2')
12	   Format (A,F10.2,1X,A,1X,F10.2,1X,A,1X,F6.2,
     +		'(',I2,') -2 2 text_pos',
     $ 		1X,I1,1X,I1,' text2')
13	   Format (A,F10.2,1X,A,1X,F10.2,1X,A,1X,F6.2,
     +		'(',I3,') -2 2 text_pos',
     $ 		1X,I1,1X,I1,' text2')
14	   Format (A,F10.2,1X,A,1X,F10.2,1X,A,1X,F6.2,
     +		'(',I4,') -2 2 text_pos',
     $ 		1X,I1,1X,I1,' text2')
15	   Format (A,I1,1X,I1,' text2')

	Return
	End
**************************************************
	Subroutine CloseC (count,line_count)

	Implicit none

	Include 'common1.h'
	Include 'common2.h'
	Include 'common3.h'

	Integer count,line_count

*	Print*, 'Calling CloseC'

500	IF (fill_flag.EQ.'Y') THEN
	  Write (95,*)'closepath'
C      	 write(95,814)count
C814 	 format(1x,'closepath ',I2,' o')
	ELSE
	 Write (95,*)'stroke'
	ENDIF

      	return
      	end
**************************************************
