      PROGRAM FILLOLD                                                           
      REAL U(8000000),V(8000000),W(8000000),DBZ(8000000),DIV(8000000)
      COMMON /AVE/TBGN,TEND,DT,ISPLN                                            
      COMMON /SPCF/ALT(20),ALO(20),CTM(30)                                      
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*56
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      INTEGER*4 MDIM,IMX,JMX,KMX,NS(3)
      CHARACTER NAMEOF*56, NAME*56, JFILE*56, IR*1, TOPYES*1                    
      CHARACTER COMYES*1,COMFILE*56,FSTORE*56,TFILE*56                          
      COMMON /TWO/ SX,SY,SZ,Z0,OLAT,OLON                                        
      DATA FLAG/-999.9/,NS/2*0,1/,MDIM/8000000/,IUPDN/1/                          
      DATA IWCOR/1/                                                             
      OPEN(1,FILE='/dev/null')
      LUCOM=1                                                                 
1     WRITE(6,'(''Enter input file /DIR/SUBDIR/NAME:_'')')                  
c      READ (LUCOM,'(A)') NAME                                                   
      NAME='first_guess_fourier_xy.w'
C      OPEN(5,ERR=9999,FILE=NAME,IOSTAT=IERR,STATUS='old',                       
C     1FORM='UNFORMATTED') 
C10    READ (5) ITIME,IFLID,ISTM,IMAX,JMAX,KMAX,SX,SY,SZ,OLAT,OLON,Z0,           
C     1         STIME1,ETIME1,STIME2,ETIME2,IUNFL,NMOSM,ROT                      
C      WRITE (1,12) ITIME,IFLID,ISTM,IMAX,JMAX,KMAX,SX,SY,SZ,OLAT,OLON,          
C     1             Z0,IUNFL,NMOSM,ROT                                           
C12    FORMAT ('File created on ',15A2/4A2,1X,6A2/' IMAX JMAX KMAX:',            
C     1        5X,3I4/' SX SY SZ:',3F7.3/' OLAT OLON Z0:',2F8.2,F5.1/            
C     2        ' IUNFL:',I2,1X,'NMOSM:',I1,' ROT:',F5.1)                         
10    CALL READHEADER(5,NAME,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,Z0,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      LUOUT=6
      WRITE(LUOUT,*)CREATIME
      WRITE(LUOUT,*)FLTNAME
      WRITE(LUOUT,*)STMNAME
      WRITE(LUOUT,*)'KEYWORD,RADAR,EXPERIMENT'
      WRITE(LUOUT,'(A4,2X,A4,2X,A32)')KEYWORD,RADAR,EXPERIMENT
      WRITE(LUOUT,*)'EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN'
      WRITE(LUOUT,*)EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(LUOUT,*)'FLAG,EXTRA2'
      WRITE(LUOUT,*)FLAG,EXTRA2
      WRITE(LUOUT,*)'EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ'
      WRITE(LUOUT,*)EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,Z0
      WRITE(LUOUT,*)'ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL'
      WRITE(LUOUT,*)ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL
      WRITE(LUOUT,*)'AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7'
      WRITE(LUOUT,*)AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7
      IUPDN=2
      IWCOR=0
      XDIM=IMAX*SX-OLAT                                                         
      YDIM=JMAX*SY-OLON                                                         
      IF(KEYWORD.EQ.'RUV '.OR.KEYWORD.EQ.'ruv ')THEN
       IUV=1
      ELSE
       IUV=0
      ENDIF
      CALL LDPLN(U,V,W,DBZ,DIV,IMAX,JMAX,KMAX,IUV)
      CLOSE(5)
      WRITE(6,*)'REMOVE RZ MEAN (1), R MEAN (2) OR NOTHING (0)?'
c      READ(1,*)IREMOVE
      IREMOVE=0
      IF(IREMOVE.GT.0)THEN
       CALL REMOVE_RZMEAN(U,V,W,DBZ,IMAX,JMAX,KMAX,IREMOVE)
      ENDIF
      IF(IREMOVE.EQ.0)THEN
       WRITE(6,*)'REMOVE A CONSTANT VELOCITY (1/0)?'
       IREMOVE=0
C       READ(1,*)IREMOVE
       IF(IREMOVE.EQ.1)THEN
        WRITE(6,*)'IS THIS AN R/T(0) OR A XY(1) FILE?'
        READ(1,*)IREMOV
        WRITE(6,*)'ENTER U,V TO REMOVE'
        READ(1,*)USUB,VSUB
        IF(IREMOV.EQ.1)THEN
         CALL REMOVE_CONSTANT(U,V,IMAX,JMAX,KMAX,USUB,VSUB)
        ELSE
         CALL REMOVE_CONSTANT2(U,V,IMAX,JMAX,KMAX,YZ,SY,USUB,VSUB)
        ENDIF
       ENDIF
      ENDIF
999      WRITE(6,'("Enter output file name: ")') 
C         READ (LUCOM,'(A)') NAMEOF                                              
         NAMEOF='first_guess_fourier_xy.w'
         WRITE(6,*)'Enter output type wind (0) or ruv (1)'
         IUV=0
C         READ(1,*)IUV
         IF(IUV.EQ.1)THEN
          KEYWORD='RUV '
         ELSE
          KEYWORD='WIND'
          IUV=0
         ENDIF
C         OPEN(5,FILE=NAMEOF,IOSTAT=IERR,FORM='UNFORMATTED')
C1000     WRITE (5,ERR=998,IOSTAT=IERR) ITIME,IFLID,ISTM,IMAX,JMAX,KMAX,         
C     1        SX,SY,SZ,OLAT,OLON,Z0,STIME1,ETIME1,STIME2,ETIME2,IUNFL,          
C     2        NMOSM,ROT                                                         
         write(6,*)'calling writeheader for output file'
         CALL WRITEHEADER(5,NAMEOF,KEYWORD,FLTNAME,
     +   STMNAME,RADAR,EXPERIMENT,
     +   CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     +   IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +   SX,SY,SZ,XZ,YZ,Z0,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +   POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,LUOUT)
       write(6,*)'called it'
      WRITE(LUOUT,*)CREATIME
      WRITE(LUOUT,*)FLTNAME
      WRITE(LUOUT,*)STMNAME
      WRITE(LUOUT,*)'KEYWORD,RADAR,EXPERIMENT'
      WRITE(LUOUT,'(A4,2X,A4,2X,A32)')KEYWORD,RADAR,EXPERIMENT
      WRITE(LUOUT,*)'EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN'
      WRITE(LUOUT,*)EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(LUOUT,*)'FLAG,EXTRA2'
      WRITE(LUOUT,*)FLAG,EXTRA2
      WRITE(LUOUT,*)'EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ'
      WRITE(LUOUT,*)EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,Z0
      WRITE(LUOUT,*)'ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL'
      WRITE(LUOUT,*)ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL
      WRITE(LUOUT,*)'AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7'
      WRITE(LUOUT,*)AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7
      IMX=IMAX                                                                  
      JMX=JMAX                                                                  
      KMX=KMAX                                                                  
      IF(NMOSM.EQ.1)THEN
       OLAT=XZ
       OLON=YZ
      ENDIF
      IF(IUPDN.NE.2)THEN
       CALL DIVER(U,V,DIV,IMAX,JMAX,KMAX,SX,SY)
c       CALL DIVER(U,V,DIV,IMAX,JMAX,KMAX,LUOUT)                                   
       CALL VMOTN(U,V,DIV,W,IMAX,JMAX,KMAX,IUPDN,IWCOR,LUOUT)                       
      ENDIF
19    CALL WRPLN(U,V,W,DBZ,DIV,IMAX,JMAX,KMAX,LUOUT,IUV)
      WRITE(LUOUT,'(" Disk file has been stored.")')                         
      CLOSE (5)                                                                 
      STOP                                                                      
9999  WRITE(LUOUT,'("Error ",I4," on file ",A40,"trying /hrd/dat/")') 
     +      IERR,NAME                                                           
      JFILE= '/hrd/dat/' // NAME 
      OPEN(5,ERR=988,FILE=JFILE,IOSTAT=IERR,STATUS='old',
     + FORM='UNFORMATTED')                       
      GO TO 10                                                                  
988   WRITE(LUOUT,'("Error ",I4," on file ",A40,"not on /HRDDAT/")')            
     +      IERR,JFILE                                                          
      GO TO 1                                                                   
998   WRITE(LUOUT,'("error on output header write, ier=",i4)') IER              
      GO TO 19                                                                  
      END                                                                       
      SUBROUTINE WRPLN(U,V,W,DBZ,DIV,IMAX,JMAX,KMAX,LUOUT,IUV)                              
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DIV(IMAX,JMAX,KMAX),DBZ(IMAX,JMAX,KMAX)
      INTEGER*2 WD(2400),WS(2400),WW(2400),DB(2400),DV(2400)   
      REAL RWD(2400),RWS(2400),RWW(2400),RDV(2400)
      FLAG=-1.0E+10
      DO 1 K=1,KMAX                                                             
c       WRITE(LUOUT,'("  storing level #",i3)') K                              
       NSUM=0
       USUM=0
       VSUM=0
       DO 2 J=1,JMAX                                                          
        DO 3 I=1,IMAX                                                       
         IF(DBZ(I,J,K).GT.FLAG)THEN
          DB(I)=NINT(DBZ(I,J,K)*10.)
         ELSE
          DB(I)=-9999
         ENDIF
         IF(U(I,J,K).GT.FLAG)THEN
          NSUM=NSUM+1
          USUM=USUM+U(I,J,K)
          VSUM=VSUM+V(I,J,K)
         ENDIF
         IF(IUV.EQ.1)THEN
          RWD(I)=U(I,J,K)
          RWS(I)=V(I,J,K)
          RWW(I)=W(I,J,K)
          RDV(I)=DIV(I,J,K)
         ELSE
          IF(W(I,J,K).GT.FLAG)THEN
           WW(I)=NINT(W(I,J,K)*100.)
          ELSE
           WW(I)=-9999
          ENDIF
          IF(DIV(I,J,K).GT.FLAG)THEN
           DV(I)=NINT(DIV(I,J,K)*100000.)
          ELSE
           DV(I)=32767
          ENDIF
          US=U(I,J,K)
          VS=V(I,J,K)
          IF(US.LT.-900. .OR. VS.LT.-900.) THEN                             
           WDD=-999.9                                                     
           WSS=-999.9                                                     
          ELSE                                                              
           IF(US.NE.0..OR.VS.NE.0.)THEN
            WDD=AMOD(630.0-57.29578*ATAN2(VS,US),360.0)                    
            WSS=SQRT(US*US + VS*VS)                                        
           ELSE
            WDD=1.
            WSS=0.
           ENDIF
          ENDIF                                                             
          WD(I)=NINT(WDD*10.)                                               
          WS(I)=NINT(WSS*10.)                                               
         ENDIF
3       CONTINUE                                                          
        IF(IUV.EQ.1)THEN
         WRITE(5)(RWD(I),RWS(I),RWW(I),DB(I),RDV(I),I=1,IMAX)
        ELSE
         WRITE (5) (WD(I),WS(I),WW(I),DB(I),DV(I),I=1,IMAX)                   
        ENDIF
2      CONTINUE                                                               
       IF(NSUM.GT.0)THEN
        UMEAN=USUM/NSUM
        VMEAN=VSUM/NSUM
        WRITE(6,*)'K,UMEAN,VMEAN = ',K,UMEAN,VMEAN
       ENDIF
1     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
      SUBROUTINE LDPLN(U,V,W,DBZ,DIV,IMAX,JMAX,KMAX,IUV)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX),DIV(IMAX,JMAX,KMAX)
      REAL RWD(2400),RWS(2400),RWW(2400),RDV(2400)
      INTEGER*2 WD(2400),WS(2400),DB(2400),WW(2400),DV(2400)         
      FLAG=-1.0E+10
      DO 1 K=1,KMAX                                                             
c       WRITE(6,'("loading plane #",i3)') K,iuv
       DO 2 J=1,JMAX                                                          
        IF(IUV.EQ.1)THEN
         READ(5)(RWD(I),RWS(I),RWW(I),DB(I),RDV(I),I=1,IMAX)
c         write(6,*)'j,rwd = ',j,rwd
        ELSE
         READ(5) (WD(I),WS(I),WW(I),DB(I),DV(I),I=1,IMAX)                   
        ENDIF
        DO 3 I=1,IMAX                                                       
         IF(IUV.EQ.0)THEN
          WDR=WD(I)*.1                                                     
          WSP=WS(I)*.1                                                     
          IF (WDR.LT.0.) THEN                                              
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE                                                             
C           CALL COMP(XU,XV,WDR,WSP)                                       
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU
           V(I,J,K)=XV
          ENDIF                                                            
          IF(WW(I).GT.-9000)THEN
           W(I,J,K)=WW(I)*.01
          ELSE
           W(I,J,K)=FLAG
          ENDIF
          IF(DV(I).LT.32767)THEN
           DIV(I,J,K)=DV(I)/100000.
          ELSE
           DIV(I,J,K)=FLAG
          ENDIF
         ELSE
          IF(RWW(I).LE.-100000.)RWD(I)=FLAG
          IF(RWS(I).LE.-100000.)RWS(I)=FLAG
          IF(RWW(I).LE.-100000.)RWW(I)=FLAG
          IF(RDV(I).LE.-100000.)RDV(I)=FLAG
          U(I,J,K)=RWD(I)
          V(I,J,K)=RWS(I)
          W(I,J,K)=RWW(I)
          DIV(I,J,K)=RDV(I)
         ENDIF
         IF(DB(I).GT.-9000)THEN
          DBZ(I,J,K)=DB(I)*.1
         ELSE
          DBZ(I,J,K)=FLAG
         ENDIF
3       CONTINUE                                                         
2      CONTINUE                                                               
1     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
      SUBROUTINE DBZCHK(IDATA,IMAX,JMAX,KMAX,DBTH)                              
      INTEGER IDATA(5,IMAX,JMAX,KMAX)                                      
C     DO J=1,JMAX 
C      WRITE(1,*)'J= ',J,(IDATA(4,I,J,1),I=1,IMAX)
C     ENDDO 
         DO 5 J=1,JMAX                                                          
           DO 4 I=1,IMAX                                                        
              DO 6 K=KMAX,1,-1                                                  
                IF(IDATA(4,I,J,K).LT.INT(DBTH))THEN                             
                  IDATA(1,I,J,K)=-9999                                          
                  IDATA(2,I,J,K)=-9999                                          
                ELSE                                                            
                  GO TO 4                                                       
                ENDIF                                                           
6             CONTINUE                                                          
4          CONTINUE                                                             
5     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
      SUBROUTINE DIVER(U,V,DIV,IMAX,JMAX,KMAX,SX,SY)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),DIV(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
      DO 1 K=1,KMAX                                                             
c        WRITE(6,'("- computing divergence for plane #",i3)') K  
        DO 2 J=1,JMAX                                                           
          DO 3 I=1,IMAX                                                         
            DIV(I,J,K)=FLAG
            SCALX=SX*1000.0     
            SCALY=SY*1000.0     
            IBOUNDLEFT=-1
            IBOUNDRIGHT=-1
            IBOUNDLOW=-1
            IBOUNDHIGH=-1
            IF(U(I,J,K).LE.FLAG)GO TO 3
            IF(I.EQ.1) THEN                                                     
             IF(U(1,J,K).GT.FLAG)IBOUNDLEFT=1
            ELSEIF(U(I-1,J,K).LE.FLAG)THEN
             IBOUNDLEFT=1                                                                
            ELSE
             IBOUNDLEFT=0
            ENDIF
            IF(IBOUNDLEFT.GT.0)THEN
             IF(I.LE.IMAX-2)THEN
              IF(U(I+1,J,K).GT.FLAG.AND.U(I+2,J,K).GT.FLAG)THEN
               IBOUNDLEFT=3
              ELSEIF(U(I+1,J,K).GT.FLAG)THEN
               IBOUNDLEFT=2
              ENDIF
             ELSEIF(I.EQ.IMAX-1)THEN
              IF(U(IMAX,J,K).GT.FLAG)IBOUNDLEFT=2
             ENDIF
            ENDIF
            IF(J.EQ.1) THEN                                                     
             IF(U(I,1,K).GT.FLAG)IBOUNDLOW=1
            ELSEIF(U(I,J-1,K).LE.FLAG)THEN
             IBOUNDLOW=1                                                                
            ELSE
             IBOUNDLOW=0
            ENDIF
            IF(IBOUNDLOW.GT.0)THEN
             IF(J.LE.JMAX-2)THEN
              IF(U(I,J+1,K).GT.FLAG.AND.U(I,J+2,K).GT.FLAG)THEN
               IBOUNDLOW=3
              ELSEIF(U(I,J+1,K).GT.FLAG)THEN
               IBOUNDLOW=2
              ENDIF
             ELSEIF(J.EQ.JMAX-1)THEN
              IF(U(I,JMAX,K).GT.FLAG)IBOUNDLOW=2
             ENDIF
            ENDIF
            IF(I.EQ.IMAX) THEN                                                     
             IF(U(IMAX,J,K).GT.FLAG)IBOUNDRIGHT=1
            ELSEIF(U(I+1,J,K).LE.FLAG)THEN
             IBOUNDRIGHT=1                                                                
            ELSE
             IBOUNDRIGHT=0
            ENDIF
            IF(IBOUNDRIGHT.GT.0)THEN
             IF(I.GE.3)THEN
              IF(U(I-1,J,K).GT.FLAG.AND.U(I-2,J,K).GT.FLAG)THEN
               IBOUNDRIGHT=3
              ELSEIF(U(I-1,J,K).GT.FLAG)THEN
               IBOUNDRIGHT=2
              ENDIF
             ELSEIF(I.EQ.2)THEN
              IF(U(1,J,K).GT.FLAG)IBOUNDRIGHT=2
             ENDIF
            ENDIF
            IF(J.EQ.JMAX) THEN                                                     
             IF(U(I,JMAX,K).GT.FLAG)IBOUNDHIGH=1
            ELSEIF(U(I,J+1,K).LE.FLAG)THEN
             IBOUNDHIGH=1                                                                
            ELSE
             IBOUNDHIGH=0
            ENDIF
            IF(IBOUNDHIGH.GT.0)THEN
             IF(J.GE.3)THEN
              IF(U(I,J-1,K).GT.FLAG.AND.U(I,J-2,K).GT.FLAG)THEN
               IBOUNDHIGH=3
              ELSEIF(U(I,J-1,K).GT.FLAG)THEN
               IBOUNDHIGH=2
              ENDIF
             ELSEIF(J.EQ.2)THEN
              IF(U(I,1,K).GT.FLAG)IBOUNDHIGH=2
             ENDIF
            ENDIF
            U1=FLAG
            V1=FLAG
            IF(IBOUNDLEFT.EQ.0.AND.IBOUNDRIGHT.EQ.0)THEN
             U1=-U(I-1,J,K)/SCALX/2.
             U2=0.
             U3=U(I+1,J,K)/SCALX/2.
            ELSEIF(IBOUNDLEFT.EQ.2)THEN
             U1=-U(I,J,K)/SCALX
             U2=0.
             U3=U(I+1,J,K)/SCALX
            ELSEIF(IBOUNDLEFT.EQ.3)THEN
             U1=-1.5*U(I,J,K)/SCALX
             U2=2.*U(I+1,J,K)/SCALX
             U3=-.5*U(I+2,J,K)/SCALX
            ELSEIF(IBOUNDRIGHT.EQ.2)THEN
             U1=-U(I-1,J,K)/SCALX
             U2=0.
             U3=U(I,J,K)/SCALX
            ELSEIF(IBOUNDRIGHT.EQ.3)THEN
             U1=.5*U(I-2,J,K)/SCALX
             U2=-2.*U(I-1,J,K)/SCALX
             U3=1.5*U(I,J,K)/SCALX
            ENDIF
            IF(IBOUNDLOW.EQ.0.AND.IBOUNDHIGH.EQ.0)THEN
             V1=-V(I,J-1,K)/SCALY/2.
             V2=0.
             V3=V(I,J+1,K)/SCALY/2.
            ELSEIF(IBOUNDLOW.EQ.2)THEN
             V1=-V(I,J,K)/SCALY
             V2=0.
             V3=V(I,J+1,K)/SCALY
            ELSEIF(IBOUNDLOW.EQ.3)THEN
             V1=-1.5*V(I,J,K)/SCALY
             V2=2.*V(I,J+1,K)/SCALY
             V3=-.5*V(I,J+2,K)/SCALY
            ELSEIF(IBOUNDHIGH.EQ.2)THEN
             V1=-V(I,J-1,K)/SCALY
             V2=0.
             V3=V(I,J,K)/SCALY
            ELSEIF(IBOUNDHIGH.EQ.3)THEN
             V1=.5*V(I,J-2,K)/SCALY
             V2=-2.*V(I,J-1,K)/SCALY
             V3=1.5*V(I,J,K)/SCALY
            ENDIF
            IF(U1.GT.FLAG.AND.V1.GT.FLAG)THEN
             DIV(I,J,K)=U1+U2+U3+V1+V2+V3
            ELSE
             DIV(I,J,K)=FLAG
            ENDIF             
C       WRITE(1,*)'I,J,K,U1,U2,U3,V1,V2,V3 = '
C       WRITE(1,*)I,J,K,U1,U2,U3,V1,V2,V3
C       WRITE(1,*)'DIV = ',DIV(I,J,K)
C            IF(IDATA(5,I,J,K).GE.32767)
C     1       write(6,*)'I,J,K,V1,V2,U1,U2',I,J,K,V1,V2,U1,U2
3           CONTINUE                                                            
2         CONTINUE                                                              
1       CONTINUE                                                                
      RETURN                                                                    
      END                                                                       
      SUBROUTINE VMOTN(U,V,DV,W,IMAX,JMAX,KMAX,IUPDN,IWCOR,LUOUT)                  
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DV(IMAX,JMAX,KMAX)
      COMMON /TWO/ SX,SY,SZ,Z0,OLAT,OLON                                        
      FLAG=-1.0E+10
      DATA H0/0.1043705/                                                        
      WRITE(LUOUT,'("  --  starting vertical velocity computation"/)')
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         W(I,J,K)=FLAG
        ENDDO
       ENDDO
      ENDDO
      DO 1 J=1,JMAX                                                             
       DO 2 I=1,IMAX                                                           
        LAST=1                                                                
        IBOT=KMAX                                                             
        WL=0.                                                                 
        HL=0.                                                                 
        IF (IUPDN .EQ. 1) HL=Z0 + (KMAX-1)*SZ + SZ*.5                         
        IGOOD=0                                                               
        IDEL=-1                                                                
        IF (IUPDN .EQ. 1) IDEL=1                                             
        DO 3 KZ=1,KMAX                                                        
         K=KZ                                                              
         IF (IUPDN .EQ. 1) K=KMAX+1-KZ                                     
         WW=FLAG
         H= Z0 + FLOAT(K-1)*SZ        ! IN KM                              
         DIV=DV(I,J,K)    ! IN S-1                             
         IF(DIV.EQ.FLAG)GO TO 33               
          IF(KZ.EQ.1) THEN                                               
           DIVL=DIV                                                       
          ELSE                                                              
           DIVL=DV(I,J,K+(IDEL*1)) ! IN S-1                     
           IF(DIVL.LE.FLAG)DIVL=DIV
          ENDIF                                                             
          DZ=H-HL                                                         
          IF(K.GT.2)THEN
           SZTEST=ABS(SZ)+.0001
           IF(ABS(DZ).GT.SZTEST)THEN
            IGOOD=0
           ENDIF
          ENDIF
          ZZ=-DZ*.5*H0*IDEL                                                  
          IGOOD=1                                                           
          WW=WL*EXP(DZ*H0)-(.5*DIV+.5*DIVL*EXP(DZ*H0))*DZ*1000.  ! IN M/S 
          LAST=MAX0(K,LAST)                                                 
          IBOT=MIN0(K,IBOT)                                                 
          WL=WW                                                             
          HL=H                                                              
33        IF(IGOOD.EQ.1)THEN
           WOUT=WW
          ELSE
           WOUT=FLAG
          ENDIF
3        W(I,J,K)=WOUT
         IF (IWCOR.EQ.0) GO TO 2                                                
         IF (IBOT.EQ.KMAX) GO TO 2                                              
         N1=IBOT                                                                
         N2=LAST                                                                
         INC=1                                                                  
         IF (IUPDN .EQ. 1) THEN                                                 
            N1=LAST                                                             
            N2=IBOT                                                             
            INC=-1                                                              
         ENDIF                                                                  
         WBC=W(I,J,N2)
         WT=0.0                                                                 
         AM=LAST-IBOT + 1.5                                                     
         HAM=AM*SZ*1000.                                                        
         DIVCOR=(WBC-WT)/HAM                                                    
         AK=0.                                                                  
         DO 4 K=N1,N2,INC                                                       
           AK=AK+1.                                                             
           WW=W(I,J,K)
           DIV=DV(I,J,K)
           IF(WW.GT.FLAG) THEN                                                   
             WW=WW - (AK* (WBC-WT))/AM         !CORRECTED W                       
             W(I,J,K)=WW
           ENDIF                                                                
           IF(DIV.GT.FLAG) THEN                                          
              DIV=DIV - DIVCOR               !CORRECTED DIVERGENCE              
              DV(I,J,K)=DIV
           ENDIF                                                                
4          CONTINUE                                                             
2        CONTINUE                                                               
1      CONTINUE                                                                 
      RETURN                                                                    
      END                                                                       
      SUBROUTINE READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*56
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
c      INTEGER*4 IMAX4,JMAX4,KMAX4,KOUNT4,NMOSM4,IUNFLD4,IATTEN4,
c     +        FLAG4,EXTRA24,EXTRA34
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN,
     + FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
c      IMAX=IMAX4
c      JMAX=JMAX4
c      KMAX=KMAX4
c      KOUNT=KOUNT4
c      NMOSM=NMOSM4
c      IUNFLD=IUNFLD4
c      IATTEN=IATTEN4
c      FLAG=FLAG4
c      EXTRA2=EXTRA24
c      EXTRA3=EXTRA34
      RETURN
      END
      SUBROUTINE WRITEHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,LUOUT)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*56
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
c      INTEGER*4 IMAX4,JMAX4,KMAX4,KOUNT4,NMOSM4,IUNFLD4,IATTEN4,
c     +        FLAG4,EXTRA24,EXTRA34
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,FORM='UNFORMATTED')
      WRITE(LUOUT,*)'OPENED LU ',LU,' AS '
      WRITE(LUOUT,'(A)')FILNAM
      IMAX4=IMAX
      JMAX4=JMAX
      KMAX4=KMAX
      KOUNT4=KOUNT
      NMOSM4=NMOSM
      IUNFLD4=IUNFLD
      IATTEN4=IATTEN
      FLAG4=FLAG
      EXTRA24=EXTRA2
      EXTRA34=EXTRA3
      WRITE(LU)KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN,
     + FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
c      WRITE(LU)KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,CREATIME,
c     + EXTRA1,IMAX4,JMAX4,KMAX4,KOUNT4,NMOSM4,IUNFLD4,IATTEN4,
c     + FLAG4,EXTRA24,
c     + EXTRA34,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
c     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
c     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE REMOVE_RZMEAN(U,V,W,DBZ,IMAX,JMAX,KMAX,IREMOVE)
      REAL DBZ(IMAX,JMAX,KMAX)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
      WRITE(6,*)'ENTERED REMOVE_RZMEAN'
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      IF(IREMOVE.EQ.1)THEN
       DO K=1,KMAX
        DO I=1,IMAX
         SUMU=0.
         NSUMU=0
         SUMV=0.
         SUMW=0.
         DO J=1,JMAX
          IF(U(I,J,K).GT.FLAG)THEN
           SUMU=SUMU+U(I,J,K)
           SUMV=SUMV+V(I,J,K)
           SUMW=SUMW+W(I,J,K)
           NSUMU=NSUMU+1
          ENDIF
         ENDDO
         IF(NSUMU.EQ.JMAX)THEN
          SUMU=SUMU/NSUMU
          SUMV=SUMV/NSUMU
          SUMW=SUMW/NSUMU
          DO J=1,JMAX
           U(I,J,K)=U(I,J,K)-SUMU
           V(I,J,K)=V(I,J,K)-SUMV
           W(I,J,K)=W(I,J,K)-SUMW
          ENDDO
         ELSE
          DO J=1,JMAX
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ELSEIF(IREMOVE.EQ.2)THEN
       DO I=1,IMAX
        SUMU=0.
        NSUMU=0
        SUMV=0.
        SUMW=0.
        DO K=1,KMAX
         DO J=1,JMAX
          IF(U(I,J,K).GT.FLAG)THEN
           SUMU=SUMU+U(I,J,K)
           SUMV=SUMV+V(I,J,K)
           SUMW=SUMW+W(I,J,K)
           NSUMU=NSUMU+1
          ENDIF
         ENDDO
        ENDDO
        IF(NSUMU.GT.0)THEN
         SUMU=SUMU/NSUMU
         SUMV=SUMV/NSUMU
         SUMW=SUMW/NSUMU
         DO K=1,KMAX
          DO J=1,JMAX
           U(I,J,K)=U(I,J,K)-SUMU
           V(I,J,K)=V(I,J,K)-SUMV
           W(I,J,K)=W(I,J,K)-SUMW
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ELSEIF(IREMOVE.EQ.3)THEN
       DO J=1,JMAX
        DO I=1,IMAX
         SUMU=0.
         NSUMU=0
         SUMV=0.
         SUMW=0.
         DO K=1,KMAX
          IF(U(I,J,K).GT.FLAG)THEN
           SUMU=SUMU+U(I,J,K)
           SUMV=SUMV+V(I,J,K)
           SUMW=SUMW+W(I,J,K)
           NSUMU=NSUMU+1
          ENDIF
         ENDDO
         IF(NSUMU.GT.0)THEN
          SUMU=SUMU/NSUMU
          SUMV=SUMV/NSUMU
          SUMW=SUMW/NSUMU
          DO K=1,KMAX
           U(I,J,K)=U(I,J,K)-SUMU
           V(I,J,K)=V(I,J,K)-SUMV
           W(I,J,K)=W(I,J,K)-SUMW
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ELSEIF(IREMOVE.EQ.4)THEN
       DO J=1,JMAX
        DO I=1,IMAX
         IF(U(I,J,2).GT.FLAG)THEN
          SUMU=U(I,J,2)
          SUMV=V(I,J,2)
          DO K=1,KMAX
           U(I,J,K)=U(I,J,K)-SUMU
           V(I,J,K)=V(I,J,K)-SUMV
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ELSEIF(IREMOVE.EQ.5)THEN
       DO K=1,KMAX
        DO I=1,IMAX
         SUMU=0.
         NSUMU=0
         SUMV=0.
         SUMW=0.
         SUMZ=0.
         DO J=1,JMAX
          IF(U(I,J,K).GT.FLAG)THEN
           SUMU=SUMU+U(I,J,K)
           SUMV=SUMV+V(I,J,K)
           SUMW=SUMW+W(I,J,K)
           Z=10.**(DBZ(I,J,K)/10.)
           SUMZ=SUMZ+Z
           NSUMU=NSUMU+1
          ENDIF
         ENDDO
         IF(NSUMU.GT.0)THEN
          SUMU=SUMU/NSUMU
          SUMV=SUMV/NSUMU
          SUMW=SUMW/NSUMU
          SUMZ=SUMZ/NSUMU
          Z=10.*ALOG10(SUMZ)
          DO J=1,JMAX
           U(I,J,K)=SUMU
           V(I,J,K)=SUMV
           W(I,J,K)=SUMW
           DBZ(I,J,K)=Z
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE REMOVE_CONSTANT(U,V,IMAX,JMAX,KMAX,USUB,VSUB)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
      WRITE(6,*)'ENTERED REMOVE_CONSTANT'
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         IF(U(I,J,K).GT.FLAG)THEN
          U(I,J,K)=U(I,J,K)-USUB
          V(I,J,K)=V(I,J,K)-VSUB
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE REMOVE_CONSTANT2(U,V,IMAX,JMAX,KMAX,YZ,SY,USUB,VSUB)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
      WRITE(6,*)'ENTERED REMOVE_CONSTANT'
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      DO K=1,KMAX
       DO J=1,JMAX
        ANGLE=YZ+(J-1)*SY*3.14159/180.
        ZCOS=COS(ANGLE)
        ZSIN=SIN(ANGLE)
        USUB2=ZCOS*USUB+ZSIN*VSUB
        VSUB2=ZCOS*VSUB-ZSIN*USUB
        DO I=1,IMAX
         IF(U(I,J,K).GT.FLAG)THEN
          U(I,J,K)=U(I,J,K)-USUB2
          V(I,J,K)=V(I,J,K)-VSUB2
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END

