      PROGRAM WINDTOASCII
c      USE NETCDF
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80,OUTFILNAM*80
      CHARACTER INFILEFILE*80, OUTFILEFILE*80,SUMMARYFLIGHTID*8
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      LOGICAL SUMMARYEXISTS
C     U=EAST-WEST WIND COMPONENT
C     V=NORTH-SOUTH WIND COMPONENT
C     W=VERTICAL WIND COMPONENT
C     DBZ=RADAR REFLECTIVITY
C     WS=WIND SPEED
C     TW=TANGENTIAL WIND
C     RW=RADIAL WIND
      REAL U(8000000),V(8000000),W(8000000),DBZ(8000000)
      REAL WS(8000000),TW(8000000),RW(8000000)
      REAL X(800),Y(800),Z(800),U2(8000000)
      REAL UWRITE(8000000),VWRITE(8000000),MAXDBZ(100000)
      REAL UWRITE1(1000000),VWRITE1(1000000)
      INTEGER IconvertMAXDBZ(1000000),IconvertU(1000000)
      INTEGER IconvertV(1000000),IconvertMD(1000000)
      CHARACTER CDUMMY*1,CDUMMY13*13,CDUMMY15*15,CDUMMY25*25
      LU=80
      INCLUDEINCOMPOSITE=1
c      WRITE(6,*)'Enter input file names file name'
c      READ(5,*)INFILEFILE
c      WRITE(6,*)'Enter output file names file name'
c      READ(5,'(A80)')OUTFILEFILE
C     INFILEFILE CONTAINS THE NAMES OF HRD-FORMAT 3D WIND FILES
C     OUTFILEFILE CONTAINS THE NAME OF NETCDF 3D WIND FILES
      ICALLTEST=0
      INFILEFILE='infiles'
      OUTFILEFILE='outfiles'
      OPEN(82,FILE=INFILEFILE)
      OPEN(83,FILE=OUTFILEFILE)
C     LOOP THROUGH ALL THE INPUT FILES UNTIL EOF
1     READ(82,'(A80)',END=999)FILNAM
      READ(83,'(A80)',END=999)OUTFILNAM
      WRITE(6,180)FILNAM
      NAMELENGTH=LEN_TRIM(FILNAM)
      IF(NAMELENGTH.EQ.18)THEN
         ICALLTEST=0
      ELSE
         ICALLTEST=1
      ENDIF
      WRITE(6,*)'ICALLTEST = ',ICALLTEST
      WRITE(6,181)OUTFILNAM
180   FORMAT('INPUT FILE NAME IS ',A80)
181   FORMAT('OUTPUT FILE NAME IS ',A80)
      LUOUT=81
C      ICALLTEST=ICALLTEST+1
c      OPEN(LUOUT,FILE=OUTFILNAM)
C     READ THE HEADER OF THE HRD-FORMAT BINARY FILE
      CALL READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C KEYWORD=WIND MEANS 16-BIT INTEGER BINARY DATA
C KEYWORD=RUV MEANS 32-BIT REAL DATA
      IF(KEYWORD.EQ.'WIND'.OR.KEYWORD.EQ.'wind')THEN
       IUV=0
       WRITE(6,*)'IUV = ',IUV
      ELSEIF(KEYWORD.EQ.'RUV '.OR.KEYWORD.EQ.'ruv ')THEN
       IUV=1
       WRITE(6,*)'IUV = ',IUV
      ELSE
       WRITE(6,89)KEYWORD
89     FORMAT('KEYWORD IS ',A4,'....STOPPING')
       STOP
      ENDIF
C      WRITE(6,*)'FLTNAME = ',FLTNAME
      WRITE(6,'(A4)')KEYWORD
      WRITE(LUOUT,'(A4)')KEYWORD
      WRITE(6,'(A8)')FLTNAME
      WRITE(LUOUT,'(A8)')FLTNAME
      WRITE(6,'(A12)')STMNAME
      WRITE(LUOUT,'(A12)')STMNAME
      WRITE(6,'(A4)')RADAR
      WRITE(LUOUT,'(A4)')RADAR
      WRITE(6,'(A32)')EXPERIMENT
      WRITE(LUOUT,'(A32)')EXPERIMENT
      WRITE(6,'(A32)')CREATIME
      WRITE(LUOUT,'(A32)')CREATIME
      WRITE(6,'(A28)')EXTRA1
      WRITE(LUOUT,'(A28)')EXTRA1
      IF(IABS(KOUNT).GT.100)KOUNT=100
      WRITE(6,'(7I10)')IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(LUOUT,'(7I10)')IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(6,'(3I10)')FLAG,EXTRA2,EXTRA3
      WRITE(LUOUT,'(3I10)')FLAG,EXTRA2,EXTRA3
      WRITE(6,'(4E14.6)')STIME,ETIME,OLAT,OLON
      WRITE(LUOUT,'(4E14.6)')STIME,ETIME,OLAT,OLON
      WRITE(6,'(6F10.3)')SX,SY,SZ,XZ,YZ,ZZ
      WRITE(LUOUT,'(6F10.2)')SX,SY,SZ,XZ,YZ,ZZ
      WRITE(6,'(4E14.6)')ROT,RA,CO1,CO2
      WRITE(LUOUT,'(4E14.6)')ROT,RA,CO1,CO2
      WRITE(6,'(6E13.5)')AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL
      WRITE(LUOUT,'(6E13.5)')AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL
      WRITE(6,'(4E14.6)')ETIME1,STIME2,EXTRA6,EXTRA7
      WRITE(LUOUT,'(4E14.6)')ETIME1,STIME2,EXTRA6,EXTRA7
C
C LOAD THE WIND AND REFLECTIVITY DATA FROM THE HRD-FORMAT 3D FILE
C
      CALL LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
C
C COMPUTE WIND SPEED (WS), TANGENTIAL WIND (TW), AND RADIAL WIND (RW)
C FROM U AND V
C
      CALL ALLWIND(SX,SY,XZ,YZ,IMAX,JMAX,KMAX,U,V,WS,TW,RW)
C
C WRITENETCDF WILL CREATE A NETCDF FILE, REMAP FROM X-Y COORDINATES 
C RELATIVE TO THE STORM CENTER, REMAP FROM FORTRAN STORAGE HIERARCHY
C TO NETCDF (C) STORAGE HIERARCY, DECLARE AND WRITE ALL METADATA, DIMENSIONS
C AND VARIABLES TO NETCDF FILE, AND THEN CLOSE THE FILE
C
      INCLUDEINCOMPOSITE=1
      WRITE(6,*)INCLUDEINCOMPOSITE
      INQUIRE(FILE='summary',EXIST=SUMMARYEXISTS)
      IF(SUMMARYEXISTS)THEN
         OPEN(LUIN,FILE="summary")
         READ(LUIN,'(A13,A8)')CDUMMY13,SUMMARYFLIGHTID
         IF(SUMMARYFLIGHTID.NE.FLTNAME)THEN
            INCLUDEINCOMPOSITE=0
         ENDIF
         WRITE(6,'(A13,1X,A13,1X,I1)')
     +        SUMMARYFLIGHTID,FLTNAME,INCLUDECOMPOSITE
         DO K=1,4
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A15,3I2)')CDUMMY15,IHSS,IMSS,ISSS
         DO K=1,3
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A13,3I2)')CDUMMY13,IHES,IMES,ISES
         DO K=1,5
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A25,I1)')CDUMMY25,IACCEPTABLE
         CLOSE(LUIN)
         WRITE(6,*)'IACCEPTABLE = ',IACCEPTABLE
         IF(IACCEPTABLE.NE.1)INCLUDEINCOMPOSITE=0
         STIMES=IHSS*3600.+IMSS*60.+ISSS*1.
         ETIMES=IHES*3600.+IMES*60.+ISES*1.
         WRITE(6,*)'STIME,STIMES,ETIME,ETIMES,STIME1,ETIME2 = ',
     1        STIME,STIMES,ETIME,ETIMES,STIME1,ETIME2
         IF(STIMES.NE.STIME.OR.ETIMES.NE.ETIME)INCLUDEINCOMPOSITE=0
      ENDIF
      WRITE(6,*)'INCLUDEINCOMPOSITE = ',INCLUDEINCOMPOSITE
      CALL WRITENETCDF(IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ,
     1 U,V,W,DBZ,X,Y,Z,KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     1 CREATIME,EXTRA1,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,
     1 STIME,ETIME,OLAT,OLON,ROT,RA,CO1,CO2,
     1 AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,
     1 EXTRA7,U2,OUTFILNAM,WS,RW,TW,ICALLTEST,
     1 UWRITE,VWRITE,UWRITE1,VWRITE1,MAXDBZ,IconvertMAXDBZ,
     1 IconvertU,IconvertV,IconvertMD,INCLUDEINCOMPOSITE)
c      CALL WRITEDATA(LUOUT,U,V,W,DBZ,IMAX,JMAX,KMAX)
      CLOSE(80)
      CLOSE(81)
C GO TO 1 AND SEE IF THERE ARE ANY MORE FILES TO CONVERT
      GO TO 1
999   STOP
      END
      SUBROUTINE ALLWIND(SX,SY,XZ,YZ,IMAX,JMAX,KMAX,U,V,WS,TW,RW)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),WS(IMAX,JMAX,KMAX)
      REAL TW(IMAX,JMAX,KMAX),RW(IMAX,JMAX,KMAX)
      DO K=1,KMAX
         DO J=1,JMAX
            Y=-.5*SY+J*SY-YZ
            DO I=1,IMAX
               X=.5*SX+I*SY-XZ
               RADIUS=SQRT(X*X+Y*Y)
               U1=U(I,J,K)
               V1=V(I,J,K)
               IF(U1.GT.-900)THEN
                  WS(I,J,K)=SQRT(U1*U1+V1*V1)
                  TW(I,J,K)=(V1*X-U1*Y)/RADIUS
                  RW(I,J,K)=(U1*X+V1*Y)/RADIUS
               ELSE
                  WS(I,J,K)=-999.9
                  TW(I,J,K)=-999.9
                  RW(I,J,K)=-999.9
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,
     + RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
c      USE NETCDF
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX)
      INTEGER*2 IU(800),IV(800),IW(800),IDB(800),IDV(800)
      REAL RU(800),RV(800),RW(800),RDV(800)
      FLAG=-999.9
      WRITE(6,*)'INSIDE LDPLNW'
      WRITE(6,*)'IMAX,JMAX,KMAX,IUV = ',IMAX,JMAX,KMAX,IUV
      DO K=1,KMAX
       DO J=1,JMAX
        IF(IUV.EQ.0)THEN
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
c         write(6,*)'j,k,iu = ',(j,k,iu(i),i=1,imax)
c         write(6,*)'j,k,iv = ',(j,k,iv(i),i=1,imax)
c         write(6,*)'j,k,iw = ',j,k,(iw(i),i=1,imax)
c         write(6,*)'j,k,idb = ',j,k,(idb(i),i=1,imax)
c         write(6,*)'j,k,idv = ',(j,k,idv(i),i=1,imax)
        ELSE
         READ(LU)(RU(I),RV(I),RW(I),IDB(I),RDV(I),I=1,IMAX)
        ENDIF
        DO I=1,IMAX
         IF(IDB(I).GT.-1000)THEN
          DBZZ=IDB(I)*.1
          DBZ(I,J,K)=DBZZ
         ELSE
          DBZZ=FLAG
          DBZ(I,J,K)=FLAG
         ENDIF
         IF(IUV.EQ.0)THEN
          IF(IU(I).LT.-9990)THEN
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE
           WDR=IU(I)*.1
           WSP=IV(I)*.1
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU
           V(I,J,K)=XV
          ENDIF
          IF(IW(I).GT.-9990.AND.DBZZ.GT.FLAG)THEN
           W(I,J,K)=IW(I)*.01
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDIF
c          IF(U(I,J,K).GT.FLAG.AND.W(I,J,K).LE.FLAG)THEN
c           WRITE(6,*)'I,J,K,U,V,W,IU,IV,IW = ',
c     1    I,J,K,U(I,J,K),V(I,J,K),W(I,J,K),IU(I),IV(I),IW(I)
c          ENDIF
         ELSE
          IF(RU(I).GT.FLAG.AND.RV(I).GT.FLAG.AND.RW(I).GT.FLAG)THEN
           U(I,J,K)=RU(I)
           V(I,J,K)=RV(I)
           DBZ(I,J,K)=IDB(I)*.1
           W(I,J,K)=RW(I)
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
           DBZ(I,J,K)=FLAG
          ENDIF
         ENDIF
        ENDDO
c        WRITE(6,*)'J,K,U = ',J,K,(U(I,J,K),I=1,IMAX)
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE WRITENETCDF(IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ,
     1 U,V,W,DBZ,X,Y,Z,KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     1 CREATIME,EXTRA1,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,
     1 STIME,ETIME,OLAT,OLON,ROT,RA,CO1,CO2,
     1 AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,
     1 EXTRA7,U2,OUTFILNAM,WS,RW,TW,ICALLTEST,
     1 UWRITE,VWRITE,UWRITE1,VWRITE1,MAXDBZ,IconvertMAXDBZ,
     1 IconvertU,IconvertV,IconvertMD,INCLUDEINCOMPOSITE)
      USE NETCDF
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80,OUTFILNAM*80
      CHARACTER TIMESIG*13
      CHARACTER OUTFILERADAR*80
      INTEGER KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      INTEGER IKEYWORD,IFLTNAME,ISTMNAME,IRADAR,IEXPERIMENT
      INTEGER ICREATIME,IKOUNT,INMOSM,IIUNFLD,IIATEN,IFLAG,IEXTRA2
      INTEGER IEXTRA3,ISTIME,IETIME,IOLAT,IOLON,ISX,ISY,ISZ
      INTEGER IXZ,IYZ,IZZ,IROT,IRA,ICO1,ICO2,IAZMCOR,IELCOR,ITHRESH
      INTEGER IPOWERT,IBIEL,IAZBIEL,IETIME1,ISTIME2,IEXTRA6,IEXTRA7
      INTEGER IMAX,JMAX,KMAX,ITMAX
      INTEGER IDIMIDS(4),ICOUNT(4),ISTART(4),NCID,ICOUNT1(1)
      INTEGER ISTART1(1)
      INTEGER IDIMIDS3(3),ICOUNT3(3),ISTART3(3)
      INTEGER ISTARTX,ISTARTY,ISTARTZ,test
      INTEGER ICOUNTX,ICOUNTY,ICOUNTZ
      INTEGER IXVARID,IYVARID,IZVARID,ITVARID,INVARID,INC(1)
      INTEGER IXDIMID,IYDIMID,IZDIMID,ITDIMID
      INTEGER IUVARID,IVVARID,IWVARID,IDBZVARID,ISTAT
      INTEGER IULEVELVARID(37),IVLEVELVARID(37)
      INTEGER IWSVARID,ITWVARID,IRWVARID
      CHARACTER ULEVELC(37)*8,VLEVELC(37)*8,LONGNAMEU*41,LONGNAMEV*43
      INTEGER INCLUDEINCOMPOSITE
      REAL UWRITE(IMAX,JMAX,KMAX),VWRITE(IMAX,JMAX,KMAX)
      REAL UWRITE1(IMAX,JMAX),VWRITE1(IMAX,JMAX)
C      INTEGER NF90_CLASSIC_MODE
      REAL X(IMAX),Y(JMAX),Z(KMAX),U(IMAX,JMAX,KMAX),U2(KMAX,JMAX,IMAX)
      REAL V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX),TT(1),VALID_RANGE(2),VALID_RANGE_DBZ(2)
      REAL TW(IMAX,JMAX,KMAX),RW(IMAX,JMAX,KMAX),WS(IMAX,JMAX,KMAX)
      REAL MAXDBZ(IMAX,JMAX)
      DOUBLE PRECISION DSECS,SECS
      INTEGER IconvertMAXDBZ(IMAX,JMAX) 
      REAL DFLAG , NULLW
      REAL VALID_MIN, VALID_MAX
      CHARACTER*80 NETCDFPATH,OUTFILEWIND
      CHARACTER*39 WRITECHAR
      CHARACTER*2 YEAR,MONTH,DAY,HR,MN
      CHARACTER YYYY*19
      INTEGER IconvertU(IMAX,JMAX),IconvertV(IMAX,JMAX)
      INTEGER IconvertMD(IMAX,JMAX)

c      NF90_FLOAT=32
      READ(OUTFILNAM,'(A13)')TIMESIG
      WRITE(OUTFILERADAR,'("AWIPSMaxdb_",A13,"z.nc")')TIMESIG
      WRITE(OUTFILEWIND,'("AWIPSWindComponents_",A13,"z.nc")')TIMESIG
      DO K=1,KMAX
         DO J=1,JMAX
            DO I=1,IMAX
               UWRITE(I,J,K)=-999.9
               VWRITE(I,J,K)=-999.9
            ENDDO
         ENDDO
      ENDDO
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      WRITE(6,*)'NF90_FLOAT = ',NF90_FLOAT
      NETCDFMODE=0
c      NETCDFPATH=OUTFILNAM
      WRITE(6,*)'NF90_NOCLOBBER = ',NF90_NOCLOBBER
      WRITE(6,*)'NF90_NETCDF4 = ',NF90_NETCDF4
      WRITE(6,*)'NF90_CLASSIC_MODEL = ',NF90_CLASSIC_MODEL
      WRITE(6,*)'NF90_FORMAT_NETCDF4 = ',NF90_FORMAT_NETCDF4
C
C OPEN OR CREATE NETCDF FILE
C
      ISTAT=NF90_CREATE(OUTFILNAM,NF90_CLASSIC_MODEL,NCID)
      WRITE(6,*)'NF90_FORMAT_NETCDF4 = ',NF90_FORMAT_NETCDF4
      WRITE(6,*)'CREATE,ISTAT,NCID = ',ISTAT,NCID
      DFLAG=-999.9
      VALID_RANGE_DBZ(1)=-31.9
      VALID_RANGE_DBZ(2)=70.
      VALID_RANGE(1)=-900.
      VALID_RANGE(2)=900.
      VALID_MIN=-900.
      VALID_MAX=900.
C
C CONVERT Y COORDINATE (DISTANCE FROM CENTER) TO LATITUDE
C 111.111 KM = 1 DEG SINCE 10,000 KM IS DISTANCE FROM POLE TO EQUATOR
C
C OLAT AND OLON ARE THE LATITUDE AND LONGITUDE OF THE STORM CENTER 
      DO J=1,JMAX
       Y(J)=(.5+FLOAT(J-1))*SY-YZ
       Y(J)=OLAT+Y(J)/111.111
      ENDDO
C
C SET MINIMUM, MAXIMUM LONGITUDE AND ALL LONGITUDES IN BETWEEN
C USING THE MAXIMUM LATITUDE OF THE ANALYSIS (Y(JMAX))
C
      DO I=1,IMAX
       X(I)=(.5+FLOAT(I-1))*SX-XZ
       X(I)=OLON+X(I)/(COS(Y(JMAX)*3.14159/180.)*111.111)
      ENDDO
      DO K=1,KMAX
       Z(K)=(K-1)*SZ+ZZ
      ENDDO
C
C REMAP ALL THE VARIABLES FROM THE X-Y COORDINATE SYSTEM TO THE LAT-LON
C COORDINATE SYSTEM SET ABOVE
C
      CALL REMAP(U,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(V,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(W,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(RW,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(TW,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(WS,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(DBZ,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      MAXDBZ(:,:)=MAXVAL(DBZ,3)
c      WHERE(MAXDBZ(:,:)<-30.)MAXDBZ(:,:)=0.0
C     IconvertMAXDBZ=MAXDBZ(:,:)
      ITMAX=1
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      WRITE(6,*)'IDIM1,ISTAT = ',ISTAT
      ISTAT=NF90_DEF_DIM(NCID,"level",KMAX,IZDIMID)
      WRITE(6,*)'IDIM2,ISTAT = ',ISTAT
      ISTAT=NF90_DEF_DIM(NCID,"lats",JMAX,IYDIMID)
      WRITE(6,*)'IDIM3,ISTAT = ',ISTAT
      ISTAT=NF90_DEF_DIM(NCID,"lons",IMAX,IXDIMID)
      WRITE(6,*)'IDIM4,ISTAT = ',ISTAT
      IDIMIDS(1)=ITDIMID
      IDIMIDS(2)=IZDIMID
      IDIMIDS(3)=IYDIMID
      IDIMIDS(4)=IXDIMID
      DO K=2,KMAX
         KK=K
c         WRITE(6,*)NINT(Z(K)*1000.)
         WRITE(ULEVELC(K),'("u_",I5.5)')NINT(Z(K)*1000.)
c         WRITE(6,*)'ULEVELC FOR LEVEL ',K,'= ',ULEVELC(K)
         WRITE(VLEVELC(K),'("v_",I5.5)')NINT(Z(K)*1000.)
c         WRITE(6,*)'VLEVELC FOR LEVEL ',K,'= ',VLEVELC(K)
         KK=K
C Setting up 3D UWRITE and VWRITE for later writing of
C 2D u- and v-component wind variables
         CALL U1U21LEVEL(U,UWRITE,KK,IMAX,JMAX,KMAX)
         CALL U1U21LEVEL(V,VWRITE,KK,IMAX,JMAX,KMAX)
C
C Conversion of UWRITE AND VWRITE TO KNOTS WHILE LEAVING U AND V IN M/S
C
         DO J=1,JMAX
            DO I=1,IMAX
               IF(UWRITE(I,J,K).GT.-900.)THEN
                  UWRITE(I,J,K)=UWRITE(I,J,K)*1.94384
                  VWRITE(I,J,K)=VWRITE(I,J,K)*1.94384
               ENDIF
            ENDDO
         ENDDO
C END OF AWIPS INITIAL WIND CONFIGURATION
      ENDDO
      CALL U1U2(U,U2,IMAX,JMAX,KMAX)
      CALL U1U2(V,U2,IMAX,JMAX,KMAX)
      CALL U1U2(W,U2,IMAX,JMAX,KMAX)
      CALL U1U2(RW,U2,IMAX,JMAX,KMAX)
      CALL U1U2(TW,U2,IMAX,JMAX,KMAX)
      CALL U1U2(WS,U2,IMAX,JMAX,KMAX)
      CALL U1U2(DBZ,U2,IMAX,JMAX,KMAX)
C INITIAL AWIPS MAX DBZ CONFIGURATION
      CALL U1U2(MAXDBZ,U2,IMAX,JMAX,1)
C END OF INITIAL CONFIGURATION
      WRITE(6,*)'NCID,IDIMIDS = ',NCID,IDIMIDS
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_FLOAT,ITDIMID,ITVARID)
      READ(FLTNAME,'(3I2)')IYEAR,IMONTH,IDAY
      IF(IYEAR.GT.50.)THEN
       IYEAR=IYEAR+1900
      ELSE
       IYEAR=IYEAR+2000
      ENDIF
      WRITE(WRITECHAR,8777)IYEAR,IMONTH,IDAY
 8777 FORMAT('seconds since ',i4,'-',i2.2,'-',i2.2,' 00:00:00 00:00')
      WRITE(6,8777)IYEAR,IMONTH,IDAY
c      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'UNITS',
c     1'seconds since 2007-09-14 00:00:00 00:00')
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'UNITS',
     1WRITECHAR)
      WRITE(6,*)'FIRST WRITCHAR ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'STANDARD_NAME','time')
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'AXIS',"T")
      ISTAT=NF90_DEF_VAR(NCID,"level",NF90_FLOAT,IZDIMID,IZVARID)
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'UNITS','km')
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'STANDARD_NAME','level')
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'AXIS',"Z")
      ISTAT=NF90_DEF_VAR(NCID,"lats",NF90_FLOAT,IYDIMID,IYVARID)
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'UNITS','degrees-north')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'STANDARD_NAME','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'AXIS',"Y")
      ISTAT=NF90_DEF_VAR(NCID,"lons",NF90_FLOAT,IXDIMID,IXDIMID)
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'UNITS','degrees-east')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'STANDARD_NAME','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'AXIS',"X")
      WRITE(6,*)'IXDIMID,IYDIMID,IZDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,IZDIMID,ITDIMID
      ISTAT=NF90_DEF_VAR(NCID,"includeincomposite",NF90_INT,
     + ITDIMID,INVARID)
      WRITE(6,*)'def_var_includeincomposite, ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,INVARID,'1_OR_0','integer')
      WRITE(6,*)'PUT_ATT includeincomposite, ISTAT = ',ISTAT
      ISTAT=NF90_DEF_VAR(NCID,"U",NF90_FLOAT,IDIMIDS,IUVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IUVARID = ',ISTAT,IDIMIDS,IUVARID
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_DEF_VAR(NCID,"V",NF90_FLOAT,IDIMIDS,IVVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IVVARID = ',ISTAT,IDIMIDS,IVVARID
      ISTAT=NF90_DEF_VAR(NCID,"W",NF90_FLOAT,IDIMIDS,IWVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IWVARID = ',ISTAT,IDIMIDS,IWVARID
      ISTAT=NF90_DEF_VAR(NCID,"REFLECTIVITY",
     1 NF90_FLOAT,IDIMIDS,IDBZVARID)
      ISTAT=NF90_DEF_VAR(NCID,"WIND_SPEED",
     1 NF90_FLOAT,IDIMIDS,IWSVARID)
      ISTAT=NF90_DEF_VAR(NCID,"RADIAL_WIND",
     1 NF90_FLOAT,IDIMIDS,IRWVARID)
      ISTAT=NF90_DEF_VAR(NCID,"TANGENTIAL_WIND",
     1 NF90_FLOAT,IDIMIDS,ITWVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IWSVARID = ',ISTAT,IDIMIDS,IWSVARID
      WRITE(6,*)'ISTAT,IDIMIDS,IRWVARID = ',ISTAT,IDIMIDS,IRWVARID
      WRITE(6,*)'ISTAT,IDIMIDS,ITWVARID = ',ISTAT,IDIMIDS,ITWVARID
      WRITE(6,*)'ISTAT,IDIMIDS,IDBZVARID = ',ISTAT,IDIMIDS,IDBZVARID
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_min',-31)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_max',100)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_max',VALID_MAX)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"KEYWORD",KEYWORD)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLTNAME",FLTNAME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"STMNAME",STMNAME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RADAR",RADAR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXPERIMENT",EXPERIMENT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CREATIME",CREATIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA1",EXTRA1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"KOUNT",KOUNT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"NMOSM",NMOSM)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"IUNFLD",IUNFLD)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"IATTEN",IATTEN)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA2",EXTRA2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA3",EXTRA3)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"START_TIME",STIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"END_TIME",ETIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ORIGIN_LATITUDE",OLAT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ORIGIN_LONGITUDE",OLON)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLAG",FLAG)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "EAST_WEST_RESOLUTION_KM",SX)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "NORTH_SOUTH_RESOLUTION_KM",SY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "VERTICAL_RESOLUTION_KM",SZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "ORIGIN_EAST_WEST_DISTANCE_FROM_LOWER_LEFT_CORNER_KM",XZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "ORIGIN_NORTH_SOUTH_DISTANCE_FROM_LOWER_LEFT_CORNER_KM",YZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "HEIGHT_OF_LOWEST_HORIZONTAL_LEVEL_KM",ZZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ROTATION_IN_DEGREES",ROT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RA",RA)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CO1",CO1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CO2",CO2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"AZMCOR",AZMCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ELCOR",ELCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"THRESH",THRESH)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"POWERT",POWERT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"BIEL",BIEL)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"AZBIEL",AZBIEL)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"STIME2",STIME2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ETIME1",ETIME1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA6",EXTRA6)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA7",EXTRA7)
      ISTAT=NF90_ENDDEF(NCID)
      ICOUNT1(1)=IMAX
      ISTART1(1)=1
      ISTART(1)=1
      ISTART(2)=0
      ISTART(3)=0
      ICOUNT(1)=IMAX
      ICOUNT(2)=0
      ICOUNT(3)=0
c***
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      ICOUNT1(1)=JMAX
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1)
      ICOUNT1(1)=KMAX
      ISTAT=NF90_PUT_VAR(NCID,IZDIMID,Z,ISTART1,ICOUNT1)
      ICOUNT1(1)=1
      IF(ETIME1.GE.STIME.AND.ETIME1.LE.ETIME)THEN
         TT(1)=ETIME1
      ELSE
         TT(1)=FLOAT(INT((STIME+ETIME)/2.))
      ENDIF
      WRITE(6,*)'TT,ETIME1,STIME,ETIME = ',
     1  TT(1),ETIME1,STIME,ETIME
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT,ISTART1,ICOUNT1)
      INC(1)=INCLUDEINCOMPOSITE
      ISTAT=NF90_PUT_VAR(NCID,INVARID,INC,ISTART1,ICOUNT1)
      WRITE(6,*)'PUT_VAR includeincomposite, ISTAT = ',ISTAT
c***
      ICOUNT(1)=1
      ICOUNT(2)=KMAX
      ICOUNT(3)=JMAX
      ICOUNT(4)=IMAX
      ISTART(1)=1
      ISTART(2)=1
      ISTART(3)=1
      ISTART(4)=1
      ISTAT=NF90_PUT_VAR(NCID,IUVARID,U,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IVVARID,V,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IWVARID,W,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IDBZVARID,DBZ,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IWSVARID,WS,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IRWVARID,RW,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,ITWVARID,TW,ISTART,ICOUNT)
      ISTAT=NF90_CLOSE(NCID)
C FIRST TIME WRITENETCDF IS CALLED IS FOR THE EARTH RELATIVE WIND FILE
C BUT SECOND TIME IS FOR THE STORM RELATIVE.  STORM RELATIVE AWIPS FILES
C NOT NEEDED SO RETURN HERE FOR SECOND CALL TO WRITENETCDF
      IF(ICALLTEST.NE.0)RETURN
C Beginning of making AWIPS max radar 2D file
      ISTAT=NF90_CREATE(OUTFILERADAR,NF90_NETCDF4,NCID)
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lats",JMAX,IYDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lons",IMAX,IXDIMID)
      IDIMIDS3(1)=ITDIMID
      IDIMIDS3(2)=IYDIMID
      IDIMIDS3(3)=IXDIMID
      write(*,*)ITDIMID 
      WRITE(6,*)'IXDIMID,IYDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,ITDIMID
      WRITE(6,*)'WRITECHAR = ',WRITECHAR
      test=1507204800
      YEAR=OUTFILNAM(1:2)
      MONTH=OUTFILNAM(3:4)
      DAY=OUTFILNAM(5:6)
      HR=OUTFILNAM(10:11)
      MN=OUTFILNAM(12:13)
      READ(OUTFILNAM,'(9X,I2)')IHR
      READ(OUTFILNAM,'(11X,I2)')IMIN
      SECS=IHR*3600+IMIN*60
      CALL SECS1970(IYEAR,IMONTH,IDAY,SECS,DSECS)
      YYYY="20"//YEAR//"-"//MONTH//"-"//DAY//" "//HR//":"//MN//":00"
      WRITE(6,'("YYYY = ",A19)')YYYY
      WRITE(6,*)'IYEAR,IMONTH,IDAY,IHR,IMIN = ',IYEAR,IMONTH,IDAY,
     & IHR,IMN
      WRITE(6,*)'SECS,DSECS = ',SECS,DSECS
C      PAUSE
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_DOUBLE,ITDIMID,ITVARID)
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'units',
     & "seconds since 1970-01-01 00:00:00")
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'time_origin',YYYY)           
       ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'long_name',"Valid Time")
      ISTAT=NF90_DEF_VAR(NCID,"lats",NF90_DOUBLE,IYDIMID,IYVARID)
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'units','degrees_north')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'standard_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'long_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'_Storage','contiguous')
      ISTAT=NF90_DEF_VAR(NCID,"lons",NF90_DOUBLE,IXDIMID,IXVARID)
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'units','degrees_east')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'Standard_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'long_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'_Storage','contiguous')
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"title","Recon Radar Data") 
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"time_origin",YYYY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"source","TSB testing")
c      DO I=1,IMAX
c      write(*,*)(MAXDBZ(J,I),J=1,JMAX)
c      ENDDO
c      write(*,*) 'shape =', shape(MAXDBZ)
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
c      write(*,*) IDIMIDS3
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
      ISTAT=nf90_def_var(ncid,"MAXREFLECTIVITY", nf90_double,
c SNS - IYDIMID/IXDIMID switched
     &                   (/ IXDIMID, IYDIMID /),IDBZVARID)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'coordinates',"time lats lons")
      WRITE(6,*)'PUTIDBZVARID,ISTAT = ',ISTAT
      ISTAT=NF90_ENDDEF(NCID)
      WRITE(6,*)'ENDDEF,ISTAT = ',ISTAT
      ISTART1(1)=1
      ICOUNT1(1)=IMAX
      ICOUNT1(1)=JMAX
      ICOUNT1(1)=1
      ICOUNT1(1)=JMAX
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1) 
      ICOUNT1(1)=IMAX 
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      IF(ETIME1.GE.STIME.AND.ETIME1.LE.ETIME)THEN
         TT(1)=ETIME1
         TT(1)=1507204800 
      ELSE
         TT(1)=FLOAT(INT((STIME+ETIME)/2.))
         TT(1)=1507204800
      ENDIF
      TT(1)=1507204800
      WRITE(6,*)'TT,ETIME1,STIME,ETIME,ISTART1,ICOUNT1 = ',
     1  TT(1),ETIME1,STIME,ETIME,ISTART1,ICOUNT1
      test=1507204800  
      TT(1)=DSECS
      WRITE(6,*)'AWIPS DBZ TT(1) - ',TT(1)
C      PAUSE
      ICOUNT1(1)=JMAX
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT)
      ICOUNT3(1)=1
      ICOUNT3(2)=JMAX
      ICOUNT3(3)=IMAX
      ISTART3(1)=1
      ISTART3(2)=1
      ISTART3(3)=1
      IconvertMD=MAXDBZ(:,:)
      IconvertMD=transpose(IconvertMD) 
      ISTAT=NF90_PUT_VAR(NCID,IDBZVARID,float(IconvertMD))
      WRITE(6,*)'PUTDBZ,ISTAT = ',ISTAT
      ISTAT=NF90_CLOSE(NCID)
C End of making AWIPS 2D max dBZ file
C Beginning of making wind 2D VARIABLES IN ONE FILE
C      OUTFILERADAR='WindComponents.nc'
      ISTAT=NF90_CREATE(OUTFILEWIND,NF90_NETCDF4,NCID)
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lats",JMAX,IYDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lons",IMAX,IXDIMID)
      IDIMIDS3(1)=ITDIMID
      IDIMIDS3(2)=IYDIMID
      IDIMIDS3(3)=IXDIMID
      write(*,*)ITDIMID 
      WRITE(6,*)'IXDIMID,IYDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,ITDIMID
      WRITE(6,*)'WRITECHAR = ',WRITECHAR
      test=1507204800
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_DOUBLE,ITDIMID,ITVARID)
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'units',"seconds since 1970-01-01
     &00:00:00")
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'time_origin',YYYY)
       ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'long_name',"Valid Time")
      WRITE(6,*)'1 ISTAT = ',ISTAT
      WRITE(6,*)'2 ISTAT = ',ISTAT
      WRITE(6,*)'3 ISTAT = ',ISTAT
      ISTAT=NF90_DEF_VAR(NCID,"lats",NF90_DOUBLE,IYDIMID,IYVARID)
      WRITE(6,*)'4 ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'units','degrees_north')
      WRITE(6,*)'5 ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'standard_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'long_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'_Storage','contiguous')
      WRITE(6,*)'6 ISTAT = ',ISTAT
      WRITE(6,*)'7 ISTAT = ',ISTAT
      ISTAT=NF90_DEF_VAR(NCID,"lons",NF90_DOUBLE,IXDIMID,IXVARID)
      WRITE(6,*)'8 ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'units','degrees_east')
      WRITE(6,*)'9 ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'Standard_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'long_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'_Storage','contiguous')
      WRITE(6,*)'10 ISTAT = ',ISTAT
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"title","Recon Radar Data") 
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"time_origin",YYYY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"source","TSB testing")
      WRITE(6,*)'11 ISTAT = ',ISTAT
c      DO I=1,IMAX
c      write(*,*)(MAXDBZ(J,I),J=1,JMAX)
c      ENDDO
c      write(*,*) 'shape =', shape(MAXDBZ)
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
c      write(*,*) IDIMIDS3
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
      DO K=2,37
         ISTAT=nf90_def_var(ncid,ULEVELC(K), nf90_double,
c SNS - switched IYDIMID/IXDIMID
     &                   (/ IXDIMID, IYDIMID /),IULEVELVARID(K))

         ISTAT=
     &    NF90_PUT_ATT(NCID,IULEVELVARID(K),'valid_range',VALID_RANGE)
         ISTAT=
     &    NF90_PUT_ATT(NCID,IULEVELVARID(K),'UNITS','knots')
         WRITE(LONGNAMEU,
     & '("east-west wind component at ",I6," meters")')
     & NINT(Z(K)*1000.)
         ISTAT=NF90_PUT_ATT(NCID,IULEVELVARID(K),'long_name',longnameu)
C         ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
         ISTAT=NF90_PUT_ATT
     &    (NCID,IULEVELVARID(K),'coordinates',"time lats lons")
         ISTAT=nf90_def_var(ncid,VLEVELC(K), nf90_double,
c SNS - switched IYDIMID/IXDIMID
     &                   (/ IXDIMID, IYDIMID /),IVLEVELVARID(K))
         ISTAT=
     &    NF90_PUT_ATT(NCID,IVLEVELVARID(K),'valid_range',VALID_RANGE)
         ISTAT=
     &    NF90_PUT_ATT(NCID,IVLEVELVARID(K),'UNITS','knots')
         WRITE(LONGNAMEV,
     & '("north-south wind component at ",I6," meters")')
     & NINT(Z(K)*1000.)
         ISTAT=NF90_PUT_ATT(NCID,IVLEVELVARID(K),'long_name',longnamev)
C         ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
         ISTAT=NF90_PUT_ATT
     &    (NCID,IVLEVELVARID(K),'coordinates',"time lats lons")
      ENDDO
C      WRITE(6,*)'PUTIDBZVARID,ISTAT = ',ISTAT
      ISTAT=NF90_ENDDEF(NCID)
      WRITE(6,*)'ENDDEF,ISTAT = ',ISTAT
      ISTART1(1)=1
      ICOUNT1(1)=IMAX
      ICOUNT1(1)=JMAX
      ICOUNT1(1)=1
      ICOUNT1(1)=JMAX
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1) 
      ICOUNT1(1)=IMAX 
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      IF(ETIME1.GE.STIME.AND.ETIME1.LE.ETIME)THEN
         TT(1)=ETIME1
         TT(1)=1507204800 
      ELSE
         TT(1)=FLOAT(INT((STIME+ETIME)/2.))
         TT(1)=1507204800
      ENDIF
      TT(1)=1507204800
      WRITE(6,*)'TT,ETIME1,STIME,ETIME,ISTART1,ICOUNT1 = ',
     1  TT(1),ETIME1,STIME,ETIME,ISTART1,ICOUNT1
      test=1507204800  
      TT(1)=1507204800
      TT(1)=DSECS
      ICOUNT1(1)=JMAX
      WRITE(6,*)'AWIPS WINDS TT(1) - ',TT(1)
C      PAUSE
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT)
      DO K=2,37
         ICOUNT3(1)=1
         ICOUNT3(2)=JMAX
         ICOUNT3(3)=IMAX
         ISTART3(1)=1
         ISTART3(2)=1
         ISTART3(3)=1
C      IconvertMAXDBZ=MAXDBZ(:,:)
         DO I=1,IMAX
c            WRITE(6,*)'K,IULEVELVARID(K) = ',K,IULEVELVARID(K)
c            WRITE(6,*)(UWRITE(I,J,K),J=1,JMAX)
            DO J=1,JMAX

               UWRITE1(I,J)=UWRITE(I,J,K)
               VWRITE1(I,J)=VWRITE(I,J,K)
 
           ENDDO
         ENDDO
c         PAUSE

        where (UWRITE1 .lt. -250 ) UWRITE1 = UWRITE1 * (-0) 
        where (VWRITE1 .lt. -250 ) VWRITE1 = VWRITE1 * (-0)       
 
         UWRITE1=transpose(UWRITE1) 
         VWRITE1=transpose(VWRITE1) 

         ISTAT=NF90_PUT_VAR(NCID,IULEVELVARID(K),UWRITE1)
         ISTAT=NF90_PUT_VAR(NCID,IVLEVELVARID(K),VWRITE1)
      ENDDO
      WRITE(6,*)'PUTDBZ,ISTAT = ',ISTAT
      ISTAT=NF90_CLOSE(NCID)
C End of making AWIPS WIND FILE WITH 2D VARIABLES
      RETURN


      END
      SUBROUTINE U1U2(U,U2,IMAX,JMAX,KMAX)
C THIS ROUTINE CONVERTS FROM FORTRAN VARIABLE-STORAGE HIERACHRY TO
C THE C VARIABLE-STORAGE THAT NETCDF USES
      REAL U(IMAX,JMAX,KMAX),U2(KMAX,JMAX,IMAX)
      DO I=1,IMAX
       DO J=1,JMAX
        DO K=1,KMAX
         U2(K,J,I)=U(I,J,K)
        ENDDO
       ENDDO
      ENDDO
      CALL RESETU1U2(U,U2,IMAX,JMAX,KMAX)
      RETURN
      END
      SUBROUTINE U1U21LEVEL(U,UWRITE,K,IMAX,JMAX,KMAX)
C THIS ROUTINE CONVERTS FROM FORTRAN VARIABLE-STORAGE HIERACHRY TO
C THE C VARIABLE-STORAGE THAT NETCDF USES
      REAL U(IMAX,JMAX,KMAX),UWRITE(JMAX,IMAX,KMAX)
      DO I=1,IMAX
       DO J=1,JMAX
C        DO K=1,KMAX
         UWRITE(J,I,K)=U(I,J,K)
C        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE RESETU1U2(U,U2,IMAX,JMAX,KMAX)
      REAL U(IMAX,JMAX,KMAX),U2(IMAX,JMAX,KMAX)
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U(I,J,K)=U2(I,J,K)
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE REMAP(U,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
C THIS ROUTINE REMAPS DATA THAT ARE MAPPED TO AN EAST-WEST AND NORTH-SOUTH
C DISTANCE FROM STORM CENTER, AND REMAPS TO LATITUDE AND LONGITUDE,
C ACCOUNTING FOR THE COSINE OF LATITUDE WHEN DETERMINING LONGITUDE, 
C AND USING BI-LINEAR INTERPOLATION OF X,Y DATA TO LAT, LON
C
C U COMES INTO ROUTINE AS MAPPED IN THE X-Y DISTANCE GRID
C AND U GOES OUT OF THE ROUTINE MAPPED TO THE LAT LON GRID
C U2 IS THE WORK VARIABLE USED TO REMAP
C
C X IS THE LON GRIDPOINT BASED UPON THE NORTHERNMOST LATITUDE OF THE DATA
C WHERE LONGITUDE RANGE IS THE LARGEST
C X2 IS THE LATITUDE OF THE ACTUAL DATA IN THE X-Y DISTANCE GRID BASED UPON
C THE LATITUDE OF A GIVEN DATUM IN THE X-Y DISTANCE GRID
C Y IS LATITUDE
C
      REAL U(IMAX,JMAX,KMAX),U2(IMAX,JMAX,KMAX),
     1 X(IMAX),X2(1000),Y(JMAX)
      INTEGER A,B
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U2(I,J,K)=-999.9
        ENDDO
       ENDDO
      ENDDO
      DO J=1,JMAX
C DETERMINE THE ACTUAL LONGITUDE OF THE VARIABLES STORED IN HRD-FORMAT
C FOR A GIVEN LATITUDE Y(J)
       DO I=1,IMAX
        X2(I)=(.5+FLOAT(I-1))*SX-XZ
        X2(I)=OLON+X2(I)/(COS(Y(J)*3.14159/180.)*111.111)
c        WRITE(6,*)'I,J,OLON,Y(J),SX,XZ,OLON,X2 = ',
c     1         I,J,OLON,Y(J),SX,XZ,OLON,X2(I)
       ENDDO
C FOR LATITUDE Y(J) REMAP DATA STORED AS A FUNCTION OF EAST-WEST
C DISTANCE INTO DATA STORED AS A FUNCTION OF LONGITUDE
       DO I=1,IMAX
        A=1
        B=2
C X(A) AND X(B) BELOW WILL THE DATA ON EACH SIDE OF THE LONGITUDE GRID
C POINT X2(I) BEING ADDRESSED, WHERE X IS IN THE ORIGINAL DISTANCE GRID
C U IS THE ORIGINALLY MAPPED VARIABLE AND U2 IS THE VARIABLE MAPPED ON TO
C THE NEW LONGITUDE DIMENSION
        DO WHILE(X2(I).GT.X(B))
         A=A+1
         B=B+1
        ENDDO
c        WRITE(6,*)'I,J,A,B,X(A),X(B),X2(I) = ',
c     1   I,J,A,B,X(A),X(B),X2(I)
        IF(X2(I).EQ.X(A).AND.A.LE.IMAX)THEN
c         WRITE(6,*)'A'
         DO K=1,KMAX
          IF(U(A,J,K).GT.-900.)U2(I,J,K)=U(A,J,K)
         ENDDO
        ELSEIF(X2(I).EQ.X(B).AND.B.LE.IMAX)THEN
c         WRITE(6,*)'B'
         DO K=1,KMAX
          IF(U(B,J,K).GT.-900.)U2(I,J,K)=U(B,J,K)
         ENDDO
        ELSE
c         WRITE(6,*)'C'
         DO K=1,KMAX
C BI-LINEAR INTERPOLATION OF U TO U2
          IF(U(A,J,K).GT.-900..AND.U(B,J,K).GT.-900.)
     1    U2(I,J,K)=((X2(I)-X(A))*U(B,J,K)+(X(B)-X2(I))*U(A,J,K))
     1          /(X(B)-X(A))
         ENDDO
        ENDIF
       ENDDO 
      ENDDO
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U(I,J,K)=U2(I,J,K)
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE SECS1970(IYEAR,IMONTH,IDAY,SECS,DSECS)
      DOUBLE PRECISION SECS,DSECS
c      WRITE(6,*)'IYEAR,IMONTH,IDAY = ',IYEAR,IMONTH,IDAY
      IJULIAN=JULIAN_DATE(IYEAR,IMONTH,IDAY)
C      WRITE(6,*)'JULIAN DAY = ',IJULIAN
      IY=1970
      IM=1
      ID=1
      IJDAY1=JULIAN_DATE(IY,IM,ID)
      IJDAY2=JULIAN_DATE(IYEAR,IMONTH,IDAY)
      IJDAY3=IJDAY2-IJDAY1
c      WRITE(6,*)'IJDAY1,IJDAY2,IJDAY3 = ',IJDAY1,IJDAY2,IJDAY3
      DSECS=DFLOAT(IJDAY3)*8.64D+04+SECS
      RETURN
      END
      FUNCTION JULIAN_DATE(YYYY,MM,DD)
      INTEGER YYYY,MM,DD
      JULIAN_DATE = dd-32075+1461*(yyyy+4800+(mm-14)/12)/4 + 
     1 367*(mm-2-((mm-14)/12)*12)/12- 
     1 3*((yyyy + 4900 + (mm - 14)/12)/100)/4
      RETURN
      END
