	subroutine get_nyq_vel(prf_mode,prf, wavelength,vel_nyq)
C return wquivalent unambiguous Doppler velocity
C based on the prf (hz), wavelength(m), and dual Doppler modes.
C the PRF passed in the higher of the two if
C dual Doppler mlde > 0. Modes flags are as 
C described in IRIS reference in the rask_dsp_info
c structure
	integer*4 prf
	integer*2 prf_mode
	real wave_length, vel_nyq
C
C vel_nyq = t_misc.wavelength * 0.0001 * t_dsp.prf * 0.25
	vel_nyq = wavelength * prf * 0.25


C
	if(prf_mode .eq. 0 ) then
C 1_1 mode, we are done
		return
	else if( prf_mode .eq. 1 ) then
C 2:3 mode
		vel_nyq = 2.0 * vel_nyq
	else if( prf_mode .eq. 2 ) then
C 3"4 mode
		vel_nyq = 3.0 * vel_nyq
	else if( prf_mode .eq. 3 ) then
C 4:5 mode
		vel_nyq = 4.0 * vel_nyq
	end if
	return
	end
