C "portable" version for GNU Fortran, which does not
C support the structure and record data type. Had to
C replace with type declarations,. Ugliest of all
C had to replace str.var with str%var. 30 March 2010 p sosge

	subroutine read_task_hdr(lu, tsk_si, tsk_dsp, tsk_cal,
     +		tsk_range, tsk_scan, tsk_misc, tsk_end, 
     +		tsk_rhi)
c update HRD common blocks with dara from Sigmer IRIS
C dara structures in the Task blocks of the second IRIS record.

	include "iris_f90_structures.h"

	type (task_sched_info) tsk_si
	type (task_dsp_info) tsk_dsp
	type (task_calib_info) tsk_cal
	type (task_range_info)  tsk_range
	type (task_scan_info) tsk_scan
	type (task_misc_info) tsk_misc
	type (task_end_info) tsk_end
C should only need one of these. Probably rhi,,,to vonform with
C the way Sigmet thinks about this...
	type (task_rhi_scan_info) tsk_rhi
C	type (task_ppi_scan_info) tsk_ppi
C	type (task_file_scan_info) tsk_file_scan
C	type (task_manual_scan_info) tsk_manual_scan


	include "hrd_radar_common_blocks.f"
C


C structure / task_sched_info / tsk_si
C COMMENTED OUT to use swee igest time instead... for now ...
cout	time =	tsk_si%start_sec 
C this should ve updated after last ray read:
C
C structure / task_dsp_info / tsk_dsp	
	prf_highta = tsk_dsp%prf
Check this out	tsk_dsp%prf_mode = 0 ! 1:1
	nsampleta = tsk_dsp%sample_size

C
C structure / task_calib_info / tsk_cal
	refslopeta = tsk_cal%refl_slope
	refnoisethresta = tsk_cal%refl_noise_thresh / 16.0
	widththresta = tsk_cal%sqi_threshold

	calibta = tsk_cal%cal_refl / 16.0 ! dB x 16

C structure / task_range_info / tsk_range
	if(tsk_range%num_output_bins.le.max_hrd_dim)then
	 do i = 1, tsk_range%num_output_bins
	   radiita(i) = tsk_range%first_bin_range +
     +	  (i-1) * tsk_range%output_step
C conver from cm to km
	   radiita(i) = rdelcorta + (radiita(i) * 0.00001)
	 end do
C mark rest as bad so old find groind dois not choke
	 do i = tsk_range%num_output_bins + 1, max_hrd_dim
	   radiita(i) = -999.0
	 end do
	else
c only fill array
	 do i = 1, max_hrd_dim
	   radiita(i) = tsk_range%first_bin_range +
     +	  (i-1) * tsk_range%output_step
C conver from cm to km
	   radiita(i) = rdelcorta + (radiita(i) * 0.00001)
	 end do
	end if
C I am assuming fixed bin length for the flag setting
C
C structure / task_scan_info / tsk_scan
C I set scan mide to 2 = RHI because that is what rv08 will set on giv.
C mode 4 is continuous PPI
C	tsk_scan%antenna_scan_mode = 2
C	tsk_scan%num_sweeps = 1
C /* The following 200 bytes can hold a variety of structures:
C  * task_rhi_scan_info, task_ppi_scan_info, task_file_scan, or
C  * task_manual_scan_info:
C  */
C
C structure / task_misc_info / tsk_misc
C	tsk_misc%wavelength = 322 ! cm x 100


C structure / task_end_info / tsk_end

C
C /* Well, the damn task_scan_info can hold one of the following:
C * task_rhi_scan_info, task_ppi_scan_info, task_file_scan_info, or
C * task_manual_scan_info. So I guess I need those also, because I don't
C * know if I am going to get PPI's, RHI's....
C */
C
C structure / task_rhi_scan_info / tsk_rhi
C the next three must ve updated after reading in a sweep from tape
C
c  structure dumping starts here *******************************************

	if( lu .gt. 0 ) then
	  write(lu, *) " Task structures:  ===================="
C	structure / task_sched_info /
	write(lu, *)
     +	' Task Schedule Info:'
	write(lu,*)
     +	  "tsk_si%start_sec",tsk_si%start_sec
	 write(lu,*)
     +	  "tsk_si%stop_sec",tsk_si%stop_sec
	 write(lu,*)
     +	  "tsk_si%skip_sec",tsk_si%skip_sec
	 write(lu,*)
     +	  "tsk_si%last_run_time_sec",tsk_si%last_run_time_sec
	 write(lu,*)
     +	  "tsk_si%last_time_used",tsk_si%last_time_used
	 write(lu,*)
     +	  "tsk_si%last_run_day",tsk_si%last_run_day
	 write(lu,*)
     +	  "tsk_si%flag",tsk_si%flag
	 write(lu,*)
     +	  "tsk_si%spare(47)",tsk_si%spare(47)
 
C
C  structure / task_dsp_info /
	write(lu, *)' Task DSP Info: '
	 write(lu,*)
     +	  "tsk_dsp%major_mode",tsk_dsp%major_mode
	 write(lu,*)
     +	  "tsk_dsp%dsp_type",tsk_dsp%dsp_type
	 write(lu,*)
     +	  "tsk_dsp%data_type_mask(6) ",tsk_dsp%data_type_mask(6) 
	 write(lu,*)
     +	  "tsk_dsp%aux_data_def(27)",tsk_dsp%aux_data_def(27)
	 write(lu,*)
     +	  "tsk_dsp%prf",tsk_dsp%prf
	 write(lu,*)
     +	  "tsk_dsp%pulse_width",tsk_dsp%pulse_width
	 write(lu,*)
     +	  "tsk_dsp%prf_mode",tsk_dsp%prf_mode
	 write(lu,*)
     +	  "tsk_dsp%dual_prf_delay",tsk_dsp%dual_prf_delay
	 write(lu,*)
     +	  "tsk_dsp%agc_feedback_code",tsk_dsp%agc_feedback_code
	 write(lu,*)
     +	  "tsk_dsp%sample_size",tsk_dsp%sample_size
	 write(lu,*)
     +	  "tsk_dsp%gain_control_flag",tsk_dsp%gain_control_flag
	 write(lu, *)
     +		"tsk_dsp%clutter_filter_file ",
     +		tsk_dsp%clutter_filter_file
	write(lu, *)
     +	   "tsk_dsp%lin_filter_num ",tsk_dsp%lin_filter_num

	write(lu, *)
     +	 "tsk_dsp%log_filter_num ",tsk_dsp%log_filter_num

	 write(lu,*)
     +	  "tsk_dsp%attenuation",tsk_dsp%attenuation
	 write(lu,*)
     +	  "tsk_dsp%gas_attenuation",tsk_dsp%gas_attenuation
	 write(lu,*)
     +	  "tsk_dsp%clutter_flag",tsk_dsp%clutter_flag
	 write(lu,*)
     +	  "tsk_dsp%xmt_phase_seq",tsk_dsp%xmt_phase_seq
C /* this last spare probably contains the name of the custom extended 
C  * headet in a 16 character ASCII string. 5 Feb 2008
C  */
	 write(lu,*)
     +	  "tsk_dsp%spare2(72)",tsk_dsp%spare2(72)
 
C
C 	structure / task_calib_info /
	write(lu,*)' Task Calibration Info: '
	 write(lu,*)
     +	  "tsk_cal%refl_slope",tsk_cal%refl_slope
	 write(lu,*)
     +	  "tsk_cal%refl_noise_thresh",tsk_cal%refl_noise_thresh
	 write(lu,*)
     +	  "tsk_cal%clutter_corr_thresh",tsk_cal%clutter_corr_thresh
	 write(lu,*)
     +	  "tsk_cal%sqi_threshold",tsk_cal%sqi_threshold
	 write(lu,*)
     +	  "tsk_cal%pwr_trhreshold",tsk_cal%pwr_trhreshold
	 write(lu,*)
     +	  "tsk_cal%spare(4)",tsk_cal%spare(4)
	 write(lu,*)
     +	  "tsk_cal%cal_refl",tsk_cal%cal_refl
	 write(lu,*)
     +	  "tsk_cal%uncor_refl_thresh",tsk_cal%uncor_refl_thresh
	 write(lu,*)
     +	  "tsk_cal%cor_refl_thresh",tsk_cal%cor_refl_thresh
	 write(lu,*)
     +	  "tsk_cal%vel_thresh",tsk_cal%vel_thresh
	 write(lu,*)
     +	  "tsk_cal%width_thresh",tsk_cal%width_thresh
	 write(lu,*)
     +	  "tsk_cal%zdr_thresh",tsk_cal%zdr_thresh
	 write(lu,*)
     +	  "tsk_cal%spare2(3)",tsk_cal%spare2(3)
	 write(lu,*)
     +	  "tsk_cal%flags",tsk_cal%flags
C bit 9 mauks whether platform vel removed of not
	if(iand(tsk_cal%flags, 512) .eq. 512) then
	   write(lu,*)"Warning! platform vel removed!"
	end if
	 write(lu,*)
     +	  "tsk_cal%spare3(2)",tsk_cal%spare3(2)
	 write(lu,*)
     +	  "tsk_cal%zdr_bias",tsk_cal%zdr_bias
	 write(lu,*)
     +	  "tsk_cal%spare4(138)",tsk_cal%spare4(138)
C
C
C	structure / task_range_info /
	write(lu,*)
     +	  ' Rask Range Info: '
	 write(lu,*)
     +	  "tsk_range%first_bin_range",tsk_range%first_bin_range
	 write(lu,*)
     +	  "tsk_range%last_bin_range",tsk_range%last_bin_range
	 write(lu,*)
     +	  "tsk_range%num_input_bins",tsk_range%num_input_bins
	 write(lu,*)
     +	  "tsk_range%num_output_bins",
     +		tsk_range%num_output_bins
	 write(lu,*)
     +	  "tsk_range%input_step",tsk_range%input_step
	 write(lu,*)
     +	  "tsk_range%output_step",tsk_range%output_step
	 write(lu,*)
     +	  "tsk_range%flag",tsk_range%flag
	 write(lu,*)
     +	  "tsk_range%rng_avg_flag",tsk_range%rng_avg_flag
	 write(lu,*)
     +	  "tsk_range%spare(68)",tsk_range%spare(68)
C 
C
C	structure / task_scan_info /
	write(lu,*)
     +	  ' Task Scan Info: '

	write(lu,*)
     +	  "tsk_scan%antenna_scan_mode",tsk_scan%antenna_scan_mode
	 write(lu,*)
     +	  "tsk_scan%ang_resolution",tsk_scan%ang_resolution
	 write(lu,*)
     +	  "tsk_scan%spare",tsk_scan%spare
	 write(lu,*)
     +	  "tsk_scan%num_sweeps",tsk_scan%num_sweeps
C /* The following 200 bytes can hold a variety of structures:
C  * task_rhi_scan_info, task_ppi_scan_info, task_file_scan, or
C  * task_manual_scan_info:
C  */
	 write(lu,*)
     +	  "tsk_scan%scan_info(100)",tsk_scan%scan_info(100)
	 write(lu,*)
     +	  "tsk_scan%spare2(56)",tsk_scan%spare2(56)
C
C
C	structure / task_misc_info /
	write(lu, *)
     +	  ' Task Misc Info: '
	 write(lu,*)
     +	  "tsk_misc%wavelength",tsk_misc%wavelength
	write(lu, *)
     +	   "tsk_misc%tr_ser_number ",tsk_misc%tr_ser_number
	 write(lu,*)
     +	  "tsk_misc%trans_power",tsk_misc%trans_power
	 write(lu,*)
     +	  "tsk_misc%flags",tsk_misc%flags
	 write(lu,*)
     +	  "tsk_misc%polarization_type",tsk_misc%polarization_type
	 write(lu,*)
     +	  "tsk_misc%trunc_height",tsk_misc%trunc_height
	 write(lu,*)
     +	  "tsk_misc%spare_pol_spec(9)",tsk_misc%spare_pol_spec(9)
	 write(lu,*)
     +	  "tsk_misc%spare(6)",tsk_misc%spare(6)
	 write(lu,*)
     +	  "tsk_misc%n_bytes_comments",tsk_misc%n_bytes_comments
	 write(lu,*)
     +	  "tsk_misc%horiz_beamwidth",tsk_misc%horiz_beamwidth
	 write(lu,*)
     +	  "tsk_misc%vert_beamwidth",tsk_misc%vert_beamwidth
	do i = 1, 10
	     write(lu,*)
     +	  "tsk_misc%customer_defined(i)",
     +		i, tsk_misc%customer_defined(i)
	end do
	 write(lu,*)
     +	  "tsk_misc%spare2(104)",tsk_misc%spare2(104)
C
C
C structure / task_end_info /
	write(lu, *)
     +	  ' Task End Info: '
	 write(lu,*)
     +	  "tsk_end%task_major_num",tsk_end%task_major_num
	 write(lu,*)
     +	  "tsk_end%task_minor_num",tsk_end%task_minor_num
	write(lu, *)
     +	  "tsk_end%task_config_file ",tsk_end%task_config_file
	write(lu, *)
     +	   "tsk_end% task_description ",tsk_end% task_description
	 write(lu,*)
     +	  "tsk_end%num_tasks",tsk_end%num_tasks
	 write(lu,*)
     +	  "tsk_end%task_state",tsk_end%task_state
	 write(lu,*)
     +	  "tsk_end%spare",tsk_end%spare
cout		record /ymds_time/ data_time
	 write(lu,*)
     +	  "tsk_end%spare2(102)",tsk_end%spare2(102)
C
C
C	structure / task_rhi_scan_info /
	write(lu,*)
     +	  ' Task RHI Info: '
	 write(lu,*)
     +	  "tsk_rhi%el_start_angle",tsk_rhi%el_start_angle
	 write(lu,*)
     +	  "tsk_rhi%el_end_angle",tsk_rhi%el_end_angle
	 write(lu,*)
     +	  "tsk_rhi%az_scan_angles(40)",tsk_rhi%az_scan_angles(40)
	 write(lu,*)
     +	  "tsk_rhi%spare(58)",tsk_rhi%spare(58)
C
C
C structure / task_ppi_scan_info /
C	write(lu,*)
C     +	  ' Task PPI Info: '
C	 write(lu,*)
C    +	  "tsk_ppi%az_start_angle",tsk_ppi%az_start_angle
c	 write(lu,*)
C    +	  "tsk_ppi%az_end_angle",tsk_ppi%az_end_angle
c	 write(lu,*)
C    +	  "tsk_ppi%el_scan_angles(40)		",tsk_ppi%el_scan_angles(40)		
c	 write(lu,*)
C    +	  "tsk_ppi%spare(58)",tsk_ppi%spare(58)



	end if
	return
	end 
